-- Crawla Commander
/*
	HP > 50%
		Hovers near the player and tries to stay at a distance.
		Then it lunges sideways in an arc and lunges towards the player to attack
	
	HP < 50%
		Charges more aggressively.
		If the player is away, jumps in the air and deals an AOE attack as it stomps downwards
		
		
	HARD MODE: Starts in phase 2, jumps after lunging too
*/

PSO.info.enemies[MT_CRAWLACOMMANDER] = {
		
		name = "Crawla Commander",
		sprite = SPR_CCOM,
		frame = A,
		painframe = A,
		
		bhp = 500,
		satk = 35,
		ratk = 30,
		tatk = 20,
		def = 25,
		exp = 40,
		weight = 4,
		
		
		drops = {
			-- Lv1-10
			{"calibur", 1, 9, 2, 50},
			{"burst", 1, 9, 2, 50},
			{"cane", 1, 9, 2, 50},		
			
			{"doublesaber", 1, 9, 8, 50},
			{"shotgun", 1, 9, 8, 50},
			
			{"gigush", 1, 9, 2, 50},
			{"beam", 1, 9, 2, 50},
			{"baton", 1, 9, 2, 50},	
			
			{"unit_satk_1", 1, 9, 2, 50},
			{"unit_ratk_1", 1, 9, 2, 50},
			{"unit_tatk_1", 1, 9, 2, 50},

			-- Lv30-50
			{"vita pine", 30, 50, 2, 50},
			{"vita shooter", 30, 50, 2, 50},
			{"vita crest", 30, 50, 2, 50},		
			
			{"command shot", 30, 50, 1, 100},
			
			{"unit_power_2", 30, 50, 2, 50},
			{"unit_rainbow_1", 30, 50, 2, 50},
			{"unit_hppp_2", 30, 50, 2, 50},
			
			--Lv10-29 units
			{"unit_pp_2", 10, 29, 5, 50},
			{"unit_hp_2", 10, 29, 5, 50},
			{"unit_satk_2", 10, 29, 5, 50},
			{"unit_ratk_2", 10, 29, 5, 50},
			{"unit_tatk_2", 10, 29, 5, 50},			
			
			{1000, nil, nil, 1, 5},
			{"dimate", nil, nil, 1, 5},
		},
		
		weakness = ELEM_ICE,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.flags = $|MF_NOGRAVITY|MF_SOLID
				mo.momz = 0
			end
		end,
		
		damage = function(mo)
			
			if mo.pso.hp < mo.pso.maxhp/2
			and not mo.phase2
			and PSO.lib.questDifficulty() < DIFF_HARD	-- doesn't happen in hard
				
				mo.flags = $|MF_SOLID
				
				mo.pso.invincible = true
				mo.phase2 = true
				mo.phase2start = 1	-- timers
				
				P_InstaThrust(mo, mo.angle, - FRACUNIT*3)
				mo.momz = FRACUNIT*16
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			
			local targetz = mo.floorz +FRACUNIT*16
			local rate = mo.scale*8/10
			local attack_potency = 300
			
			local missile_time = TICRATE*3
			local melee_time = TICRATE*3
			
			local melee_dist = FRACUNIT*512
			local charge_visual_speed = 10
			
			local speed_closein = FRACUNIT*10
			
			local missile_potency = 300
			
			local melee_potency = 350
			local melee_circle_speed = ANG1*6
			local melee_circle_time = TICRATE/2
			local melee_charge_wait = TICRATE*3/4
			local melee_charge_speed = FRACUNIT*30
			local melee_charge_time = TICRATE*2
			
			local leap_potency = 400
			local leap_time = TICRATE*2
			
			mo.scale = FRACUNIT*2
			PSO.lib.enemyManageAggro(mo)
			
			mo.flags = $ & ~(MF_FLOAT|MF_NOGRAVITY)
			
			-- phase 2 start:
			if mo.phase2start
				
				mo.sprite = SPR_CCOM
				mo.frame = C
				if leveltime & 1
					mo.flags2 = $|MF2_DONTDRAW
				else
					mo.flags2 = $ & ~MF2_DONTDRAW
				end
				
				if not P_IsObjectOnGround(mo)
					mo.rollangle = $+ANG1*16
				else
					mo.rollangle = 0
					mo.phase2start = $+1
					
					if mo.phase2start == TICRATE*3/4
						
						if mo.target and mo.target.valid
							mo.doleap = 1
						end
						mo.flags2 = $ & ~MF2_DONTDRAW
						mo.phase2start = nil
						mo.pso.invincible = nil
					end
				end
				return
			end
			
			if mo.doleap
				
				-- set target
				if mo.doleap == 1
					
					-- reset those values
					mo.melee_attack = 0
					mo.meleetime = melee_time*3/2
					mo.missiletime = missile_time*3/2
					
					-- leap towards target and knock everyone around back
					for p in players.iterate 
						if p and p.mo and p.mo.valid
						and R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y) < 320*p.mo.scale
							
							local ang = R_PointToAngle2(mo.x, mo.y, p.mo.x, p.mo.y)
							local dist = R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y)
							-- magic numbers but they work for now and there's no need to change that...
							P_InstaThrust(p.mo, ang, 20*p.mo.scale - (dist/17))
						end
					end

					for i = 1, 8
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
						dust.angle = (360/8)*i
						P_InstaThrust(dust, dust.angle, FRACUNIT*24)
					end
					
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					local ldist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
					
					P_InstaThrust(mo, mo.angle, ldist / (leap_time*3/4))
					mo.momz = FRACUNIT*32
					
					mo.leaptarg = {mo.target.x, mo.target.y}
					mo.doleap = 2
					
					S_StartSound(mo, sfx_beflap)
				
				-- reach target
				elseif mo.doleap == 2
					
					if leveltime & 1
						P_SpawnGhostMobj(mo)
					end
					
					mo.momz = max(0, $)
					
					if R_PointToDist2(mo.x, mo.y, mo.leaptarg[1], mo.leaptarg[2]) < (FixedHypot(mo.momx, mo.momy)*8)
						mo.doleap = 3
						P_InstaThrust(mo, 0, 0)
					end
				
				-- SLAM!!!
				elseif mo.doleap == 3
					
					mo.momz = -32*FRACUNIT
					
					if P_IsObjectOnGround(mo)
						local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*4, 320<<FRACBITS, 40<<FRACBITS, mo, leap_potency, DMT_STRIKE, 8, RT_BLOWDOWN)
						hb.pso.reactionradialangle = true
						hb.pso.reactionstrength = 14
						
						for i = 1, 8
							local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							dust.angle = (360/8)*i*ANG1
							P_InstaThrust(dust, dust.angle, FRACUNIT*20)
						end
						
						S_StartSound(mo, sfx_pstop)
						
						mo.doleap = nil
					end
				end
				return
			end
			
			if mo.z < targetz
				mo.momz = $ + rate
			elseif mo.momz < 0
				mo.momz = min(-mo.scale, $ + rate*2)
			end
			
			if mo.target and mo.target.valid
				-- do different actions depending on how far the player is
				local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
				
				local movespeed = (dist - melee_dist*3/4) / 96
				if movespeed < 0	-- make it faster when backpedalling
					movespeed = $*2
				end
				-- calculate movespeed based on distance to player
				-- clamp it between the target speeds
				movespeed = min($, speed_closein)
				movespeed = max($, -speed_closein)
									
				-- charge visuals
				
				-- performing melee attack, don't cancel
				if mo.melee_attack
				and mo.melee_data
					
					mo.melee_attack = $+1
					
					if mo.melee_attack < melee_circle_time
					
						local tx = mo.melee_data[1] + FixedMul(mo.melee_data[3], cos(mo.melee_data[4]))
						local ty = mo.melee_data[2] + FixedMul(mo.melee_data[3], sin(mo.melee_data[4]))
						
						P_InstaThrust(mo, 0, 0)	-- technically we aren't moving via momentum
						if leveltime & 1
							P_SpawnGhostMobj(mo)
						end
						
						-- check what's on positions tx/ty with a blockmap check...
						-- 02/07: 

						
						
						if not P_TryMove(mo, tx, ty, true)
						or blocked
							mo.melee_data[5] = $ *-1
						else
							P_MoveOrigin(mo, tx, ty, mo.z)
						end
						
						mo.melee_data[4] = $ + (melee_circle_speed * mo.melee_data[5])
						
						if mo.melee_data[3] < (melee_dist)
							mo.melee_data[3] = min(melee_dist, $ + FRACUNIT*16)
						elseif mo.melee_data[3] > (melee_dist)
							mo.melee_data[3] = max(melee_dist, $ - FRACUNIT*16)
						end
						
						mo.angle = mo.melee_data[4] + ANG1*180
					
					elseif mo.melee_attack == melee_circle_time + melee_charge_wait
						local ang = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
						P_InstaThrust(mo, ang, melee_charge_speed)
						mo.angle = ang
						mo.flags = $ & ~MF_SOLID

						local hx = mo.x + 96*cos(mo.angle)
						local hy = mo.y + 96*sin(mo.angle)

						local hb = PSO.lib.spawnHurtBox(hx, hy, mo.z, 50<<FRACBITS, 40<<FRACBITS, mo, melee_potency, DMT_STRIKE, melee_charge_time, RT_BLOWDOWN)
						mo.hitbox = hb
						hb.angle = mo.angle
						hb.pso.reactionstrength = 10						
						
					elseif mo.melee_attack > melee_circle_time + melee_charge_wait
						if leveltime & 1
							P_SpawnGhostMobj(mo)
						end

						local hx = mo.x + 64*cos(mo.angle)
						local hy = mo.y + 64*sin(mo.angle)

						if mo.hitbox and mo.hitbox.valid
							P_MoveOrigin(mo.hitbox, hx, hy, mo.z)
						end
						
						if mo.melee_attack > melee_circle_time + melee_charge_wait + (melee_charge_time/2)
							mo.momx = $*7/10
							mo.momy = $*7/10
						end
						
						if PSO.lib.enemyMovementInvalid(mo)
							P_InstaThrust(mo, mo.angle, -FRACUNIT*3)
							mo.momz = FRACUNIT*6
						end
						
						-- end the attack					
						if FixedHypot(mo.momx, mo.momy) < FRACUNIT*4
							mo.melee_attack = nil
							mo.meleetime = melee_time*2	-- DELAY IT.
							if mo.hitbox
								if mo.hitbox.valid
									P_RemoveMobj(mo.hitbox)
								end
								mo.hitbox = nil
							end
							
							mo.flags = $ | MF_SOLID
							
							if diff >= DIFF_HARD
								mo.doleap = 1
							end
						end
					end
					
				elseif dist > melee_dist
				or mo.missiletime and mo.missiletime < (missile_time/2)	-- let him finish charging
				
					if mo.meleetime
						mo.meleetime = max($, melee_time)
					end
					
					mo.missiletime = $ or missile_time
					mo.missiletime = $-1
					
					if mo.missiletime < missile_time/2
							
						movespeed = $/2
							
						local t = P_SpawnMobj(mo.x + P_RandomRange(-128, 128)*mo.scale, mo.y + P_RandomRange(-128, 128)*mo.scale, mo.z + P_RandomRange(-128, 128)*mo.scale, MT_THOK)
						t.tics = charge_visual_speed
						t.color = SKINCOLOR_RED
						t.frame = A|FF_ADD
						t.scale = mo.scale
						t.destscale = 1
						t.scalespeed = mo.scale/12
							
						t.momx = (mo.x - t.x)/charge_visual_speed
						t.momy = (mo.y - t.y)/charge_visual_speed
						t.momz = (mo.z - t.z)/charge_visual_speed					
					end
					if not mo.missiletime
						local msl = PSO.lib.spawnMissile(mo, MT_PSO_RIFLESHOT, mo.angle, 20*FRACUNIT, missile_potency, DMT_RANGED, 0, 0, 0, RT_KNOCKBACK)
						PSO.lib.aimMissile(msl, mo.target)
							
						msl.color = SKINCOLOR_RED
						msl.extravalue1 = 1
						msl.extravalue2 = 1
						msl.cusval = 1
							
						mo.missiletime = missile_time*3/2
						
						if mo.phase2 or diff >= DIFF_HARD
							mo.doleap = 1
						end
					end
				else	-- in melee range, wait until we strike
				
					if mo.missiletime
						mo.missiletime = max($, missile_time)	-- reset missile if in melee range
					end
					
					mo.meleetime = $ or melee_time
					mo.meleetime = $-1
					
					if not mo.meleetime
						-- keep in track where we're going
						-- {x, y, distance, angle, whether we rotate clockwise or counterclockwise
						local ang = R_PointToAngle2(mo.target.x, mo.target.y, mo.x, mo.y)
						mo.melee_data = {mo.target.x, mo.target.y, dist, ang, (P_RandomRange(0, 1) and -1 or 1)}
						mo.melee_attack = 1
					end
				end
				
				if not mo.melee_attack
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					P_InstaThrust(mo, mo.angle, movespeed)	
				end
			end
			
			mo.sprite = SPR_CCOM
			mo.frame = (leveltime%4 /2) + (mo.phase2 and C or 0)
		end,
}