-- Minus
/*
	Stationary, after a while, dig and resurface at target's location.
	If player close enough when initiating a dig, try to dig ontop of them
*/

PSO.info.enemies[MT_MINUS] = {
		
		name = "Minus",
		sprite = SPR_MNUS,
		frame = A,
		painframe = A,
		
		bhp = 150,
		satk = 35,
		ratk = 20,
		tatk = 20,
		def = 20,
		exp = 8,
		weight = 1,
		
		
		drops = {
			-- Lv 1-10
			{100, 1, 9, 1, 15},				-- meseta (100% mult) 2/5 (Lv1-10)
			{"sword", 1, 9, 1, 100},		-- sword: 	1/100 (Lv1-10)
			{"rifle", 1, 9, 1, 100},		-- rifle: 	1/100 (Lv1-10)
			{"rod", 1, 9, 1, 100},			-- rod: 	1/100 (Lv1-10)
			{"cane", 1, 9, 1, 50},
			
			{"monomate", 1, 9, 1, 25},	-- monomate: 1/5 (Lv1-10)
			
			-- Lv10-19
			
			{200, 10, 19, 1, 15},
			{"gigush", 10, 19, 1, 100},
			{"beam", 10, 19, 1, 100},
			{"cane", 10, 19, 1, 100},
			{"monomate", 10, 19, 1, 25},
			{"ulrod", 10, 19, 1, 50},

			-- Lv20-29
			{300, 20, 29, 1, 15},
			{"breaker", 20, 29, 1, 150},
			{"doublegladius", 20, 29, 1, 150},
			{"laser", 20, 29, 1, 150},
			{"canon", 20, 29, 1, 150},
			{"ulrod", 20, 29, 1, 150},
			{"crescent", 20, 29, 1, 50},
			{"dimate", 20, 29, 1, 25},

			{650, 30, 50, 1, 15},
			{"doubliss", 30, 50, 1, 50},
			{"alva doubliss", 30, 50, 1, 75},
			{"vita doubliss", 30, 50, 1, 100},
			{"double driller", 30, 50, 1, 250},
			{"rostig frame", 30, 50, 1, 30},
			{"fehler frame", 30, 50, 1, 100},			
			{"dimate", 30, 50, 1, 35},	
			{"trimate", 30, 50, 1, 35},	
		},
		
		stagger_duration = TICRATE/2,
		
		weakness = ELEM_FIRE,
		
		reset =	function(mo)
			if not mo.pso.blowdown
				mo.flags = $|MF_NOGRAVITY
				mo.momz = 0
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			local attack_potency = 400
			local targetz = mo.floorz + mo.scale*8
			local rate = FRACUNIT*8/10
			local attack_wait = TICRATE*4
			local dig_timer = TICRATE
			
			PSO.lib.enemyManageAggro(mo)
			
			mo.rollangle = 0
			
			if mo.leaping
			and mo.target and mo.target.valid
			and mo.leaptarget and mo.leaptarget.valid
				
				mo.sprite = SPR_MNUS
				mo.frame = leveltime%8 /2	
				
				if mo.leaping == 1

					if leveltime & 1
						P_SpawnGhostMobj(mo)
					end
				
					if mo.momz < 0
						
						local dist = R_PointToDist2(mo.x, mo.y, mo.leaptarget.x, mo.leaptarget.y)
						mo.momz = 0
						
						if dist < 48*mo.scale
							mo.leaping = 2
							mo.flags = $|MF_NOCLIPTHING|MF_NOBLOCKMAP
							mo.momx = 0
							mo.momy = 0
						end
					end
				elseif mo.leaping == 2

					if leveltime & 1
						P_SpawnGhostMobj(mo)
					end

					mo.rollangle = ANG1*180
					mo.momz = $ + P_GetMobjGravity(mo)
					
					if P_IsObjectOnGround(mo)
						
						mo.leaping = 3
						mo.digtimer = dig_timer
						
						
						local dig = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
						dig.sprite = SPR_MNUD
						dig.frame = F
						dig.destscale = 1
						dig.tics = TICRATE/3
						
						for i = 1, 8
							local rock = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
							rock.state = S_ROCKCRUMBLEA
							rock.fuse = TICRATE/2
							rock.flags = $ & ~MF_NOGRAVITY
							rock.momz = P_RandomRange(4, 12)*FRACUNIT
							rock.momx = P_RandomRange(-8, 8)*FRACUNIT
							rock.momy = P_RandomRange(-8, 8)*FRACUNIT
							rock.scale = FRACUNIT/4
						end
						
						local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - FRACUNIT*4, 128<<FRACBITS, 40<<FRACBITS, mo, attack_potency, DMT_STRIKE, 8, RT_BLOWDOWN)
						hb.pso.reactionradialangle = true
						
						S_StartSound(mo, sfx_s3k82)
					end
				
				
				elseif mo.leaping == 3
					mo.sprite = SPR_NULL
					mo.frame = A	-- be invisible
					
					mo.digtimer = $-1
					if mo.digtimer == 0
						mo.leaping = 4
						mo.surfacetimer = TICRATE
						
						local tgt = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
						tgt.state = S_INVISIBLE
						tgt.tics = -1
						tgt.flags = $ & ~MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
						tgt.radius = mo.radius
						
						if mo.target and mo.target.valid
							if P_TryMove(tgt, mo.target.x, mo.target.y, false)
								P_SetOrigin(tgt, mo.target.x, mo.target.y, mo.target.floorz)
							end
						end
						mo.leaptarget = tgt
					end
				
				elseif mo.leaping == 4
					mo.sprite = SPR_NULL
					mo.frame = A
					
					mo.surfacetimer = $-1
					local scale = max(1, FRACUNIT - (mo.surfacetimer*FRACUNIT/TICRATE))
					local surface = P_SpawnMobj(mo.leaptarget.x + P_RandomRange(-4, 4)*scale, mo.leaptarget.y + P_RandomRange(-4, 4)*scale, mo.leaptarget.floorz, MT_THOK)
					surface.sprite = SPR_MNUD
					surface.frame = F
					surface.scale = scale
					
					if mo.surfacetimer == 0
						
						P_SetOrigin(mo, mo.leaptarget.x, mo.leaptarget.y, mo.leaptarget.floorz)

						for i = 1, 8
							local rock = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
							rock.state = S_ROCKCRUMBLEA
							rock.fuse = TICRATE/2
							rock.flags = $ & ~MF_NOGRAVITY
							rock.momz = P_RandomRange(4, 12)*FRACUNIT
							rock.momx = P_RandomRange(-8, 8)*FRACUNIT
							rock.momy = P_RandomRange(-8, 8)*FRACUNIT
							rock.scale = FRACUNIT/4
						end
						
						local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - FRACUNIT*4, 128<<FRACBITS, 40<<FRACBITS, mo, attack_potency, DMT_STRIKE, 8, RT_BLOWDOWN)
						hb.pso.reactionradialangle = true
						mo.leaping = 5
						mo.surfaced = TICRATE/2
						
						mo.flags = $ & ~MF_NOBLOCKMAP
						
						mo.momz = FRACUNIT*10
						
						S_StartSound(mo, sfx_s3k82)
						
						if diff >= DIFF_HARD
							for i = 1, 24
								local msl = PSO.lib.spawnMissile(mo, MT_DIGA, 0, 0, attack_potency/2, DMT_TECHNIQUE, 0, 0, 0)
								msl.target = mo
								msl.pso.element = ELEM_EARTH
								msl.color = SKINCOLOR_ORANGE
								msl.colorized = true
								P_SetOrigin(msl, mo.x, mo.y, mo.z + mo.height)
								
								msl.momz = P_RandomRange(8, 12)*FRACUNIT
								msl.momx = P_RandomRange(-12, 12)*FRACUNIT
								msl.momy = P_RandomRange(-12, 12)*FRACUNIT
							end
						end
						
					end
				elseif mo.leaping == 5
					
					mo.surfaced = $-1
					mo.momz = $*98/100
					
					if leveltime & 1
						P_SpawnGhostMobj(mo)
					end
					
					if not mo.surfaced
						mo.flags = $ & ~(MF_NOCLIP)
						mo.leaping = nil
						mo.waittimer = nil
						mo.pso.superarmor = nil
					end
				end
				
				return
			end
			
			mo.flags = MF_ENEMY|MF_SHOOTABLE|MF_SOLID
			
			if mo.z < targetz
				mo.momz = $ + rate
			elseif mo.momz < 0
				mo.momz = min(-mo.scale, $ + rate*2)
			end
			
			if mo.target and mo.target.valid
				
				local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
				
				if mo.waittimer == nil
					mo.waittimer = attack_wait
				end
				
				P_InstaThrust(mo, 0, 0)
				
				mo.waittimer = $-1
				
				if not mo.waittimer
					
					-- act depending on target's distance
					if dist > 768*mo.scale	-- too far...
						
						local fake = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
						fake.state = S_INVISIBLE
						fake.fuse = TICRATE*12
						
						mo.leaptarget = fake
						mo.momz = FRACUNIT*8
						
					else	-- good, try to jump at em!
						mo.momz = FRACUNIT*16

						local fake = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_THOK)
						fake.state = S_INVISIBLE
						fake.fuse = TICRATE*12						
						mo.leaptarget = fake
					end
					
					mo.leaping = 1
					mo.pso.superarmor = true
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.leaptarget.x, mo.leaptarget.y)
					local dist = R_PointToDist2(mo.x, mo.y, mo.leaptarget.x, mo.leaptarget.y)
					
					P_InstaThrust(mo, mo.angle, dist/(TICRATE*2))
					
					S_StartSound(mo, sfx_cdfm01)
					
				end
			end
			
			mo.sprite = SPR_MNUS
			mo.frame = leveltime%8 /2	
		end	
}