-- Popup Turret
/*
	Periodically pops in and out to shoot players.
	Bullets deal no knockback but travel quite fast.
	
	HARD MODE: Shoots 3 bullets instead of 1
*/

PSO.info.enemies[MT_POPUPTURRET] = {
		
		name = "Turret",
		sprite = SPR_TURR,
		frame = A,
		painframe = I,
		
		bhp = 20,
		satk = 10,
		ratk = 25,
		tatk = 10,
		def = 5,
		exp = 2,
		weight = 4,
		
		
		drops = {
			-- Lv 1-10
			{50, 1, 9, 1, 15},				-- meseta (100% mult) 2/5 (Lv1-10)
			{"sword", 1, 9, 1, 100},		-- sword: 	1/100 (Lv1-10)
			{"rifle", 1, 9, 1, 100},		-- rifle: 	1/100 (Lv1-10)
			{"rod", 1, 9, 1, 100},			-- rod: 	1/100 (Lv1-10)
			{"beam", 1, 9, 1, 100},
			
			{"monomate", 1, 9, 1, 25},	-- monomate: 1/5 (Lv1-10)
			
			-- Lv10-19
			
			{100, 10, 19, 1, 15},
			{"gigush", 10, 19, 1, 100},
			{"beam", 10, 19, 1, 100},
			{"cane", 10, 19, 1, 100},
			{"monomate", 10, 19, 1, 25},
			{"laser", 10, 19, 1, 100},

			-- Lv20-29
			{150, 20, 29, 1, 15},
			{"breaker", 20, 29, 1, 150},
			{"doublegladius", 20, 29, 1, 150},
			{"laser", 20, 29, 1, 150},
			{"canon", 20, 29, 1, 150},
			{"ulrod", 20, 29, 1, 150},
			{"burster", 20, 29, 1, 100},
			{"dimate", 20, 29, 1, 25},

			-- Lv30-50
			{200, 30, 50, 1, 15},
			{"shooter", 30, 50, 1, 50},
			{"alva shooter", 30, 50, 1, 100},
			{"vita shooter", 30, 50, 1, 150},
			{"dimate", 30, 50, 1, 35},
		},
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			local attack_potency = 150
			local delay = mo.mtangle or TICRATE*2
			local numbullets = diff > DIFF_NORMAL and 3 or 1
			
			local frame = A
			
			PSO.lib.enemyManageAggro(mo)
			
			if mo.target and mo.target.valid
				if mo.shooting
					
					frame = min(I, mo.shooting)
					mo.shooting = $+1
					mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
					
					for i = 1, numbullets
						if mo.shooting == TICRATE-10 + (i-1)*10
							S_StartSound(mo, sfx_trfire)
							local msl = PSO.lib.spawnMissile(mo, MT_JETTBULLET, mo.angle, 30*FRACUNIT, attack_potency, DMT_RANGED, 0, 0, mo.height/2, RT_NONE)
							PSO.lib.aimMissile(msl, mo.target)
						end
					end
					
					if mo.shooting > TICRATE*3/2 + (numbullets-1)*10
						local t = mo.shooting - (TICRATE*3/2 + (numbullets-1)*10)
						frame = max(A, I-t)
						
						if not frame
							mo.shooting = nil
							mo.delay = nil
						end
					end
				
				elseif not mo.delay
					mo.delay = delay
				else
					mo.delay = $-1
					
					if not mo.delay
						mo.shooting = 1
						S_StartSound(mo, sfx_s3k64)
					end
				end
			end
			
			mo.sprite = SPR_TURR
			mo.frame = frame
			
		end,
}