-- Item crates
-- Drop items depending on map & difficulty.
-- The crate changes colour depending on whether it contains a consumable, weapon, unit or a rare item.

-- crate drop tables per map / difficulty:
PSO.info.crateDropTables = {
	
	-- Coast
	[2] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{20, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 5},
			{"dimate", 0, 0, 1, 6},
			
			{"monogrinder", 0, 0, 1, 50},
			{"digrinder", 0, 0, 1, 50},
			
			{"moon atomizer", 0, 0, 1, 10},
			{"sword", 0, 0, 2, 100},
			{"gigush", 0, 0, 1, 100},
			{"calibur", 0, 0, 1, 100},
			{"rifle", 0, 0, 2, 100},
			{"burst", 0, 0, 1, 100},
			{"beam", 0, 0, 1, 100},
			{"rod", 0, 0, 2, 100},
			{"helixen", 0, 0, 2, 100},
			{"cane", 0, 0, 1, 100},
			{"saber", 0, 0, 2, 100},
			{"handgun", 0, 0, 2, 100},
			{"wand", 0, 0, 2, 100},
		},
		
		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 10},
			{"dimate", 0, 0, 1, 10},
			{"trimate", 0, 0, 1, 10},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			
			{"pine", 0, 0, 1, 100},
			{"alva pine", 0, 0, 1, 100},
			{"shooter", 0, 0, 1, 100},
			{"alva shooter", 0, 0, 1, 100},
			{"crest", 0, 0, 1, 100},
			{"alva crest", 0, 0, 1, 100},
			{"hammer", 0, 0, 1, 100},
			{"alva hammer", 0, 0, 1, 100},
			{"claw", 0, 0, 1, 100},
			{"alva claw", 0, 0, 1, 100},
			{"peacekeeper", 0, 0, 1, 100},
			{"alva peacekeeper", 0, 0, 1, 100},
			
			{"unit_hppp_1", 0, 0, 1, 100},
			{"unit_hppp_2", 0, 0, 1, 100},
			{"unit_rainbow_1", 0, 0, 1, 100},
			{"unit_power_1", 0, 0, 1, 100},
			{"unit_power_2", 0, 0, 1, 100},
		},
	},

	-- Canyon
	[3] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{30, 0, 0, 1, 5},

			{"monogrinder", 0, 0, 4, 50},
			{"digrinder", 0, 0, 2, 50},
			
			{"monomate", 0, 0, 1, 5},
			{"dimate", 0, 0, 1, 6},
			{"moon atomizer", 0, 0, 1, 10},
			{"sword", 0, 0, 2, 100},
			{"gigush", 0, 0, 1, 100},
			{"calibur", 0, 0, 1, 100},
			{"rifle", 0, 0, 2, 100},
			{"burst", 0, 0, 1, 100},
			{"beam", 0, 0, 1, 100},
			{"rod", 0, 0, 2, 100},
			{"helixen", 0, 0, 2, 100},
			{"cane", 0, 0, 1, 100},
			{"saber", 0, 0, 2, 100},
			{"handgun", 0, 0, 2, 100},
			{"wand", 0, 0, 2, 100},
		},
		
		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 10},
			{"dimate", 0, 0, 1, 10},
			{"trimate", 0, 0, 1, 10},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			
			{"pine", 0, 0, 1, 100},
			{"alva pine", 0, 0, 1, 100},
			{"shooter", 0, 0, 1, 100},
			{"alva shooter", 0, 0, 1, 100},
			{"crest", 0, 0, 1, 100},
			{"alva crest", 0, 0, 1, 100},
			{"hammer", 0, 0, 1, 100},
			{"alva hammer", 0, 0, 1, 100},
			{"claw", 0, 0, 1, 100},
			{"alva claw", 0, 0, 1, 100},
			{"peacekeeper", 0, 0, 1, 100},
			{"alva peacekeeper", 0, 0, 1, 100},
			
			{"unit_hpsatk_2", 0, 0, 2, 100},
			{"unit_hpratk_2", 0, 0, 2, 100},
			{"unit_hptatk_2", 0, 0, 2, 100},
			{"unit_rainbow_2", 0, 0, 2, 100},
			{"unit_power_2", 0, 0, 2, 100},
		},
	},

	-- Peaks
	[4] = {
		[DIFF_NORMAL] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{50, 0, 0, 1, 5},
			
			{"monogrinder", 0, 0, 4, 50},
			{"digrinder", 0, 0, 2, 50},
			
			{"monomate", 0, 0, 1, 5},	-- 20
			{"dimate", 0, 0, 1, 6},		-- 36
			{"trimate", 0, 0, 1, 10},	-- 46
			{"moon atomizer", 0, 0, 1, 10},	-- 56
			{"breaker", 0, 0, 2, 100},
			{"doublegladius", 0, 0, 2, 100},
			{"laser", 0, 0, 2, 100},
			{"canon", 0, 0, 2, 100},
			{"ulrod", 0, 0, 2, 100},
			{"slash", 0, 0, 2, 100},
			{"autogun", 0, 0, 2, 100},
			{"batnara", 0, 0, 2, 100},
			
			{"unit_hp_2", 0, 0, 2, 100},
			{"unit_satk_2", 0, 0, 2, 100},
			{"unit_ratk_2", 0, 0, 2, 100},
			{"unit_tatk_2", 0, 0, 2, 100},
			{"unit_pp_2", 0, 0, 2, 100},
			{"unit_hppp_2", 0, 0, 2, 100},
			{"unit_ppregen_1", 0, 0, 2, 100},
		},
		
		[DIFF_HARD] = {
			
			-- {item, unused, unused, ratelow, ratehigh}
			{150, 0, 0, 1, 5},
			{"monomate", 0, 0, 1, 10},
			{"dimate", 0, 0, 1, 10},
			{"trimate", 0, 0, 1, 10},
			
			{"scape doll", 0, 0, 1, 100},
			
			{"monogrinder", 0, 0, 2, 50},
			{"digrinder", 0, 0, 1, 50},
			{"trigrinder", 0, 0, 1, 100},
			
			{"moon atomizer", 0, 0, 1, 20},
			{"star atomizer", 0, 0, 1, 20},
			
			{"alva pine", 0, 0, 1, 100},
			{"vita pine", 0, 0, 1, 100},
			{"alva shooter", 0, 0, 1, 100},
			{"vita shooter", 0, 0, 1, 100},
			{"alva crest", 0, 0, 1, 100},
			{"vita crest", 0, 0, 1, 100},
			{"alva hammer", 0, 0, 1, 100},
			{"vita hammer", 0, 0, 1, 100},
			{"alva claw", 0, 0, 1, 100},
			{"vita claw", 0, 0, 1, 100},
			{"alva peacekeeper", 0, 0, 1, 100},
			{"vita peacekeeper", 0, 0, 1, 100},
			
			{"unit_ppsatk_2", 0, 0, 2, 100},
			{"unit_ppratk_2", 0, 0, 2, 100},
			{"unit_pptatk_2", 0, 0, 2, 100},
			{"unit_rainbow_2", 0, 0, 2, 100},
			{"unit_power_2", 0, 0, 2, 100},
		},
	},
	
}

freeslot("MT_PSO_CRATE", "S_PSO_CRATE_WAIT", "S_PSO_CRATE", "SPR_PCRT")

mobjinfo[MT_PSO_CRATE] = {
	doomednum = 2505,
	spawnstate = S_PSO_CRATE_WAIT,
	spawnhealth = 1000,
	flags = MF_NOCLIPTHING,
	radius = 64<<FRACBITS,
	height = 128<<FRACBITS,
}	

-- sets up the crate, visual and drops.
function A_SetupCrate(mo)
	
	-- box alredy set up, update it!
	if mo.hnext	
		local curr = mo.hnext
		while curr
			curr.momx = mo.momx
			curr.momy = mo.momy
			curr.momz = mo.momz
			
			curr = curr.hnext
		end
		return
	end
	
	--PSO.lib.dprint("A_SetupCrate()...")
	local boxsize = FRACUNIT*3/4
	
	if not mo.pso
		mo.pso = {name = "Item crate"}
	end
	
	mo.flags = MF_SOLID|MF_SHOOTABLE
	
	-- only compute drops if they don't come premade (this is the case with boss crates)
	if not mo.drops
		local difficulty = PSO.lib.questDifficulty() or DIFF_NORMAL
		
		-- should we use the map or quest drop table?
		
		local quest
		if server.questdata
			quest = PSO.info.quests[server.questdata.map][server.questdata.index]
		end
		
		if quest and quest.drops and mo.options & 4	-- allow fallback			
			local droptable_diff = quest.drops[difficulty]
			mo.drops = PSO.lib.calcDrops(droptable_diff) or {}		
		else
		
			-- start by figuring out what drops we're giving out to every player
			local droptable_map = PSO.info.crateDropTables[gamemap]
			assert(droptable_map, "No crate drop table for this map!")
			local droptable_diff = droptable_map[difficulty]
			assert(droptable_diff, "No crate drop table for this difficulty!")
			
			-- precompute the drop table
			-- this lets us assign the colour of the box for each player!
			mo.drops = PSO.lib.calcDrops(droptable_diff) or {}
		end
	end
	
	-- get the frame
	local frame = A
	local pdrop = consoleplayer and mo.drops[#consoleplayer+1] or mo.drops[1]
	
	if pdrop and type(pdrop) ~= "number"	-- meseta: just use frame A
		local info = PSO.lib.itemInfo(pdrop)
		
		if info.rarity and info.rarity >= 7
			frame = D
		elseif info.type == IT_WEAPON
			frame = B
		elseif info.type == IT_ARMOR
		or info.type == IT_UNIT
			frame = C
		else
			frame = A	-- consumables / other
		end
	end
	
	-- spawn the crate's sides
	local curr = mo
	local dist = 64*boxsize / FRACUNIT
	local ang = mo.angle
	
	for i = 1, 4
		local x = mo.x + dist*cos(ang)
		local y = mo.y + dist*sin(ang)
		local s = P_SpawnMobj(x, y, mo.z, MT_THOK)
		s.tics = -1
		s.fuse = -1
		s.sprite = SPR_PCRT
		s.frame = frame|FF_PAPERSPRITE
		s.scale = boxsize
		s.angle = ang+ANG1*90
		ang = s.angle
		
		curr.hnext = s
		curr = s
	end
end

states[S_PSO_CRATE_WAIT] = {SPR_NULL, A, 4, nil, 0, 0, S_PSO_CRATE}
states[S_PSO_CRATE] = {SPR_NULL, A, 1, A_SetupCrate, 0, 0, S_PSO_CRATE}


-- destroying the crate...
addHook("ShouldDamage", function(mo, inflictor)
	
	-- no.
	if not mo.pso
		return false
	end
	
	if inflictor and inflictor.valid and inflictor.target and inflictor.target.player
		-- get rid of the sides of the box
		local curr = mo.hnext
		while curr
				
			local ang = curr.angle - ANG1*90
			P_InstaThrust(curr, ang, P_RandomRange(10, 24)*curr.scale)
			curr.momz = P_RandomRange(6, 12)*curr.scale
			curr.fuse = TICRATE*3/4
			curr.tics = TICRATE*3/4
			curr.flags = MF_NOCLIPHEIGHT
				
			curr = curr.hnext
		end
			
		-- drop the item
		
		local has_drops = false
		for k,v in pairs(mo.drops or {})
			has_drops = true
			if type(v) == "number"	-- add variance to meseta
				mo.drops[k] = v + P_RandomRange(-v/10, v/10)
			end
		end
		
		if has_drops
			local drop = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_PSO_DROP)
			drop.psoitems = mo.drops
			--drop.momx = P_RandomRange(-3, 3)*mo.scale
			--drop.momy = P_RandomRange(-3, 3)*mo.scale
			drop.momz = mo.scale*6
			
			if consoleplayer
				local mydrop = mo.drops[#consoleplayer+1]
				if mydrop
				and type(mydrop) ~= "number"
					local minfo = PSO.lib.itemInfo(mydrop)
					if minfo.rarity >= 7
						PSO.lib.startRareDropAnim(consoleplayer, minfo.rarity)
					end
				end
			end
			
		end
			
		P_RemoveMobj(mo)
		return
	end
end, MT_PSO_CRATE)
