-- controls the doors in the lobby.
-- the controlled sector is the sector the object starts at
-- all doors must be opened on the map (this allows the object to know the min/max height) and will then be set to closed automatically

freeslot("MT_PSO_LOBBYDOORCONTROLLER")

mobjinfo[MT_PSO_LOBBYDOORCONTROLLER] = {
	doomednum = 2600,
	spawnstate = S_INVISIBLE,
	radius = 1,
	height = 1,
	flags = MF_NOCLIP|MF_NOCLIPTHING|MF_NOGRAVITY,
}

local activation_radius = 256	-- default activation dist
local open_speed = FRACUNIT*48

addHook("MobjThinker", function(mo)
	
	local sec = mo.subsector.sector
	if not mo.extravalue2
		
		-- start by assessing the sector we're in
		mo.bottomz = sec.floorheight
		mo.topz = sec.ceilingheight
		
		-- close the door
		sec.floorheight = sec.ceilingheight
		
		-- initialized
		mo.extravalue2 = 1
	end
	
	-- open the door if we get near
	local open = false
	for p in players.iterate do
		
		if p.mo and p.mo.valid
			if R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y) < (mo.mtangle or activation_radius)*FRACUNIT
				
				open = true
				break	-- don't care about the rest of the players
			end
		end
	end
	
	
	if open
		sec.floorheight = max(mo.bottomz, $ - open_speed)
	else
		sec.floorheight = min(mo.topz, $ + open_speed)
	end
end, MT_PSO_LOBBYDOORCONTROLLER)