-- funny computer windows

freeslot("MT_PSO_LOBBYWINDOWS", "MT_PSO_LOBBYWINDOW", "S_PSO_LOBBYWINDOW", "SPR_LOBW")

mobjinfo[MT_PSO_LOBBYWINDOWS] = {
	doomednum = 2601,
	spawnstate = S_INVISIBLE,
	height = 1,
	radius = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_PSO_LOBBYWINDOW] = {
	doomednum = -1,
	spawnstate = S_PSO_LOBBYWINDOW,
	height = 1,
	radius = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}


local stretches = {
	
	{FRACUNIT/8, FRACUNIT*8},
	{FRACUNIT/4, FRACUNIT*4},
	{FRACUNIT/2, FRACUNIT*2},
	{FRACUNIT, FRACUNIT},
}

function A_LobbyWindow(mo)
	
	mo.existtime = $ or 1
	
	-- nice stretch when appearing/disappearing.
	local s = stretches[mo.existtime]
	
	if stretches[mo.fuse]
		s = stretches[mo.fuse]
	end
	
	if s
		mo.spritexscale = s[1]
		mo.spriteyscale = s[2]
	end
	
	-- move slowly around the target
	if mo.target and mo.target.valid
		
		local dist = mo.extravalue1
		local x = mo.target.x + dist*cos(mo.angle - ANG1*90)
		local y = mo.target.y + dist*sin(mo.angle - ANG1*90)
		
		P_MoveOrigin(mo, x, y, mo.z)
		mo.angle = $ + (ANG1/4*mo.extravalue2)
	end
	
	mo.existtime = $+1
end

states[S_PSO_LOBBYWINDOW] = {SPR_LOBW, A|FF_ADD|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_LobbyWindow, 0, 0, S_PSO_LOBBYWINDOW}

local default_radius = 736
local colours = {SKINCOLOR_RED, SKINCOLOR_ORANGE, SKINCOLOR_GREEN, SKINCOLOR_TEAL}

addHook("MobjThinker", function(mo)
	
	local dist = mo.mtangle or default_radius
	
	if leveltime % (TICRATE*(mo.extrainfo or 2)) == 0
		
		local ang = P_RandomRange(0, 360)*ANG1
		local fdist = P_RandomRange(dist/2, dist)
		
		local x = mo.x + fdist*cos(ang)
		local y = mo.y + fdist*sin(ang)
		local z = mo.z + FRACUNIT*128 + P_RandomRange(0, dist/3)*FRACUNIT
		
		local w = P_SpawnMobj(x, y, z, MT_PSO_LOBBYWINDOW)
		w.angle = ang + ANG1*90
		w.target = mo
		w.extravalue1 = fdist
		w.color = colours[P_RandomRange(1, #colours)]
		w.extravalue2 = P_RandomRange(0, 1) and 1 or -1
		w.fuse = P_RandomRange(5, 8)*TICRATE
	end
	
end, MT_PSO_LOBBYWINDOWS)