-- Animates the depths elevator

local mapnum = 5

local ref_tag = 101
local e_tag = 100
local l_tag = 102

local floor_bottom
local floor_top


/*COM_AddCommand("psod_elevatorspeed", function(p, arg)
	server.targetelevatorspeed = tonumber(arg) or 0
	print(server.targetelevatorspeed)
end)*/

local olga_elevator = {}
local olga_lines = {}

addHook("MapChange", do
	olga_elevator = {}
	server.targetelevatorspeed = 0
	server.elevatorspeed = 0
end)

addHook("MapLoad", do
	
	olga_elevator = {}
	olga_lines = {}
	
	for s in sectors.iterate
		
		if s.tag == e_tag
			
			table.insert(olga_elevator, s)
			--print("add "..tostring(s))
			
		elseif s.tag == ref_tag
			
			floor_bottom = s.floorheight
			floor_top = s.ceilingheight
			--print("set bounds")
		end
	end
	
	for l in lines.iterate
		
		if l.tag == l_tag
			table.insert(olga_lines, l)
		end
	end
end)


addHook("ThinkFrame", do
	
	if gamemap == mapnum
	
		server.targetelevatorspeed = $ or 0
		server.elevatorspeed = $ or 0
		
		if server.elevatorspeed < server.targetelevatorspeed*FRACUNIT
			server.elevatorspeed = $+FRACUNIT/4
		elseif server.elevatorspeed > server.targetelevatorspeed*FRACUNIT
			server.elevatorspeed = $-FRACUNIT/4
		end
		
		if floor_top ~= nil
			for i = 1, #olga_elevator
				
				local s = olga_elevator[i]
				if not s or not s.valid continue end
				--print(s)
				
				s.floorheight = $ + server.elevatorspeed
				s.ceilingheight = $ + server.elevatorspeed
				
				if s.floorheight > floor_top
				and server.elevatorspeed > 0	
					local height = floor_top-floor_bottom
					s.floorheight = $ - height
					s.ceilingheight = $ - height
					
				elseif s.ceilingheight < floor_bottom
				and server.elevatorspeed < 0
					local height = floor_top-floor_bottom
					s.floorheight = $ + height
					s.ceilingheight = $ + height
				
				end
			end
			
			for i = 1, #olga_lines
				local l = olga_lines[i]
				local side = sides[l.sidenum[0]]
				
				side.rowoffset = $ + server.elevatorspeed
			end
		end
	end
end)