-- Teleporters usable by players.
-- angle: ID (teleporter & dest ID must match)

-- extra: teleport to low orbit station (makes it red and changes the music/sky after teleporting)
	-- > this also disallows players from using weapons until they use another teleport that allows them to
	
-- special: teleport from low orbit station: restores sky/music after teleporting
	--> this also allows players to use their weapons again

-- ambush: make teleporter invisible
	--> used by the main teleporter

freeslot("MT_PSO_TELEPORTER", "MT_PSO_TELEPORT_DEST", "SPR_PTLP", "MT_PSO_BOSSTELEPORTER")

mobjinfo[MT_PSO_TELEPORTER] = {
	
	doomednum = 2510,
	spawnstate = S_INVISIBLE,
	radius = 80<<FRACBITS,
	height = 96<<FRACBITS,
	flags = MF_RUNSPAWNFUNC,
}

mobjinfo[MT_PSO_BOSSTELEPORTER] = {
	
	doomednum = 2520,
	spawnstate = S_INVISIBLE,
	radius = 80<<FRACBITS,
	height = 96<<FRACBITS,
	flags = MF_RUNSPAWNFUNC,
}

mobjinfo[MT_PSO_TELEPORT_DEST] = {
	doomednum = 2511,
	spawnstate = S_INVISIBLE,
	radius = 48<<FRACBITS,
	height = 60<<FRACBITS,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING
}

local function teleporter_thinker(mo)	
	local color = SKINCOLOR_NONE
	
	mo.existtimer = $ and $+1 or 1
	
	-- used by end-of-level teleporters
	if mo.hold
		mo.existtimer = 1
		return
	end
	
	if mo.existtimer < 4
		return
	end
	
	-- only done once so that custom spawned TPs can do whatever they want
	if not mo.extravalue2
		mo.lobbytele = mo.options & 1
		mo.fromlobbytele = mo.options & 4
		mo.extravalue2 = 1
	end
	
	if mo.lobbytele
		color = SKINCOLOR_RED
	end
	
	if mo.type == MT_PSO_BOSSTELEPORTER
		color = SKINCOLOR_CYAN
	end
	
	if not mo.extravalue1
		
		mo.id = mo.mtangle
		
		if not (mo.options & 8)
			local bot = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*192, MT_THOK)
			bot.sprite = SPR_PTLP
			bot.frame = A
			bot.flags2 = $|MF2_SPLAT
			bot.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			bot.tics = -1
			
			mo.bottom = bot
			
			local top = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			top.sprite = SPR_PTLP
			top.frame = A
			top.flags2 = $|MF2_SPLAT
			top.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD	
			top.tics = -1
			
			mo.top = top
			
			
			local coords = {
				{-54, 0, ANG1*90},
				{0, 32, ANG1*90 + ANG1*60},
				{0, -32, ANG1*90 - ANG1*60},
			}
			
			local cur = mo
			for i = 1, #coords
				local c = coords[i]
				
				local x = mo.x + c[1]*mo.scale
				local y = mo.y + c[2]*mo.scale
				local a = c[3]
				
				local f = P_SpawnMobj(x, y, mo.z, MT_THOK)
				f.sprite = SPR_PTLP
				f.frame = B|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT
				f.angle = a
				f.tics = -1
				f.color = color
				
				cur.hnext = f
				cur = f
			end
		end
		
		-- try to find a destination!
		for m in mobjs.iterate()
			if m and m.valid and m.type == MT_PSO_TELEPORT_DEST
			and m.mtangle == mo.id
				mo.target = m
				break
			end
		end
		
		if not mo.target or not mo.target.valid
			print("\x82".."WARNING: ".."\x80".."Teleporter of ID "..mo.id.." has no destination!")
		end
		
		mo.extravalue1 = 1
	end
	
	if mo.extravalue1
		local cur = mo.hnext
		while cur
			
			if leveltime%10 == 0
			
				local t = P_SpawnMobj(cur.x, cur.y, cur.z, MT_THOK)
				t.sprite = SPR_PTLP
				t.frame = C|FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT
				t.angle = cur.angle
				t.tics = 23
				t.fuse = 23
				t.color = cur.color
				t.momz = FRACUNIT*8
			end
			
			cur.momx = mo.momx
			cur.momy = mo.momy
			cur.momz = mo.momz
			
			cur = cur.hnext
		end
	end
end
addHook("MobjThinker", teleporter_thinker, MT_PSO_TELEPORTER)
addHook("MobjThinker", teleporter_thinker, MT_PSO_BOSSTELEPORTER)