freeslot("SPR_DSTL")

local function saber_trail(mo, pos, prevswordpos)
						
	for i = 0, 5
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale), mo.x + FixedMul(pos[2], mo.scale), FRACUNIT/5 *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale), mo.y + FixedMul(pos[3], mo.scale), FRACUNIT/5 *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale), mo.z + FixedMul(pos[4], mo.scale), FRACUNIT/5 *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/5 *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8, MT_THOK)
		
		if pos[7] and pos[7].use
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = SPR_DSTL
			trail.frame = A|TR_TRANS30
			
			trail.angle = 0	
			trail.rollangle = a

		else
			trail.sprite = SPR_DSTL
			trail.frame = A|TR_TRANS30|FF_PAPERSPRITE
			trail.angle = mo.player.drawangle + pos[5]
			trail.rollangle = InvAngle(a)	-- weirdly enough it's inverted here
		end
		
		trail.tics = 10
		trail.fuse = 10						
		trail.color = SKINCOLOR_CYAN
	end
end

PSO.info.photonArts["dsaber_pa_tornadodance"] = {
		name = "Tornado Dance",
		desc = "Spin the Saber above your head, generating a gust of wind that knocks enemies away.",
		cost = 0,
		icon = "H_DSABR4",
		cost = 30,
		potency = 450,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still

		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))

					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}					
					
					if timer == 1
											
						pos[2] = 0
						pos[3] = 0
						pos[4] = mo.height*12/10
						pos[5] = 0
						pos[6] = 0
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height*12/10},
							xy = 0,
							za = 0,
						}
						
						--mo.state = S_PLAY_WALK
					end
					pos[6] = $ + ANG1*45

					if mo.saberangle == nil
						mo.saberangle = p.drawangle
					end

					-- trail
					if timer > 1
						saber_trail(mo, pos, prevsaberpos)
					end

					for i = 1, 5
						if timer == (TICRATE/5 -1)* i
							
							local reaction = i < 5 and RT_STAGGER or RT_BLOWDOWN
							
							local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 320<<FRACBITS, 80<<FRACBITS, mo, potency/5, DMT_STRIKE, 2, reaction)
							hb.angle = p.drawangle
							hb.pso.combobreaker = true

							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
					end
					
					if timer == TICRATE
						
						for i = 1, 16
							local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
							P_InstaThrust(d, (360/16)*i*ANG1, mo.scale*32)
							d.momz = mo.scale*4
						end
						
						return true
					end
				end,
}

PSO.info.photonArts["dsaber_pa_spinadvance"] = {
		name = "Spin Advance",
		desc = "Push forward, spinning the Saber in front of yourself to push enemies along with you.",
		icon = "H_DSABR2",
		cost = 30,
		potency = 550,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still

		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))

					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}					
					
					if timer == 1
						mo.saberangle = p.drawangle
						
						local dist = 32
						local x = dist*cos(mo.saberangle)
						local y = dist*sin(mo.saberangle)
						local z = mo.height/2
						
						pos[2] = x
						pos[3] = y
						pos[4] = z
						pos[5] = mo.saberangle + ANG1*90
						
						mo.state = S_PLAY_WALK
					end
					
					if mo.saberangle == nil
						mo.saberangle = p.drawangle
					end
					
					p.cmd.angleturn = mo.saberangle/FRACUNIT
					pos[6] = $ + ANG1*45
					
					if FixedHypot(mo.momx, mo.momy) < mo.scale*8
						P_InstaThrust(mo, mo.saberangle, mo.scale*8)
					end
					
					-- trail
					if timer > 1
						saber_trail(mo, pos, prevsaberpos)
					end

					for i = 1, 5
						if timer == (TICRATE/5 -1)* i
							local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/5, DMT_STRIKE, 2, RT_KNOCKBACK)
							hb.angle = p.drawangle
							hb.pso.combobreaker = true
							hb.pso.reactionstrength = i == 5 and 40 or 12

							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end		
						end
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

PSO.info.photonArts["dsaber_pa_deadlyarcher"] = {
		name = "Deadly Archer",
		desc = "Throw the Saber forward like a boomerang, shreadding the enemy in its wake.",
		icon = "H_DSABR3",
		potency = 900,
		cost = 30,
		speed = 30,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		use = 	function(p, timer, hold, input, combo)

					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
										
					if timer == 1
						-- hack: make the saber invisible by sending it like 398201413271892 feet underground
						pos[4] = -9999*FRACUNIT
						
						mo.momx = $/3
						mo.momy = $/3
						
						-- spawn a fake boomerang sb!
						local fake = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height, MT_THOK)
						fake.sprite = winfo.sprite
						if winfo.splatframe
							fake.frame = winfo.splatframe
						else
							fake.frame = winfo.frame
						end
						
						fake.color = winfo.color or SKINCOLOR_NONE
						
						P_CreateFloorSpriteSlope(fake)
						fake.flags2 = $ | MF2_SPLAT
						fake.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
						
						mo.fakesaber = fake
						local spd = FixedHypot(mo.momx, mo.momy)
						P_InstaThrust(fake, p.drawangle, mo.scale*8 + spd)

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end					
					end

					if mo.saberangle == nil
						mo.saberangle = p.drawangle
					end
					
					local fake = mo.fakesaber		

					-- for interpolation.
					local prevsaberpos = {
						fake.x - mo.x,
						fake.y - mo.y,
						fake.z - mo.z,
						fake.rollangle,	-- rollangle
					}
					
					fake.floorspriteslope.o = {x = fake.x, y = fake.y, z = fake.z}
					fake.floorspriteslope.xydirection = 0
					fake.floorspriteslope.zangle = 0						
					fake.rollangle = $ + ANG1*45
					fake.tics = 2
					
					local ang = R_PointToAngle2(fake.x, fake.y, mo.x, mo.y)
					P_Thrust(fake, ang, FRACUNIT/2)
					
					-- it's all make believe!
					local fakepos = {
						nil,
						fake.x - mo.x + fake.momx,
						fake.y - mo.y + fake.momy,
						fake.z - mo.z + fake.momz,
						0,
						fake.rollangle,
						{
							use = true,
							o = {x = fake.x, y = fake.y, z = fake.z},
							xy = 0,
							za = 0,
						}
					}
					
					saber_trail(mo, fakepos, prevsaberpos)
					
					for i = 1, 5
						if timer == (TICRATE/2) + (i-1)*4
							local hb = PSO.lib.spawnHurtBox(fake.x, fake.y, fake.z-FRACUNIT*32, 255<<FRACBITS, 40<<FRACBITS, mo, potency/5, DMT_STRIKE, 2)
							hb.angle = p.drawangle
							hb.pso.locks = 2
							hb.pso.combobreaker = true
						end
					end
					
					if timer == TICRATE*3/2 - 5
						return true
					end
					
		end,
}

PSO.info.photonArts["dsaber_normal"] = {
		name = "Attack",
		desc = "A series of stylish slashes that can be used up to 3 times in a row.",
		cost = 0,
		potency = 300,
		speed = 30,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_DSABR1",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevsaberpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						
						if timer <= 3
							-- quickly swing the saber by our side.
							mo.swordangle = nil
							local ang = p.drawangle + ANG1*180 + (180/4)*(timer-1)*ANG1
							
							local x = 32*cos(ang)
							local y = 32*sin(ang)
							local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/4 * (timer-1))
							
							pos[2] = x
							pos[3] = y
							pos[4] = z
							pos[5] = ang + ANG1*90 - p.drawangle
							pos[6] = -ANG1*30
							pos[7] = {use = false}
						end
						if timer < TICRATE/4
							
							if timer == 3
							or timer == 7
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/4, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 5
								hb.pso.locks = 3
								hb.angle = p.drawangle
								
								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
							end
							
							local t = (timer - 3)
							local ang = p.drawangle - ANG1*max(0, 20-t*3)
							local dist = 32-(t*8)
							
							local px = dist*cos(ang)
							local py = dist*sin(ang)
							local pz = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT*3/4 + t*FRACUNIT/6)							
							
							pos[2] = px
							pos[3] = py
							pos[4] = pz
							pos[5] = 0
							pos[6] = -ANG1*30 + (t*48)*ANG1
							
							pos[7] = {
								use = true,
								o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
								xy = p.drawangle,
								za = -ANG1*max(0, (45 - t*8))
							}
						
						elseif timer < TICRATE*3/4 -5

							local t = timer - TICRATE/4
							pos[7] = {
								use = true,
								o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
								xy = p.drawangle - ANG1*90,	-- tilt sideways
								za = ANG1*min(t*5, 30),
							}
						
							if mo.swordangle == nil
								mo.swordangle = $ or ANG1*20
							end
							mo.swordangle = $ + ANG1*max(0, (30 - t*4))
							
							local ang = p.drawangle + mo.swordangle
							local x = 24 * cos(ang)
							local y = 24 * sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[4] = mo.height*3/4
							pos[5] = 0
							pos[6] = ang
							
							if timer == TICRATE*3/4
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 6
								hb.angle = p.drawangle	
								hb.pso.locks = 3

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							end
							
						elseif timer < TICRATE
							p.pso.actiontimer = TICRATE*30 - (TICRATE/4)
						end
					
					-- 2nd slash
					elseif combo == 1

						
						if timer <= 3
							-- quickly swing the saber by our side.
							mo.swordangle = nil
							local ang = p.drawangle + ANG1*180 - (180/4)*(timer-1)*ANG1
							
							local x = 32*cos(ang)
							local y = 32*sin(ang)
							local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/4 * (timer-1))
							
							pos[2] = x
							pos[3] = y
							pos[4] = z
							pos[5] = ang + ANG1*90 - p.drawangle
							pos[6] = -ANG1*30
							pos[7] = {use = false}
						end
						
						if timer < TICRATE/4
							
							local t = (timer - 3)
							local ang = p.drawangle + ANG1*max(0, 20-t*3)
							local dist = 32-(t*8)
							
							local px = dist*cos(ang)
							local py = dist*sin(ang)
							local pz = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT*3/4 + t*FRACUNIT/6)							
							
							pos[2] = px
							pos[3] = py
							pos[4] = pz
							pos[5] = 0
							pos[6] = -ANG1*30 - (t*48)*ANG1
							
							pos[7] = {
								use = true,
								o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
								xy = p.drawangle,
								za = -ANG1*max(0, (45 - t*8))
							}

							if timer == 3
							or timer == 7
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/4, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 2
								hb.angle = p.drawangle
								hb.pso.locks = 3

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							end
						
						elseif timer < TICRATE*3/4 -5

							local t = timer - TICRATE/4
							pos[7] = {
								use = true,
								o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
								xy = p.drawangle - ANG1*90,	-- tilt sideways
								za = ANG1*min(t*5, 10),
							}
						
							if mo.swordangle == nil
								mo.swordangle = $ or -ANG1*20
							end
							mo.swordangle = $ - ANG1*max(0, (35 - t*4))
							
							local ang = p.drawangle + mo.swordangle
							local x = 24 * cos(ang)
							local y = 24 * sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[4] = mo.height*3/4
							pos[5] = 0
							pos[6] = ang

							if timer == TICRATE*3/4
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 3
								hb.pso.locks = 1
								hb.angle = p.drawangle	

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							end
							
						elseif timer < TICRATE
							p.pso.actiontimer = TICRATE*30 - (TICRATE/4)
						end
					
					-- 3rd slash
					elseif combo == 2

						
						if timer <= 10
							-- quickly swing the saber by our side.
							mo.swordangle = nil
							local ang = p.drawangle + ANG1*180 + (180/6)*(timer-1)*ANG1
							
							local x = 32*cos(ang)
							local y = 32*sin(ang)
							local z = FixedMul(FixedDiv(mo.height, mo.scale), FRACUNIT/6 * (timer-1))
							
							pos[2] = x
							pos[3] = y
							pos[4] = z
							pos[5] = ang + ANG1*90 - p.drawangle
							pos[6] = -ANG1*30
							pos[7] = {use = false}
							
						elseif timer < TICRATE*3/4
							
							local t = (timer - 10)
							local ang = p.drawangle - ANG1*max(0, 20-t*3)
							local dist = max(0, 32-(t*8))
							
							local px = dist*cos(ang)
							local py = dist*sin(ang)
							local pz = FixedMul(FixedDiv(mo.height, mo.scale), min(FRACUNIT*12/10, FRACUNIT*3/4 + t*FRACUNIT/9))					
							
							pos[2] = px
							pos[3] = py
							pos[4] = pz
							pos[5] = 0
							pos[6] = -ANG1*30 + (t*48)*ANG1
							
							pos[7] = {
								use = true,
								o = {x = mo.x + px, y = mo.y + py, z = mo.z + pz},	-- the center of the slope is the center of the player.
								xy = p.drawangle,
								za = -ANG1*max(0, (45 - t*8))
							}

							if timer == 12
							or timer == 16
							or timer == 21
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/4, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 5
								hb.angle = p.drawangle

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							end
						
						elseif timer < TICRATE

							local t = timer - TICRATE*3/4
							pos[7] = {
								use = true,
								o = {x = mo.x, y = mo.y, z = mo.z + mo.height*3/4},	-- the center of the slope is the center of the player.
								xy = p.drawangle - ANG1*90,	-- tilt sideways
								za = ANG1*min(t*5, 30),
							}
						
							if mo.swordangle == nil
								mo.swordangle = $ or ANG1*20
							end
							mo.swordangle = $ + ANG1*max(0, (30 - t*4))
							
							local ang = p.drawangle + mo.swordangle
							local x = 24 * cos(ang)
							local y = 24 * sin(ang)
							
							pos[2] = x
							pos[3] = y
							pos[4] = mo.height*3/4
							pos[5] = 0
							pos[6] = ang

							if timer == TICRATE-6
								local x = mo.x + FixedMul(mo.scale, 64*cos(p.drawangle))
								local y = mo.y + FixedMul(mo.scale, 64*sin(p.drawangle))
								local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 166<<FRACBITS, 40<<FRACBITS, mo, potency/2, DMT_STRIKE, 2)
								--hb.pso.potency = potency	-- normals shouldn't benefit from PA%
								hb.pso.ppregen = 5
								hb.angle = p.drawangle		

								if winfo.sound
									S_StartSound(mo, winfo.sound)
								end
								
							end
							
						elseif timer == TICRATE*3/2 + TICRATE/4
							return true
						end
					end
					
					-- trail
					if timer > 1
						saber_trail(mo, pos, prevsaberpos)
					end
					
					if timer == TICRATE*30
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}