-- Saber photon arts
local function saber_trail(mo, pos, prevswordpos)
						
	for i = 0, 5
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale), mo.x + FixedMul(pos[2], mo.scale), FRACUNIT/5 *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale), mo.y + FixedMul(pos[3], mo.scale), FRACUNIT/5 *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale), mo.z + FixedMul(pos[4], mo.scale), FRACUNIT/5 *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/5 *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8, MT_THOK)
		
		if pos[7] and pos[7].use
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = SPR_STRL
			trail.frame = B|TR_TRANS30
			
			trail.angle = 0	
			trail.rollangle = a

		else
			trail.sprite = SPR_STRL
			trail.frame = B|TR_TRANS30|FF_PAPERSPRITE
			trail.angle = mo.player.drawangle + pos[5]
			trail.rollangle = InvAngle(a)	-- weirdly enough it's inverted here
		end
		
		trail.tics = 10
		trail.fuse = 10						
		trail.color = SKINCOLOR_CYAN
	end
end

PSO.info.photonArts["saber_pa_crushingleap"] = {
		name = "Crushing Leap",
		desc = "A slashing leap followed by a dive attack that keeps your enemies at bay",
		cost = 25,
		potency = 550,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SABR2",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- sabers are weapon slot 2
					local pos = p.pso.weaponpos[HAND_RIGHT]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if timer < TICRATE/4
						
						mo.groundtimer = 0
						
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = min(ANG1*30, timer*ANG1*2),				-- tilt by 30 degrees
						}
						
						local ang
						
						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/4
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(40 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/5
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z - FRACUNIT*32, 100<<FRACBITS, 60<<FRACBITS, mo, potency/3, DMT_STRIKE, 8)
							hb.pso.combobreaker = true
							hb.pso.locks = 4
							hb.angle = p.drawangle
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
							
							mo.momz = FRACUNIT*17
							mo.z = $+1
							mo.state = S_PLAY_SPRING
						end
					elseif not mo.groundtimer
						local t = timer - TICRATE/4
						
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
						end
						
						mo.momz = $ + P_GetMobjGravity(mo)*2
						
						local h_an = p.drawangle - ANG1*20
						local v_an = -ANG1*80 + min(t, 12) *ANG1*15
						local dist = 64
						
						local posa = FixedMul(mo.scale, sin(v_an)*dist)
						local tx = FixedMul(cos(h_an), posa)
						local ty = FixedMul(sin(h_an), posa)
						local tz = mo.height/2 + FixedMul(mo.scale, dist*cos(v_an))
						
						pos[2] = tx
						pos[3] = ty
						pos[4] = tz
						pos[5] = -ANG1*10
						pos[6] = v_an - ANG1*90
						pos[7] = {use=false}
						
						
						if P_IsObjectOnGround(mo)
							mo.groundtimer = timer
							
							S_StartSound(mo, sfx_pstop)
							
							local an = mo.angle - ANG1*90
							for i = 1, 8
								local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
								d.angle = ((360/8)*ANG1 + ANG1/2)*(i-1)
								P_InstaThrust(d, d.angle, FRACUNIT*32)
							end
	
							local x = mo.x + 64*cos(p.drawangle)
							local y = mo.y + 64*sin(p.drawangle)
	
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z - FRACUNIT*32, 200<<FRACBITS, 40<<FRACBITS, mo, potency*2/3, DMT_STRIKE, 8, RT_BLOWDOWN)
							hb.pso.combobreaker = true
							hb.pso.locks = 4
							hb.angle = p.drawangle
						end
					else
						
						p.pso.actionspeed = 0
						if timer == mo.groundtimer + TICRATE/2
							mo.groundtimer = nil
							return true
						end
					end

					if timer > 1
						saber_trail(mo, pos, prevswordpos)
					end
				end,
}

PSO.info.photonArts["saber_normal"] = {
		name = "Attack",
		desc = "A series of quick slashes ending in a skewer move that knocks enemies back. Restores PP on hit.",
		cost = 0,
		potency = 205,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_SABR1",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- sabers are weapon slot 2
					local pos = p.pso.weaponpos[HAND_RIGHT]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang
						
						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/4
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(40 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/5
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 100<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 5
							hb.pso.locks = 4
							hb.angle = p.drawangle
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer > TICRATE/3
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/3
						end
					
					-- slash 2:
					elseif combo == 1
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle - ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang
						
						if timer < 3
							mo.swordangle = ANG1*120
						elseif timer < TICRATE/4
							local nt = timer-3
							mo.swordangle = $ - max(0, ANG1*(40 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90

						-- damage box:
						if timer == TICRATE/5
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 140<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 5
							hb.pso.locks = 4
							hb.angle = p.drawangle
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer > TICRATE/3
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/3
						end					
					
					elseif combo == 2
						
						pos[7] = {use = false}
						
						local ang = p.drawangle - ANG1*30
						local x = 24*cos(ang)
						local y = 24*sin(ang)
						
						-- further dist for the skewer:
						x = x + (min(4, timer)*cos(p.drawangle)*16)
						y = y + (min(4, timer)*sin(p.drawangle)*16)

						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = ANG1*10
						pos[6] = 0

						-- damage box:
						if timer == TICRATE/8
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(mo.x+x, mo.y+y, mo.z+z, 180<<FRACBITS, 40<<FRACBITS, mo, potency + 4, DMT_STRIKE, 8, RT_KNOCKBACK)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 6
							hb.pso.reactionangle = p.drawangle
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer == TICRATE*3/4
							return true
						end
					end
					
					-- sword trail:
					if timer > 1 and combo < 2
						saber_trail(mo, pos, prevswordpos)
					end
					
					if timer == 30*TICRATE
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}
