PSO.info.photonArts["shotgun_normal"] = {
		name = "Shot",
		desc = "A cluster of Photon bullets that shred through hordes of enemies.",
		normal = true,
		cost = 6,
		potency = 220,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG1",
		combo = TICRATE*3/5,		-- can be reused after 21 frames on the timer!
		
		-- p: player
		-- timer: how long the animation has played for
		-- hold: if true, button is being held down, if not, it's been released
		-- input: timer on how long the button has been held for
		-- combo: non-zero if the attack was performed from a combo.
					-- useful to create attacks that are faster/different if used repeatedly.
		
		-- return true to end the animation
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1
						
						if combo
							pos[5] = FixedDiv(mo.height, mo.scale)/2
							pos[6] = 0
							
						else	-- we've just started that attack
							local z = FixedDiv(mo.height, mo.scale)
							pos[4] = z
								
							-- set angle
							pos[6] = ANG1*90 -- vert. angle
						end
					end
					
					if timer < 5
					and not combo
						pos[6] = $ - ANG1*20
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					elseif timer == 5
						pos[6] = 0
					end
					
					
					if timer == 9
						pos[6] = ANG1*30
						
						local hb = PSO.lib.spawnHurtBox(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4]*2/3, 255<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_RANGED, TICRATE/2)
						hb.scale = FRACUNIT/8
						hb.destscale = FRACUNIT*2
						hb.pso.locks = 5
						
						P_InstaThrust(hb, p.drawangle, mo.scale*48)

						local range = winfo.range or 512
						hb.fuse = FixedDiv(range*FRACUNIT, FixedHypot(hb.momx, hb.momy))/FRACUNIT
						
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(48, 76)*FRACUNIT)
							bullet.momz = P_RandomRange(-6, 6)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							bullet.color = PSO.info.elementColours[wep.element]
						end
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end

						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
						
					elseif timer > 9 and timer < 13
						pos[6] = $ - ANG1*10
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

PSO.info.photonArts["shotgun_pa_gloriousrain"] = {
		name = "Glorious Rain",
		desc = "A stylish jump above your enemies as your rain down bullets.",
		cost = 25,
		potency = 450,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG4",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle -ANG1*90
					local x = 32*cos(ang)
					local y = 32*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*90	-- lat. angle
					
					if timer == 1

						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
								
						-- set angle
						--pos[6] = -ANG1*90 -- vert. angle
						pos[4] = -9999*FRACUNIT	-- make it invisible
						
						mo.momz = mo.scale*10
						mo.state = S_PLAY_SPRING
						P_InstaThrust(mo, p.drawangle, mo.scale*8)
					end
					
					if timer > 1
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.colorized = true
							g.rollangle = mo.rollangle
						end
						
						mo.momz = max(0, $)
						
						if timer < TICRATE/4 +1
							mo.rollangle = $ + ANG1*20
						end
						
						if timer >= TICRATE/8
						and timer < TICRATE/8 + 10
							pos[4] = mo.height/2
							pos[6] = $ - ANG1*45
						end
						
						if timer == TICRATE/8 + 11
							pos[6] = -ANG1*90
						end
					end
					
					if timer == TICRATE/4 +5
					or timer == TICRATE/2 +5
					or timer == TICRATE*3/4 +5
						
						local hbx = mo.x
						local hby = mo.y 
						local hbz = mo.z - 128*mo.scale
						
						local hb = PSO.lib.spawnHurtBox(hbx, hby, hbz, 320<<FRACBITS, 128<<FRACBITS, mo, potency/3, DMT_RANGED, 4)
						hb.pso.locks = 5
						hb.pso.combobreaker = true
						hb.angle = p.drawangle
						
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(-40, 40)*FRACUNIT)
							bullet.momz = P_RandomRange(-36, -12)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							bullet.color = PSO.info.elementColours[wep.element]
						end
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						
						if timer == TICRATE*3/4 + 5
							mo.state = S_PLAY_ROLL
							mo.rollangle = 0
							mo.momz = $ + mo.scale*4
							return true
						end
						
						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
					end
					/*elseif timer > TICRATE/3 and timer < TICRATE/3 + 4
						pos[6] = $ + ANG1*10
					end*/
					
					/*if timer == TICRATE
						return true
					end*/
				end,
}

PSO.info.photonArts["shotgun_pa_impactrecoil"] = {
		name = "Impact Recoil",
		desc = "Jump and fire a powerful shot that sends both your enemy and yourself away from each other to create distance.",
		cost = 25,
		potency = 355,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SHTG3",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1

						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
								
						-- set angle
						pos[6] = ANG1*90 -- vert. angle
						
						mo.momz = mo.scale*10
						mo.state = S_PLAY_SPRING
					end
					
					if timer < 5
						pos[6] = $ - ANG1*30
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					end
					
					if timer == TICRATE/3
						pos[6] = ANG1*30
						
						local hbx = mo.x + 128*cos(p.drawangle)
						local hby = mo.y + 128*sin(p.drawangle)
						local hbz = mo.z - 128*mo.scale
						
						local hb = PSO.lib.spawnHurtBox(hbx, hby, hbz, 320<<FRACBITS, 80<<FRACBITS, mo, potency, DMT_RANGED, 4, RT_BLOWDOWN)
						hb.pso.locks = 5
						hb.pso.combobreaker = true
						hb.angle = p.drawangle
						
						for i = 1, 16
							local bullet = P_SpawnMobj(mo.x + pos[2], mo.y + pos[3], mo.z + pos[4], MT_PSO_RIFLESHOT)
							bullet.flags = MF_NOGRAVITY|MF_NOCLIPTHING
							bullet.angle = p.drawangle + ANG1*P_RandomRange(-30, 30)
							P_InstaThrust(bullet, bullet.angle, P_RandomRange(48, 76)*FRACUNIT)
							bullet.momz = -mo.scale*32 + P_RandomRange(-6, 6)*FRACUNIT
							bullet.scale = $/3
							bullet.fuse = P_RandomRange(3, 9)
							bullet.color = PSO.info.elementColours[wep.element]
						end
						
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
						
						P_InstaThrust(mo, p.drawangle, -mo.scale*10)
						mo.state = S_PLAY_FALL
						
						-- make the missile fade after it gets out of the range.
						--local range = wep.range or 512
						--msl.fuse = FixedDiv(range*FRACUNIT, FixedHypot(msl.momx, msl.momy))/FRACUNIT
						
					elseif timer > TICRATE/3 and timer < TICRATE/3 + 4
						pos[6] = $ - ANG1*10
					end
					
					if timer == TICRATE
						return true
					end
				end,
}

freeslot("MT_PSO_ZERODISTANCE", "S_PSO_ZERODISTANCE1", "S_PSO_ZERODISTANCE2", "S_PSO_ZERODISTANCE3")
mobjinfo[MT_PSO_ZERODISTANCE] = {
	doomednum = -1,
	spawnstate = S_PSO_ZERODISTANCE1,
	spawnhealth = 1000,
	radius = 1,
	height = 1,
	flags = MF_NOGRAVITY,
}

function A_ZeroDistanceExplosion(actor)
	S_StartSound(actor, sfx_sblst2)
	for i = 1, 32
		local t = P_SpawnMobj(actor.x, actor.y, actor.z - actor.target.height/2, i & 1 and MT_SONIC3KBOSSEXPLODE or MT_THOK)
		t.color = actor.color
		t.scale = actor.scale
		t.destscale = 1
		t.scalespeed = actor.scale/12
		t.momx = P_RandomRange(-16, 16)*actor.scale
		t.momy = P_RandomRange(-16, 16)*actor.scale
		t.momz = P_RandomRange(-16, 16)*actor.scale
		if not (i & 1)
			t.frame = A|TR_TRANS10
			t.fuse = 20
			t.tics = 20	
		end
	end
	
	-- spawn the hitbox
	local h = PSO.lib.spawnHurtBox(actor.x, actor.y, actor.z, 320<<FRACBITS, 192<<FRACBITS, actor.target, actor.potency, DMT_RANGED, 4)
	h.pso.combobreaker = true
	
end

function A_ZeroDistanceCheckRespawn(actor)
	if actor.extravalue1 > 0
		actor.state = S_PSO_ZERODISTANCE1
		actor.extravalue1 = $-1
	end
end

states[S_PSO_ZERODISTANCE1] = {SPR_NULL, A, 1, nil, 0, 0, S_PSO_ZERODISTANCE2}
states[S_PSO_ZERODISTANCE2] = {SPR_NULL, A, TICRATE/3, A_ZeroDistanceExplosion, 0, 0, S_PSO_ZERODISTANCE3}
states[S_PSO_ZERODISTANCE3] = {SPR_NULL, A, 1, A_ZeroDistanceCheckRespawn, 0, 0, S_NULL}

PSO.info.photonArts["shotgun_pa_zerodistance"] = {
		name = "Zero Distance",
		desc = "Fires a devastating close range blast right in front of you. Charge the attack to increase the potency.",
		cost = 30,
		potency = 550,
		speed = 40,
		
		icon = "H_SHTG2",
		
		use = 	function(p, timer, hold, input)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					local chargethreshold = PSO.lib.hasSkill(p, "ra_quickload") and TICRATE*2/3 or TICRATE
					
					--print(timer)
					-- set new weapon pos:
					local ang = p.drawangle - ANG1*30
					local x = 24*cos(ang)
					local y = 24*sin(ang)
					
					pos[2] = x
					pos[3] = y
					pos[5] = ANG1*10	-- lat. angle
					
					if timer == 1
						local z = FixedDiv(mo.height, mo.scale)
						pos[4] = z
							
						-- set angle
						pos[6] = ANG1*90 -- vert. angle
					end
					
					if timer < 5
						pos[6] = $ - ANG1*20
						pos[4] = $ - FixedDiv(mo.height, mo.scale)/10
					elseif timer == 5
						pos[6] = 0
					end
					
					if timer >= 5
					and timer < chargethreshold

						if timer == 5
							S_StartSound(mo, sfx_s3ka3)
						end
						
						-- show the charge...
						local cang = p.drawangle - ANG1*5
						local cx = 50*cos(cang)
						local cy = 50*sin(cang)
						
						if leveltime & 1
							local t = P_SpawnMobj(mo.x + FixedMul(cx, mo.scale), mo.y + FixedMul(cy, mo.scale), mo.z + mo.height*2/3, MT_THOK)
							t.tics = 2
							t.fuse = 2
							t.scale = mo.scale/3
							t.frame = A
							t.color = PSO.info.elementColours[wep.element]
							
							local t2 = P_SpawnMobj(t.x + P_RandomRange(-64, 64)*mo.scale, t.y + P_RandomRange(-64, 64)*mo.scale, t.z + P_RandomRange(-64, 64)*mo.scale, MT_THOK)
							t2.scale = mo.scale/4
							t2.destscale = mo.scale/8
							t2.scalespeed = mo.scale/12
							t2.frame = A
							t2.color = PSO.info.elementColours[wep.element]
							
							t2.momx = (t.x - t2.x)/10
							t2.momy = (t.y - t2.y)/10
							t2.momz = (t.z - t2.z)/10
							
							t2.fuse = 10
							t2.tics = 10
							
						end
					end
					
					if timer >= chargethreshold/3
					and timer < TICRATE*20
					and not hold
						-- just let it go.
						p.pso.actiontimer = TICRATE*30	-- first firing state.
						pos[6] = ANG1*90
						
						local x = 96*cos(p.drawangle)
						local y = 96*sin(p.drawangle)
						
						local zd = P_SpawnMobj(mo.x + x, mo.y + y, mo.z + mo.scale*30, MT_PSO_ZERODISTANCE)
						zd.target = mo
						zd.potency = potency		
						zd.color = PSO.info.elementColours[wep.element]

						if timer >= chargethreshold
							zd.potency = $*3/4
							zd.extravalue1 = 2
						end

						P_InstaThrust(mo, p.drawangle, -16*FRACUNIT)
						p.skidtime = 20
						mo.saveang = p.drawangle
						p.pso.actionspeed = 0	-- remove all cmd prompts.
						p.drawangle = mo.angle
						mo.state = S_PLAY_WALK

						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
					end
					
					-- if we keep holding we'll eventually reach full charge!
					if timer == chargethreshold
						S_StopSound(mo)
						local g = P_SpawnGhostMobj(mo)
						g.destscale = mo.scale*4
						g.scalespeed = mo.scale/12
						S_StartSound(mo, sfx_s3ka8)
					end
					
					if timer >= TICRATE*20
					and timer < TICRATE*20 + 5
						pos[6] = $ - ANG1*10
					elseif timer == TICRATE*21
						return true
					end
					
					
					if timer >= TICRATE*30
					and timer < TICRATE*31
						p.drawangle = mo.saveang
						p.cmd.angleturn = mo.saveang/ANG1
					end	
					
					if timer >= TICRATE*30
					and timer < TICRATE*30 + 10
						pos[6] = $ - ANG1*10
					elseif timer == TICRATE*31
						P_InstaThrust(mo, 0, 0)
						p.drawangle = mo.saveang
						return true
					end
					
					-- hack to prevent us from reaching firing states.
					if p.pso.actiontimer > TICRATE*10
					and p.pso.actiontimer < TICRATE*20	-- if we're past here, don't do it.
						p.pso.actiontimer = TICRATE*10
					end
				end,
		
}