-- Used when the player asks to be healed!

local choices = {
		"PROCEED",
		"CANCEL",
}

local w = 270
local h = 70
local function drawTPMenu(v, p, c, choice, timer)
	
	local x = 160-(w/2)
	local y = 100-(h/2)
	
	v.drawFill(x, y, w, h, 253)
	
	v.drawString(160, y+4, "WARNING!", V_YELLOWMAP, "center")
	v.drawString(160, y+12, "Entering this teleport will", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+20, "prevent you from returning.", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+28, "As such, the quest will fail if", V_ALLOWLOWERCASE, "center")
	v.drawString(160, y+36, "all players become incapacitated.", V_ALLOWLOWERCASE, "center")
	
	local cy = y+50
	for i = 1, #choices
		
		v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i], 0, "center")
		cy = $+10
	end
end

local w2 = 160
local h2 = 32
local function drawWaitMenu(v, p, c, choice, timer)

	local x = 160-(w2/2)
	local y = 100-(h2/2)
		
	if p.mo.tptime	
		
		-- draw countdown!
		local patches = {"H_CNUM3", "H_CNUM2", "H_CNUM1", "H_CNUMG"}
		for i = 1, #patches
			
			local tmr = p.mo.tptime - TICRATE*i
			local pp = v.cachePatch(patches[i])
			
			local scale1 = min(FRACUNIT, tmr*FRACUNIT/4)
			local scale2 = min(FRACUNIT*3, tmr*FRACUNIT/4)
			local tflag1 = 0
			local tflag2 = 5 << V_ALPHASHIFT
			
			if tmr >= TICRATE-10
				tflag1 = min(9, (tmr - (TICRATE-10))) << V_ALPHASHIFT
			end
			
			if tmr > 4
				tflag2 = $ + (tmr/4)<<V_ALPHASHIFT
			end
			
			if tmr >= 0
			and tmr < TICRATE
				v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale1, pp, tflag1)
			end
			
			if tmr >= 0
			and tmr < TICRATE/3
				v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale2, pp, tflag2)
			end
			
		end
	else	-- show how many players are missing
		v.drawFill(x, y, w2, h2, 253)
		
		v.drawString(160, y+4, "WAITING FOR PLAYERS...", V_YELLOWMAP, "center")
		
		local count = 0
		local accepted = 0
		
		for pl in players.iterate do
			
			if pl and pl.mo and pl.mo.valid
				count = $+1
				
				if pl.mo.tpok
					accepted = $+1
				end
				
			end
		end
		
		v.drawString(160, y+12, accepted.."/"..count, 0, "center")
	end
end

freeslot("sfx_cnt1", "sfx_cnt2", "sfx_cnt3", "sfx_cntgo") 

PSO.info.menus["bosstp"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		if p.mo.tpok
			drawWaitMenu(v, p, c, choice, timer)
		else
			drawTPMenu(v, p, c, choice, timer)
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if p.mo.tpok
			
			local count = 0
			local accepted = 0
			
			for pl in players.iterate do
				
				if pl and pl.mo and pl.mo.valid
					count = $+1
					
					if pl.mo.tpok
						accepted = $+1
					end
					
				end
			end	
			
			if accepted >= count
				p.mo.tptime = $ and $+1 or 1
				
				if p.mo.tptime == TICRATE
					S_StartSound(nil, sfx_cnt3, p)
				elseif p.mo.tptime == TICRATE*2
					S_StartSound(nil, sfx_cnt2, p)				
				elseif p.mo.tptime == TICRATE*3
					S_StartSound(nil, sfx_cnt1, p)	
				elseif p.mo.tptime == TICRATE*4
					S_StartSound(nil, sfx_cntgo, p)	
				elseif p.mo.tptime == TICRATE*5
					PSO.lib.softResetPlayer(p)
					p.pso.teleport = 1
					p.pso.teleporttarget = p.pso.teletarget.target
					
					-- the bodies were never found
					if p.pso.teletarget and p.pso.teletarget.valid
						p.pso.teletarget.fuse = 4
					end
					
					if server.questdata	-- happens during testing
						server.questdata.noreturn = true	-- no going back now~
					end
					
					PSO.lib.closeMenu(p)
				end
				
			else
				p.mo.tptime = 0
			end
			return true	-- can't do shit!
		end
		
		if input(p, IPT_CONFIRM) == 1
			
			if p.pso.menu.choice == 1
				S_StartSound(nil, sfx_mconf, p)
				p.mo.tpok = true
			else				
				S_StartSound(nil, sfx_mconf, p)
				PSO.lib.closeMenu(p)
			end
		end
	end,
	
	choices = choices,
}