-- menu used when setting type for the very first time

local type_anim_base = {
	"H_HUF",
	"H_RAF",
	"H_FOF",
}	

local type_anim_duration = {
	141,
	239,
	171,
}

PSO.info.menus["type_set"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		
		local xpos = 52
		local w = 128
		local h = 60
		local ochoice = choice
		
		local curr = choice+2
		if curr > #choices
			curr = $ - #choices
		end	
		
		if not p.pso.real_cgi return end	-- wait 1f
				
		for i = 1, #choices
			
			local ypos = 30 + (#choices-i -1)*10
			v.drawFill(xpos, ypos, 100, 150, 253)
			
			local tt = 1
			if i == 3	-- the last one is the one we have selected
				tt = ((p.pso.real_cgi % type_anim_duration[curr]) +1)
			end
			
			local pp = type_anim_base[curr]..tt
			v.draw(xpos+2, ypos+2, v.cachePatch(pp))
			
			-- draw a fade mostly for the text
			if i == 2
				v.fadeScreen(31, 5)
			end
			
			curr = $-1
			
			if not curr
				curr = #choices
			end
			
			xpos = $ - 16
		end
		
		local classname = PSO.info.typenames[choice]
		
		local arr_l = leveltime%10 < 5 and "< " or "<"
		local arr_r = leveltime%10 < 5 and " >" or ">"
		
		v.drawString(xpos + 50 +16, 20+136, arr_l..classname..arr_r, V_YELLOWMAP, "center")
		
		
		local str = "WELCOME TO SRB2I, SELECT YOUR TYPE!"
		v.drawString(160, 2, str, V_YELLOWMAP, "center")
		
		local desc = PSO.lib.wordWrap(v, PSO.info.typedescs[choice], 180)
		
		local dy = 20
		v.drawString(130, dy, "\x82"..classname, 0)
		v.drawString(130, dy+10, desc, V_ALLOWLOWERCASE|V_RETURN8)
		
		v.drawString(130, dy+60, "\x82".."EQUIPPABLE WEAPONS", 0)
		
		local profs = PSO.info.typestats[choice].weapons
		local wy = dy+70
		
		for i = 0, 31
			local w = profs[2^i]
			if w
				local name = PSO.info.weaponnames[2^i]
				local ico = "H_WICO"..PSO.info.weaponnums[2^i]
				
				v.draw(130+8, wy, v.cachePatch(ico))
				v.drawString(130+18, wy, name)
				wy = $+10
			end
		end
		
		local ty = 140
		local col = leveltime%10 < 5 and V_ORANGEMAP or V_YELLOWMAP
		v.drawString(130, ty, "-TYPE CAN BE CHANGED FREELY", col, "thin")
		v.drawString(130, ty+10, "-CONTROLS CAN BE CHANGED FROM THE MENU,", col, "thin")
		v.drawString(130, ty+18, "  (TOSSFLAG TO OPEN BY DEFAULT)", col, "thin")
		v.drawString(130, ty+28, "-PRESS [F1] FOR HELP & TIPS", col, "thin")
		
		if p.pso.type_confirm
			v.fadeScreen(31, 7)
			
			local win_w = 256
			local win_h = 100
			local win_x = 160 - win_w/2
			local win_y = 100 - win_h/2
			
			v.drawFill(win_x, win_y, win_w, win_h, 253)
			
			v.drawString(160, win_y+2, "CONFIRM SELECTION", V_YELLOWMAP, "center")
			
			v.drawString(160, win_y+12, "Confirm Type selection and", V_ALLOWLOWERCASE, "center")
			v.drawString(160, win_y+20, "receive starting equipment?", V_ALLOWLOWERCASE, "center")
			
			v.drawString(160, win_y+32, "You may change type later at", V_ALLOWLOWERCASE, "center")
			v.drawString(160, win_y+40, "the Type Counter, however,", V_ALLOWLOWERCASE, "center")
			v.drawString(160, win_y+48, "no items will be given on switch.", V_ALLOWLOWERCASE, "center")
			
			local ynchoices = {"PROCEED", "BACK"}
			local cy = win_y + 70
			
			for i = 1, #ynchoices
				
				v.drawString(160, cy, (i == p.pso.type_confirm and "\x82"..">" or "")..ynchoices[i], 0, "center")
				cy = $+10
			end
		end
		
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		--if input(p, IPT_CONFIRM) == 1
		
		p.pso.real_cgi = $ or 1
		
		if input(p, "left") == 1
		and not p.pso.type_confirm
			p.pso.menu.choice = $-1
			if p.pso.menu.choice < p.pso.menu.minchoice
				p.pso.menu.choice = p.pso.menu.maxchoice
			end
			
			p.pso.real_cgi = 1
			
			S_StartSound(nil, sfx_mhvr, p)
		
		elseif input(p, "right") == 1
		and not p.pso.type_confirm
			p.pso.menu.choice = $+1
			if p.pso.menu.choice > p.pso.menu.maxchoice
				p.pso.menu.choice = p.pso.menu.minchoice
			end
			
			p.pso.real_cgi = 1
			
			S_StartSound(nil, sfx_mhvr, p)
		
		elseif (input(p, "up") == 1 or input(p, "down") == 1)
		and p.pso.type_confirm
			p.pso.type_confirm = (p.pso.type_confirm == 1 and 2 or 1)
			S_StartSound(nil, sfx_mhvr, p)
		
		elseif input(p, IPT_BACK) == 1
		and p.pso.type_confirm
			S_StartSound(nil, sfx_mback, p)
			p.pso.type_confirm = nil
		
		elseif input(p, IPT_CONFIRM) == 1
			if not p.pso.type_confirm
				p.pso.type_confirm = 1
				S_StartSound(nil, sfx_mconf, p)
				
			elseif p.pso.type_confirm == 1	-- ok
				S_StartSound(nil, sfx_mconf, p)
				
				PSO.lib.playerChangeType(p, p.pso.menu.choice)	-- set new type and stats
				PSO.lib.initPlayerType(p, p.pso.menu.choice)
				
				p.pso.type_initialized = true
				PSO.lib.closeMenu(p)
				
			elseif p.pso.type_confirm == 2
				S_StartSound(nil, sfx_mback, p)
				p.pso.type_confirm = nil
			end
		end
		
		
		p.pso.real_cgi = $+1
		
		return true
	end,
	
	choices = {
		{"Hunter", TYPE_HUNTER},
		{"Ranger", TYPE_RANGER},
		{"Force", TYPE_FORCE},
	},
}