-- Main pause menu

local mainchoices = {
		{"Items", "inventory"},
		{"Status", "status"},
		{"Map", "map"},
		{"Quest", "mission"},
		{"Social", "social"},
		{"Options", "options"},
}

-- separated because it's used by other menus
rawset(_G, "drawMainMenu", function(v, p, c, choice, timer)
	local choices = mainchoices
	for i = 1, #choices
			
		local targetxpos = 2 + 18*(i-1)
		v.draw(min(targetxpos, timer*10), 2, v.cachePatch("H_MMENU"..i), V_SNAPTOTOP|V_SNAPTOLEFT)
			
		if i == choice
			v.draw(min(targetxpos, timer*10), 2, v.cachePatch("H_MMENU0"), V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
		
	local sx = 2 + 18*(#choices)
	mainchoices[1][1] = "Items ("..#p.pso.inventory.."/"..PSO.info.INVENTORYSIZE..")"
	v.drawString(sx, 2, "\x82"..choices[choice][1], V_SNAPTOTOP|V_SNAPTOLEFT)
	
	-- draw amount of meseta
	v.draw(sx, 10, v.cachePatch("H_MST"), V_SNAPTOTOP|V_SNAPTOLEFT)
	v.drawString(sx + 10, 10, "\x82"..PSO.lib.numCommas(p.pso.meseta), V_SNAPTOTOP|V_SNAPTOLEFT)
end)

PSO.info.menus["main"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, choice, timer)
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end
	end,
	
	choices = mainchoices,
	inputtype = 1,
}


-- some local states for sanity check...
local IST_GENERAL = 1
local IST_PALETTE = 2
local IST_ACTIONS = 3
local IST_UNITS = 4
local IST_DROPYN = 5
local IST_STOREYN = 6
local IST_USE = 7

PSO.info.menus["inventory"] = {
	
	openfunc = function(p)
		p.pso.hidehud = true
		p.pso.inventorysection = 1
		
		p.pso.inventorystate = 0
		p.pso.inventorychoice = 1
		
		p.pso.itmsg = nil
		
		-- set the initial menu bounds:
		p.pso.menu.minchoice = p.pso.inventory_sections[1]
		p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso.inventory_sections[2] -1)
		
		PSO.lib.playerFixUnits(p)
	end,
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 1, 999)
		
		-- old variables still used by the code below
		local xpos = 2
		local w = 178
		local y = 34		
		local sx = xpos + 14		
		local y2 = 114
		
		-- EQUIP / REMOVE UNITS (god this code sucks)
		if p.pso.inventorystate == IST_UNITS

			y = 21
			y2 = y + 70 + 2
			
			local selected = p.pso.inventory[p.pso.menu.choice][1]
			-- select action to remap on weapon:
			v.drawFill(xpos, y, w, 70, 253|V_SNAPTOLEFT)
			v.drawString(xpos+2, y+2, "SELECT UNIT SLOT", V_YELLOWMAP|V_SNAPTOLEFT)
			
			local ay = y+18
			local selectunit_top
			if p.pso.replaceunit
				selectunit_top = p.pso.replaceunit
			else
				selectunit_top = p.pso.inventorychoice
			end
			
			for i = 1, PSO.info.items[selected.ref].slots+1
					
				local dta = selected.slots[i]	--p.pso.inventoryunits[i]
				if i == PSO.info.items[selected.ref].slots+1
					dta = {name = "CHECK STATS TOTAL"}
				end
				
				local ico
				local str = "---"
				local ymap = (( i == selectunit_top ) and V_YELLOWMAP or 0)
				
				if dta
					str = dta.name
				end
					
				v.drawString(xpos + 2, ay, str, V_ALLOWLOWERCASE|V_SNAPTOLEFT|ymap)
				ay = $+10
			end

			
			local unit = selected.slots[selectunit_top]
			
			local w2 = 320 - xpos - w - 2
			v.drawFill(xpos+w, y, w2, 70, 253|V_SNAPTOLEFT)
					
			v.drawFill(xpos+w -1, y+1, 2, 68, 27|V_SNAPTOLEFT)
			v.drawFill(xpos+w -1, y+1, 1, 67, 0|V_SNAPTOLEFT)
			
			local stats = {"hp", "pp", "satk", "ratk", "tatk", "ppregen"}
			local statnames = {"HP", "PP", "S-ATK", "R-ATK", "T-ATK", "PP REGEN"}
			
			if selectunit_top == PSO.info.items[selected.ref].slots+1
				-- total up all of our units' stats...
				local totals = {}
				
				for i = 1, PSO.info.items[selected.ref].slots
					
					local tunit = selected.slots[i]
					if tunit
						for j = 1, #stats
							totals[stats[j]] = $ or 0
							totals[stats[j]] = $ + (tunit[stats[j]] or 0)
						end
					end
				end
				
				-- now do the display
				for i = 1, #stats
					
					v.drawString(xpos+2+w, y+2+(i-1)*8, "\x82"..statnames[i]..":", V_SNAPTOLEFT)
					
					local stat = totals[stats[i]] or 0
					local str = ""
					
					if stat > 0
						str = "\x85".."+"..stat
					elseif stat < 0
						str = "\x84".."-"..stat
					else
						str = stat
					end
					
					v.drawString(xpos+2+w + 85, y+2+(i-1)*8, str, V_SNAPTOLEFT)
				end
				
			elseif unit

				for i = 1, #stats
					
					v.drawString(xpos+2+w, y+2+(i-1)*8, "\x82"..statnames[i]..":", V_SNAPTOLEFT)
					
					local stat = unit[stats[i]] or 0
					local str = ""
					
					if stat > 0
						str = "\x85".."+"..stat
					elseif stat < 0
						str = "\x84".."-"..stat
					else
						str = stat
					end
					
					v.drawString(xpos+2+w + 85, y+2+(i-1)*8, str, V_SNAPTOLEFT)
				end
			else
				v.drawString(xpos + w + 2, y+20, "N/A", V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
			end
			
			if p.pso.inventoryunits
				
				v.drawFill(xpos, y2, w, 100, 253|V_SNAPTOLEFT)
				v.drawString(xpos+2, y2+2, "SELECT NEW UNIT", V_YELLOWMAP|V_SNAPTOLEFT)
				
				local ay = 20+70+16
				for i = p.pso.inventoryscroll+1, min(#p.pso.inventoryunits, p.pso.inventoryscroll+7)	--#p.pso.inventoryunits
					
					local a = p.pso.inventoryunits[i]

					if a ~= -1
					
						local dta = PSO.info.items[a.ref]
						local str = dta.name
						local tflag = 0
						
						-- is the unit already equipped?
						if dta.rarity > selected.rarity
							v.draw(xpos+2, ay, v.cachePatch("H_NEQ"), V_SNAPTOLEFT)
							tflag = V_50TRANS
						end
						
						for j = 1, PSO.info.items[selected.ref].slots
							if selected.slots[j] == a
								v.draw(xpos+2, ay, v.cachePatch("H_EQ"), V_SNAPTOLEFT)
								break
							end
						end
						
						local pname = "H_STAR"..((dta.rarity-1)/3 +1)
						v.draw(xpos+2+10, ay, v.cachePatch(pname), V_SNAPTOLEFT)
								
						v.draw(xpos+22, ay, v.cachePatch("H_IICO3"..(i == p.pso.inventorychoice and "2" or "")), V_SNAPTOLEFT|tflag)
						v.drawString(xpos+32, ay, str, (i == p.pso.inventorychoice and V_YELLOWMAP or 0)|V_SNAPTOLEFT|V_ALLOWLOWERCASE|tflag)
					else
						v.drawString(xpos+24, ay, "REMOVE", (i == p.pso.inventorychoice and V_YELLOWMAP or 0)|V_SNAPTOLEFT|V_ALLOWLOWERCASE)
					end
					ay = $+12
				end

				local w2 = 320 - xpos - w - 2
				v.drawFill(xpos+w, y2, w2, 100, 253|V_SNAPTOLEFT)
					
				v.drawFill(xpos+w -1, y2+1, 2, 98, 27|V_SNAPTOLEFT)
				v.drawFill(xpos+w -1, y2+1, 1, 97, 0|V_SNAPTOLEFT)
				
				local unit = p.pso.inventoryunits[p.pso.inventorychoice]

				if unit and unit ~= -1
					local stats = {"hp", "pp", "satk", "ratk", "tatk", "ppregen"}
					local statnames = {"HP", "PP", "S-ATK", "R-ATK", "T-ATK", "PP REGEN"}
					
					for i = 1, #stats
						
						v.drawString(xpos+2+w, y2+2+(i-1)*8, "\x82"..statnames[i]..":", V_SNAPTOLEFT)
						
						local stat = unit[stats[i]]
						local str = ""
						
						if stat > 0
							str = "\x85".."+"..stat
						elseif stat < 0
							str = "\x84".."-"..stat
						else
							str = stat
						end
						
						v.drawString(xpos+2+w + 85, y2+2+(i-1)*8, str, V_SNAPTOLEFT)
					end
				else
					v.drawString(xpos + w + 2, y2+20, "Remove unit", V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
				end		
			end
		
		
		-- EQUIP / REMOVE ACTIONS (god this code sucks too...)
		elseif p.pso.inventorystate == IST_ACTIONS
			
			y = 21
			y2 = y + 70 + 2
			
			local selected = p.pso.inventory[p.pso.menu.choice][1]
			-- select action to remap on weapon:
			v.drawFill(xpos, y, w, 70, 253|V_SNAPTOLEFT)
			v.drawString(xpos+2, y+2, "SELECT ACTION", V_YELLOWMAP|V_SNAPTOLEFT)
			
			-- if we're in this state, selected is always going to be a weapon
			local hand = PSO.info.weaponHand[selected.weapontype]
			local ay = y+18
			
			local selectedart_top
			if p.pso.replaceaction
				selectedart_top = p.pso.replaceaction
			else
				selectedart_top = p.pso.inventorychoice
			end
			
			for i = 1, (hand == HAND_BOTH and 4 or 2)
					
				local bt = PSO.lib.playerButtonIcon(p, IPT_ATTACK + (i-1)%2, true)
				local dta = PSO.info.photonArts[selected.actions[i]]
				local ico
				local str = "---"
				local ymap = (( i == selectedart_top ) and V_YELLOWMAP or 0)
					
				if dta
					ico = v.cachePatch(dta.icon)
					str = dta.name
				end
					
				if ico
					v.draw(xpos + 64 - 13, ay-3, ico, V_SNAPTOLEFT)
				end
				v.drawString(xpos + 64, ay, str, V_ALLOWLOWERCASE|V_SNAPTOLEFT|ymap)
					
				v.draw(xpos + 32, ay-3, v.cachePatch(bt), V_SNAPTOLEFT)
				if i > 2
					local bt2 = PSO.lib.playerButtonIcon(p, IPT_SECONDPALETTE, true)
					v.draw(xpos + 8, ay-3, v.cachePatch(bt2), V_SNAPTOLEFT)
					v.drawString(xpos + 25, ay-1, "+", V_ALLOWLOWERCASE|V_SNAPTOLEFT|ymap)
				end
					
				ay = $+12
			end			
			
			local art = PSO.info.photonArts[selected.actions[selectedart_top]]
			
			local w2 = 320 - xpos - w - 2
			v.drawFill(xpos+w, y, w2, 70, 253|V_SNAPTOLEFT)
					
			v.drawFill(xpos+w -1, y+1, 2, 68, 27|V_SNAPTOLEFT)
			v.drawFill(xpos+w -1, y+1, 1, 67, 0|V_SNAPTOLEFT)
			
			if art
				local pow = (art.potency or "---").."%"
				local cost = (art.cost or 0).." PP"
					
				v.drawString(xpos + w + 2, y+2, "\x82".."POTENCY: \x80"..pow.."\x82\n".."COST: \x80"..cost, V_RETURN8|V_SNAPTOLEFT)
				
				local desc = PSO.lib.wordWrap(v, art.desc or "", w2-8, V_ALLOWLOWERCASE, "thin")
				v.drawString(xpos + w + 2, y+20, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
			else
				v.drawString(xpos + w + 2, y+20, "N/A", V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
			end
			
			if p.pso.actionlist
				
				v.drawFill(xpos, y2, w, 100, 253|V_SNAPTOLEFT)
				v.drawString(xpos+2, y2+2, "SELECT NEW ACTION", V_YELLOWMAP|V_SNAPTOLEFT)
				
				local ay = 20+70+16
				for i = p.pso.inventoryscroll+1, min(#p.pso.actionlist, p.pso.inventoryscroll+7)
					
					local a = p.pso.actionlist[i]
					
					local dta = PSO.info.photonArts[a]
					local str
					
					if dta
						str = dta.name
						if dta.icon
							v.draw(xpos + 2, ay-2, v.cachePatch(dta.icon), V_SNAPTOLEFT)
						end
					else
						str = "REMOVE"
					end
					
					v.drawString(xpos+18, ay, str, (i == p.pso.inventorychoice and V_YELLOWMAP or 0)|V_SNAPTOLEFT|V_ALLOWLOWERCASE)
					
					ay = $+12
				end
				
				-- desc
				
				local art = PSO.info.photonArts[p.pso.actionlist[p.pso.inventorychoice]]
				local w2 = 320 - xpos - w - 2
				v.drawFill(xpos+w, y2, w2, 100, 253|V_SNAPTOLEFT)
					
				v.drawFill(xpos+w -1, y2+1, 2, 98, 27|V_SNAPTOLEFT)
				v.drawFill(xpos+w -1, y2+1, 1, 97, 0|V_SNAPTOLEFT)
				
				if art
					local pow = (art.potency or "---").."%"
					local cost = (art.cost or 0).." PP"
					
					v.drawString(xpos + w + 2, y2+2, "\x82".."POTENCY: \x80"..pow.."\x82\n".."COST: \x80"..cost, V_RETURN8|V_SNAPTOLEFT)
					
					local desc = PSO.lib.wordWrap(v, art.desc or "", w2-8, V_ALLOWLOWERCASE, "thin")
					v.drawString(xpos + w + 2, y2+20, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")	
				else
					v.drawString(xpos + w + 2, y2+20, "Remove art", V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")	
				end
				
			end
		else
		
			-- we still have to compute that here
			local where = "inventory"
			local sect = where.."_sections"
			local tab = p.pso.inventorysection
			local scroll = p.pso.menu.scroll
			
			local start = p.pso[sect][tab] + scroll
			local finish = p.pso[sect][tab+1] or #p.pso[where]
			
			-- use the refactored func:
			PSO.lib.HUDDrawInventory(v, p, "inventory", tab, p.pso.menu.choice, scroll)

			if p.pso.itmsg
				v.drawFill(xpos + w + 2, 20, 320 - xpos - w - 2 - 2, 28, 253|V_SNAPTOLEFT)
				v.drawString(xpos + w + 8, 24, "\x82".."INFO:\n"..p.pso.itmsg, V_SNAPTOLEFT)
			end
			
			local slot = p.pso.inventory[p.pso.menu.choice]
			local selected
			local info
			
			if slot and start ~= finish
				selected = p.pso.inventory[p.pso.menu.choice][1]
				
				--  context menu (use/drop/equip.....)
				if (p.pso.inventorystate == IST_GENERAL or p.pso.inventorystate == IST_DROPYN or p.pso.inventorystate == IST_STOREYN)
				and p.pso.inventorychoices
					
					local extray = 0
					local drawqty
					
					if p.pso.inventorystate == IST_DROPYN
					or p.pso.inventorystate == IST_STOREYN
						if type(selected) == "string"
							drawqty = true
						end
						extray = $+10
					end
					
					if drawqty
						v.drawFill(xpos + w + 2, 20, 320 - xpos - w - 2 - 2, 2*10 +8 + extray, 253|V_SNAPTOLEFT)
						v.drawString(xpos + w + 8, 24, "\x82".."HOW MANY?", V_SNAPTOLEFT)
						
						local arr1 = leveltime%10 < 5 and "<" or "< "
						local arr2 = leveltime%10 < 5 and ">" or " >"
						v.drawString(xpos+w+2 + (320 - xpos - w - 2 - 2)/2, 30 + extray, arr1..p.pso.inventoryqty..arr2, V_SNAPTOLEFT, "center")
						
					else
						v.drawFill(xpos + w + 2, 20, 320 - xpos - w - 2 - 2, #p.pso.inventorychoices*10 +8 + extray, 253|V_SNAPTOLEFT)
						if extray
							if p.pso.inventorystate == IST_DROPYN
								v.drawString(xpos + w + 8, 24, "\x82".."DROP ITEM?", V_SNAPTOLEFT)
							elseif p.pso.inventorystate == IST_STOREYN
								v.drawString(xpos + w + 8, 24, "\x82".."SEND TO STORAGE?", V_SNAPTOLEFT)
							end
						end
						local oy = 24 + extray
						for i = 1, #p.pso.inventorychoices
							
							local yel = (p.pso.inventorychoice == i)
							local stflag = (p.pso.inventorychoices[i][2] == 0 and V_50TRANS or 0)
							v.drawString(xpos + w + 8, oy, (yel and "\x82>" or "")..p.pso.inventorychoices[i][1], V_SNAPTOLEFT|stflag)
							oy = $+10
						end
					end
				
				elseif p.pso.inventorystate == IST_PALETTE
				and p.pso.inventorypalx	-- make sure this is set.
				
					-- oh mama
					local pal = p.pso.palette.layout
					local px = xpos + w + 4
					local sy = 10
					
					for col = 1, #pal
						local py = sy
						local cw = col == 2 and 32 or 16
						local tflag = (col ~= p.pso.inventorypalx) and V_80TRANS or 0
						
						for lin = 1, PSO.info.MAXPALSIZE
							
							v.drawFill(px, py, cw, 16, 253|V_SNAPTOLEFT)
							
							local it = pal[col][lin]
							if type(it) == "string"	-- that's a consumable
								local ico = v.cachePatch(PSO.info.items[it].paletteico or "what")
								if (it ~= selected or leveltime%10 < 5)
									v.draw(px, py, ico, V_SNAPTOLEFT|tflag)
								end
							
							elseif type(it) == "table"
								
								if it[1] or it[2]	-- this is a weapon... but it could be two weapons.
									for i = 1, 2
										local t_it = it[i]
										if not t_it continue end	-- skip if it doesn't exist.
										
										local info = PSO.info.items[t_it.ref]
										
										if info.type == IT_WEAPON
										and (t_it ~= selected or leveltime%10 < 5)
											local col = PSO.info.elementColours[t_it.element]
											local ico = PSO.info.weaponToIcon[t_it.weapontype]
											
											v.draw(px, py, v.cachePatch(ico or "what"), V_SNAPTOLEFT|tflag, v.getColormap(TC_DEFAULT, col))
										end
									end
								elseif it.type == IT_ARMOR	-- it's an armor
									
									local col = PSO.info.elementColours[it.element]
									local ico = "H_ARMR"
									
									if (it ~= selected or leveltime%10 < 5)
										v.draw(px, py, v.cachePatch(ico), V_SNAPTOLEFT|tflag, v.getColormap(TC_DEFAULT, col))
									end
								end
							end
								
							if col == p.pso.inventorypalx
							and lin == p.pso.inventorypaly
								
								if p.pso.inventorygslot
								and col == 2
								and p.pso.palette.layout[col][lin]
								and PSO.lib.slotIsOneHanded(p.pso.palette.layout[col][lin])
									local offsx = p.pso.inventorygslot == 2 and 16 or 0
									v.draw(px+offsx, py, v.cachePatch("H_MMENU0"), V_SNAPTOLEFT)
								else
									v.draw(px, py, v.cachePatch(col == 2 and "H_MMENUA" or "H_MMENU0"), V_SNAPTOLEFT)
								end
							end
							
							py = $+16+1
						end
						px = $+cw+1
					end
					
					if p.pso.grinderref
						local name = PSO.lib.getItemName(p.pso.grinderref)
						v.drawString(xpos+w+4, sy+(16*PSO.info.MAXPALSIZE)+4, name, V_SNAPTOLEFT|V_ALLOWLOWERCASE)
					end
				end
			end
		end
	end,
	
	runfunc = function(p, choices, choice, timer)
		
		local input = PSO.lib.playerInputDown
		local maxs = 3

		local start = p.pso.inventory_sections[p.pso.inventorysection]
		local finish = p.pso.inventory_sections[p.pso.inventorysection+1] or #p.pso.inventory
		
		local slot = p.pso.inventory[p.pso.menu.choice]
		local selected
		local info
		
		if slot and start ~= finish
			selected = slot[1]
			if type(selected) == "string"
				info = PSO.info.items[selected]
			else
				info = PSO.info.items[selected.ref]
			end
			
			-- inventory confirmation prompts
			if p.pso.inventorystate == IST_GENERAL			
				-- build up the choices list..
				local opts = {}
				local equipped
				if type(selected) == "table"
					equipped = selected.equipped
				end
				
				if info.type == IT_WEAPON
					opts = {
						{"Add to palette", PSO.lib.canEquip(p, selected) and IST_PALETTE or 0},
						{"Change Actions", IST_ACTIONS},			
						{"Send to Storage", not equipped and IST_STOREYN or 0},				
						{"Drop", not equipped and IST_DROPYN or 0},
						{"Back", -1},
					}
				
				elseif info.type == IT_ARMOR
					
					-- check if the armor has slots:
					local unitmenu = IST_UNITS
					local canstore = true
					
					if not info.slots
						unitmenu = 0
					else
						-- hack: consider item as equipped if it has units on.
						-- (so it can't be dropped or stored)
						for i = 1, info.slots
							if selected.slots[i]
								equipped = true
								break
							end
						end
					end
					
					opts = {
						{"Add to palette", PSO.lib.canEquip(p, selected) and IST_PALETTE or 0},
						{"Add units", unitmenu},
						{"Send to Storage", not equipped and IST_STOREYN or 0},
						{"Drop", not equipped and IST_DROPYN or 0},
						{"Back", -1},
					}
				
				elseif info.type == IT_UNIT
					opts = {
						{"Send to Storage", not equipped and IST_STOREYN or 0},				
						{"Drop", not equipped and IST_DROPYN or 0},
						{"Back", -1},
					}
				
				elseif info.type == IT_CONSUMABLE
					local usetype = IST_USE
					if info.canuse and not info.canuse(p)
					or not info.use
						usetype = 0
					end
					
					if info.grinder
						usetype = IST_PALETTE
					end
					
					opts = {
						{"Use", usetype},
						{"Add to palette", info.paletteico and IST_PALETTE or 0},
						{"Send to Storage", IST_STOREYN},
						{"Drop", IST_DROPYN},
						{"Back", -1},
					}
				end
				
				p.pso.inventorychoices = opts
			
				local minchoice = 1
				local maxchoice = #opts
				
				-- thing for using items to avoid spamusing them
				if not input(p, IPT_CONFIRM)
					p.pso.inventoryletgo = nil
				end
				
				if input(p, IPT_BACK) == 1
				or (input(p, IPT_CONFIRM) == 1 and opts[p.pso.inventorychoice][2] == -1)
					p.pso.inventorystate = 0
					p.pso.inventorychoices = nil
					S_StartSound(nil, sfx_mback, p)
				
				elseif input(p, "down") == 1
					p.pso.inventorychoice = $+1
					
					if p.pso.inventorychoice > maxchoice
						p.pso.inventorychoice = minchoice
					end
					S_StartSound(nil, sfx_mhvr, p)
				
				elseif input(p, "up") == 1
					p.pso.inventorychoice = $-1
					
					if p.pso.inventorychoice < minchoice
						p.pso.inventorychoice = maxchoice
					end
					S_StartSound(nil, sfx_mhvr, p)
				
				elseif input(p, IPT_CONFIRM) == 1
				and not p.pso.inventoryletgo
					
					local opt = opts[p.pso.inventorychoice][2]
					if not opt
						S_StartSound(nil, sfx_mnot, p)
						return true
					end
					
					S_StartSound(nil, sfx_mconf, p)
					
					p.pso.inventorystate = opt
					p.pso.inventorychoice = 1
					
					-- unset those to be sure.
					p.pso.inventoryscroll = 0	-- for some menus
					p.pso.inventoryqty = 1
					p.pso.inventorypalx = 0
					p.pso.inventorypaly = 1
					p.pso.inventorygslot = nil
					p.pso.grinderref = nil
					
					-- action slot we're currently trying to replace
					p.pso.replaceaction = nil
					
					p.pso.replaceunit = nil
				end
					
				return true
			
			elseif p.pso.inventorystate == IST_UNITS

			
				-- allow selecting the actions we want to change
				local maxchoice = info.slots+1
				
				if p.pso.inventoryunits
					maxchoice = #p.pso.inventoryunits
				end

				local minchoice = 0
				local scrollstart = 0
				local maxscroll = 0
				local scrollback = 0
				local scroll = 7
				
				-- build scroll info if we need to.
				if scroll and (maxchoice - (minchoice-1)) > scroll
					scrollstart = minchoice + scroll/2
					scrollback = maxchoice - scroll/2
					maxscroll = (maxchoice - (minchoice-1)) - scroll
				end
				
				if input(p, "up") == 1
					p.pso.inventorychoice = $-1
					
					if p.pso.inventorychoice < scrollback
					and (p.pso.inventorychoice > scrollstart or p.pso.inventoryscroll)
						p.pso.inventoryscroll = max(0, $-1)
					end
				
					
					if not p.pso.inventorychoice
						p.pso.inventorychoice = maxchoice
						p.pso.inventoryscroll = maxscroll
					end
					S_StartSound(nil, sfx_mhvr, p)
					
				elseif input(p, "down") == 1
					p.pso.inventorychoice = $+1
					
					if p.pso.inventorychoice > scrollstart
						p.pso.inventoryscroll = min(maxscroll, $+1)
					end
				
					if p.pso.inventorychoice > maxchoice
						p.pso.inventorychoice = 1
						p.pso.inventoryscroll = 0
					end
					S_StartSound(nil, sfx_mhvr, p)
				
				elseif input(p, IPT_BACK) == 1
					
					if p.pso.replaceunit
						p.pso.inventorychoice = p.pso.replaceunit
						p.pso.replaceunit = nil
						p.pso.inventoryunits = nil
						
					else
						PSO.lib.playerFixUnits(p)	-- bruhification
						p.pso.inventorychoice = 1
						p.pso.inventorystate = IST_GENERAL
					end
					S_StartSound(nil, sfx_mback, p)
				
				elseif input(p, IPT_CONFIRM) == 1
					
					if not p.pso.replaceunit
					
						-- do nothing, this option is to check the stats total
						if p.pso.inventorychoice == maxchoice
							return true
						end
					
						p.pso.replaceunit = p.pso.inventorychoice
						p.pso.inventorychoice = 1
						-- make a list of units...
						p.pso.inventoryunits = {}
						for i = 1, #p.pso.inventory
								
							local it = p.pso.inventory[i][1]
							if type(it) == "table"
							and it.type == IT_UNIT
								p.pso.inventoryunits[#p.pso.inventoryunits+1] = it
							end
						end
						
						p.pso.inventoryunits[#p.pso.inventoryunits+1] = -1	-- unequip
					else
						
						-- ok now we try to equip the unit...
						local unequip = p.pso.inventorychoice == #p.pso.inventoryunits
						
						if not unequip
							
							local unit = p.pso.inventoryunits[p.pso.inventorychoice]
							local unitinfo = PSO.info.items[unit.ref]
							
							unit.equippedarmours = $ and $ or 0	-- keep track of how many armours we're on...
							
							-- check if the unit can be equipped...
							if unitinfo.rarity > info.rarity	-- armour rarity too low!
								S_StartSound(nil, sfx_mnot, p)
								return true
							end
							
							-- unit was already equipped on that armour?
							for i = 1, info.slots
								if selected.slots[i] == unit
									unit.equippedarmours = $-1
									selected.slots[i] = nil	-- remove that
									-- don't care about unsetting equipped since we're putting it back.
								end
							end
							
							-- put the unit on!
							selected.slots[p.pso.replaceunit] = unit
							unit.equipped = true	-- unit is now equipped.
							unit.equippedarmours = $+1	
							
							-- update player stats
							PSO.lib.playerCalcStats(p, p.pso.level)
						else
							
							local unit = selected.slots[p.pso.replaceunit]
							
							if not unit
								S_StartSound(nil, sfx_mnot, p)
								return true
							end
							
							unit.equippedarmours = $-1
							selected.slots[p.pso.replaceunit] = nil
							
							if not unit.equippedarmours
								unit.equipped = nil
							end
							
							-- update player stats
							PSO.lib.playerCalcStats(p, p.pso.level)
						end
						
						p.pso.inventorychoice = p.pso.replaceunit
						p.pso.inventoryunits = nil
						p.pso.replaceunit = nil
					end	
					p.pso.inventoryscroll = 0
				end
				
				return true
			
			elseif p.pso.inventorystate == IST_ACTIONS
			
				-- allow selecting the actions we want to change
				local maxchoice = 4
				
				if p.pso.actionlist
					maxchoice = #p.pso.actionlist
				else
					local hand = PSO.info.weaponHand[selected.weapontype]
					if hand ~= HAND_BOTH
						maxchoice = 2
					end
				end
				
				local minchoice = 0
				local scrollstart = 0
				local maxscroll = 0
				local scrollback = 0
				local scroll = 7
				
				-- build scroll info if we need to.
				if scroll and (maxchoice - (minchoice-1)) > scroll
					scrollstart = minchoice + scroll/2
					scrollback = maxchoice - scroll/2
					maxscroll = (maxchoice - (minchoice-1)) - scroll
				end
				
				if input(p, "up") == 1
					p.pso.inventorychoice = $-1
					
					if p.pso.inventorychoice < scrollback
					and (p.pso.inventorychoice > scrollstart or p.pso.inventoryscroll)
						p.pso.inventoryscroll = max(0, $-1)
					end
				
					
					if not p.pso.inventorychoice
						p.pso.inventorychoice = maxchoice
						p.pso.inventoryscroll = maxscroll
					end
					S_StartSound(nil, sfx_mhvr, p)
					
				elseif input(p, "down") == 1
					p.pso.inventorychoice = $+1
					
					if p.pso.inventorychoice > scrollstart
						p.pso.inventoryscroll = min(maxscroll, $+1)
					end
				
					if p.pso.inventorychoice > maxchoice
						p.pso.inventorychoice = 1
						p.pso.inventoryscroll = 0
					end
					S_StartSound(nil, sfx_mhvr, p)
				
				elseif input(p, IPT_CONFIRM) == 1
					
					S_StartSound(nil, sfx_mconf, p)
					
					if p.pso.actionlist
						
						local unequip = p.pso.inventorychoice == #p.pso.actionlist
						
						if not unequip
							selected.actions[p.pso.replaceaction] = p.pso.actionlist[p.pso.inventorychoice]	
						else
							selected.actions[p.pso.replaceaction] = nil
						end
						
						p.pso.inventorychoice = p.pso.replaceaction	-- reset cursor
						p.pso.actionlist = nil
						p.pso.replaceaction = nil
					else
						p.pso.replaceaction = p.pso.inventorychoice
						p.pso.inventorychoice = 1
						-- get the list of PAs for that weapon...
						p.pso.actionlist = {}
						
						local index = selected.weapontype
						local list = PSO.info.weaponPhotonArts[index]
						if not list
							index = "techniques"
							list = PSO.info.weaponPhotonArts.techniques
						end
						
						for i = 1, #list
							
							local pa = list[i]
							if (p.pso.photonarts[index] & (2^(i-1)))
								p.pso.actionlist[#p.pso.actionlist+1] = pa
							end
						end
						
						p.pso.actionlist[#p.pso.actionlist+1] = -1	-- remove
					end
				elseif input(p, IPT_BACK) == 1
					S_StartSound(nil, sfx_mback, p)
					
					if p.pso.actionlist
						-- cancel 
						p.pso.inventorychoice = p.pso.replaceaction
						p.pso.actionlist = nil
						p.pso.replaceaction = nil
					else
						-- go back to IST_GENERAL
						p.pso.inventorystate = IST_GENERAL
						p.pso.inventorychoice = 1
					end
					
				end
				
				
				return true
			
			elseif p.pso.inventorystate == IST_DROPYN
			or p.pso.inventorystate == IST_STOREYN
				
					local opts = {
						{"Yes", IST_PALETTE},
						{"No", IST_GENERAL},							
					}
					
					p.pso.inventorychoices = opts
					
					-- set item qty with up/down
					if type(selected) == "string"
						p.pso.inventorychoice = 1	-- force it to "yes"
						if p.pso.inventory[p.pso.menu.choice][2] and p.pso.inventory[p.pso.menu.choice][2] > 1
							if input(p, "left") == 1 or input(p, "right") > TICRATE/2
								p.pso.inventoryqty = $-1
								if not p.pso.inventoryqty
									p.pso.inventoryqty = p.pso.inventory[p.pso.menu.choice][2]
								end	
								
								S_StartSound(nil, sfx_mhvr, p)
								
							elseif input(p, "right") == 1 or input(p, "right") > TICRATE/2
								p.pso.inventoryqty = $+1
								if p.pso.inventoryqty > p.pso.inventory[p.pso.menu.choice][2]
									p.pso.inventoryqty = 1
								end	
								
								S_StartSound(nil, sfx_mhvr, p)			

							end
						end
					else	-- select yes/no
						p.pso.inventoryqty = nil
						if input(p, "up") == 1 or input(p, "down") == 1
							p.pso.inventorychoice = 1 and 2 or 1	-- just swap
							S_StartSound(nil, sfx_mhvr, p)
						end
					end
					
					if input(p, IPT_CONFIRM) == 1
					and p.pso.inventorychoice == 1
						
						S_StartSound(nil, sfx_mconf, p)
						
						-- drop item:
						if p.pso.inventorystate == IST_DROPYN
							local drop = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_PSO_DROP)
							--drop.psoitems = {nil, "trimate"}
							drop.psoitem = selected	-- global drop
							drop.psoqty = p.pso.inventoryqty
							PSO.lib.playerLoseItem(p, p.pso.menu.choice, p.pso.inventoryqty)
							p.pso.itmsg = "\x83".."ITEM DROPPED"
						
						elseif p.pso.inventorystate == IST_STOREYN
							-- send the item to storage
							local res = PSO.lib.playerSendToStorage(p, p.pso.menu.choice, p.pso.inventoryqty)
							if res
								p.pso.itmsg = "\x83".."DEPOSIT SUCCESS"
							else
								p.pso.itmsg = "\x85".."STORAGE FULL!"
							end
						end

						p.pso.inventorychoice = 1
						p.pso.inventorystate = 0
							
						-- now update the menu here before everything catches on fire...
						p.pso.menu.minchoice = p.pso.inventory_sections[p.pso.inventorysection]
						p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso.inventory_sections[p.pso.inventorysection+1] -1)		
						
						while p.pso.menu.choice > p.pso.menu.maxchoice
							p.pso.menu.choice = $-1
							if p.pso.menu.scroll
								p.pso.menu.scroll = $-1
							end
						end
							
					elseif input(p, IPT_CONFIRM) == 1
					and p.pso.inventorychoice == 2
					or input(p, IPT_BACK)
						p.pso.inventorystate = IST_GENERAL
						p.pso.inventorychoice = 1
						S_StartSound(nil, sfx_mback, p)
					end
					return true
			
			-- use a consumable item
			elseif p.pso.inventorystate == IST_USE
				
				if (not info.canuse or info.canuse(p)) and info.use
					-- lose the item
					PSO.lib.playerLoseItem(p, p.pso.menu.choice, 1)
				
					info.use(p)
					
					-- now update the menu here before everything catches on fire...
					p.pso.menu.minchoice = p.pso.inventory_sections[p.pso.inventorysection]
					p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso.inventory_sections[p.pso.inventorysection+1] -1)	

					while p.pso.menu.choice > p.pso.menu.maxchoice
						p.pso.menu.choice = $-1
						if p.pso.menu.scroll
							p.pso.menu.scroll = $-1
						end
					end					
					
					if p.pso.inventory[p.pso.menu.choice] ~= selected
						p.pso.inventorystate = nil	-- close the window
					else	-- we still have some of that item
						p.pso.inventorystate = IST_GENERAL
						p.pso.inventoryletgo = true	-- fixes a funny bug
						--print("We have more still")
					end
				end
				
			-- assigning item in palette, dear lord.
			elseif p.pso.inventorystate == IST_PALETTE
				-- set palx:
				if info.grinder
					p.pso.inventorypalx = max($, 2)
					p.pso.inventorypalx = min($, 3)
					p.pso.inventorygslot = $ or 1
					
					if input(p, "left") == 1 or input(p, "right") == 1

						local pal = p.pso.palette.layout
						local slot = pal[p.pso.inventorypalx][p.pso.inventorypaly]
						
						if p.pso.inventorypalx == 2
						and slot
						and PSO.lib.slotIsOneHanded(slot)
							
							if input(p, "left") == 1
								if p.pso.inventorygslot == 2
									p.pso.inventorygslot = 1
								else
									p.pso.inventorypalx = 3
								end
							elseif input(p, "right") == 1
								if p.pso.inventorygslot == 1
									p.pso.inventorygslot = 2
								else
									p.pso.inventorypalx = 3
								end
							end
							
							--p.pso.inventorygslot = p.pso.inventorygslot == 1 and 2
						else
							p.pso.inventorypalx = p.pso.inventorypalx == 2 and 3 or 2
						end
						S_StartSound(nil, sfx_mhvr, p)
					end
					
					if p.pso.inventorypalx ~= 2
						p.pso.inventorygslot = 1
					end
					
				elseif info.type == IT_CONSUMABLE
					p.pso.inventorypalx = 1
				elseif info.type == IT_WEAPON
					p.pso.inventorypalx = 2
				elseif info.type == IT_ARMOR
					p.pso.inventorypalx = 3
				end

				local minchoice = 1
				local maxchoice = PSO.info.MAXPALSIZE
				
				if input(p, IPT_BACK) == 1
					p.pso.inventorystate = IPT_GENERAL
					p.pso.inventorychoices = nil
					
					S_StartSound(nil, sfx_mback, p)
				
				elseif input(p, "down") == 1
					p.pso.inventorypaly = $+1
					
					if p.pso.inventorypaly > maxchoice
						p.pso.inventorypaly = minchoice
					end
					S_StartSound(nil, sfx_mhvr, p)
				
				elseif input(p, "up") == 1
					p.pso.inventorypaly = $-1
					
					if p.pso.inventorypaly < minchoice
						p.pso.inventorypaly = maxchoice
					end
					S_StartSound(nil, sfx_mhvr, p)
				
				elseif input(p, IPT_CONFIRM) == 1
					
					local pal = p.pso.palette.layout
					local slot = pal[p.pso.inventorypalx][p.pso.inventorypaly]
					
					if p.pso.inventorypalx == 2	-- weapons have special handling
						
						-- USING GRINDER
						if info.grinder
							
							if not slot
								S_StartSound(nil, sfx_mnot, p)
								return true
							end
							
							local wep = slot[p.pso.inventorygslot]
							if not wep
								S_StartSound(nil, sfx_mnot, p)
							else
								if PSO.lib.grindItem(wep, info.grinder or 1)
									-- consume the grinder
									PSO.lib.playerLoseItem(p, p.pso.menu.choice, 1)
									S_StartSound(nil, sfx_heal, p)
									if not PSO.lib.findPlayerItem(p, selected) 
										p.pso.inventorystate = nil	-- cancel it straight out
									end
								else
									S_StartSound(nil, sfx_mnot, p)
								end
							end
						
						-- EQUIPPING
						else
							
							S_StartSound(nil, sfx_mconf, p)
							
							local hand = PSO.info.weaponHand[selected.weapontype]
							local wn = hand or 1	-- HAND_NONE go in slot 1 still, but we'll remember what we gotta unequip!
							if slot and slot[wn] == selected
								selected.equipped = nil	-- mark as unequipped
								pal[p.pso.inventorypalx][p.pso.inventorypaly][wn] = nil
								
								PSO.lib.playerFixWeaponPalette(p)
							else
								pal[p.pso.inventorypalx][p.pso.inventorypaly] = $ or {}	-- if it's not set make sure to do so.
								
								-- remove other instance of the same weapon
								for i = 1, PSO.info.MAXPALSIZE
									local s = pal[p.pso.inventorypalx][i]
									if s == nil continue end
									
									if s[1] == selected
										s[1] = nil
									elseif s[2] == selected
										s[2] = nil
									end
								end
								
								selected.equipped = true
								
								-- even if we only equip a right handed weapon we must check the left slot as this is where HAND_BOTH weapons go.
								for i = 1, 2
									
									local w = pal[p.pso.inventorypalx][p.pso.inventorypaly][i]
									
									if w
									and ((i == wn or i == 1 and PSO.info.weaponHand[w.weapontype] == HAND_BOTH)
									or PSO.info.weaponHand[selected.weapontype] == HAND_BOTH)
										w.equipped = nil	-- mark as unequipped
										pal[p.pso.inventorypalx][p.pso.inventorypaly][i] = nil	-- remove from palette.
									end
								end
								
								pal[p.pso.inventorypalx][p.pso.inventorypaly][wn] = selected
								PSO.lib.playerFixWeaponPalette(p)
							end
							
							if p.pso.inventorypaly == p.pso.palette.aweaponnum
								PSO.lib.dprint("force update")
								p.pso.forceupdateweapon = true
							end
						end
					else
						
						-- enhancing armor
						if info.grinder
							local wep = slot
							if not wep
								S_StartSound(nil, sfx_mnot, p)
							else
								if PSO.lib.grindItem(wep, info.grinder or 1)
									-- consume the grinder
									PSO.lib.playerLoseItem(p, p.pso.menu.choice, 1)
									S_StartSound(nil, sfx_heal, p)
									if not PSO.lib.findPlayerItem(p, selected) 
										p.pso.inventorystate = nil	-- cancel it straight out
									end
								else
									S_StartSound(nil, sfx_mnot, p)
								end
							end
							
						else
							if slot == selected	-- if we're "reapplying" the same item
								pal[p.pso.inventorypalx][p.pso.inventorypaly] = nil	-- unset
								if type(selected) == "table"
									selected.equipped = nil
								end							
							else -- otherwise, set it.
								-- before we do, remove other instances of that same item...
								for i = 1, PSO.info.MAXPALSIZE
									if pal[p.pso.inventorypalx][i] == selected
										pal[p.pso.inventorypalx][i] = nil
									end
								end
								
								if type(selected) == "table"
									selected.equipped = true
								end
								
								-- make sure to unequip armours.
								if type(pal[p.pso.inventorypalx][p.pso.inventorypaly]) == "table"
									pal[p.pso.inventorypalx][p.pso.inventorypaly].equipped = nil
								end
								
								pal[p.pso.inventorypalx][p.pso.inventorypaly] = selected
							end
						end
					end
				end
				
				if info.grinder
					local slot = p.pso.palette.layout[p.pso.inventorypalx][p.pso.inventorypaly]
					if p.pso.inventorypalx == 2
						
						if not PSO.lib.slotIsOneHanded(slot)
							p.pso.inventorygslot = 1
						end
						
						if slot
							p.pso.grinderref = slot[p.pso.inventorygslot]
						else
							p.pso.grinderref = nil
						end
					else
						p.pso.grinderref = slot
					end
				end
				
				return true
			end
		end
		
		if PSO.lib.navigateInventoryTabs(p, "inventory")
			return true
		
		elseif input(p, IPT_CONFIRM) == 1
			
			if not p.pso.inventorystate and selected
				p.pso.itmsg = nil
				p.pso.inventorystate = 1
				p.pso.inventorychoice = 1
			end
			
			return true
		
		elseif input(p, IPT_BACK) == 1
			
			p.pso.hidehud = false
			
			PSO.lib.changeMenu(p, "main", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)
		end
	end,
	
	-- # of choices are dynamic by virtue of how this menu works...
	choices = {},
	nomemory = true,	-- don't remember this
	scroll = 7,			-- # of items that can be displayed
}