freeslot("sfx_qload", "sfx_qacpt", "sfx_qfail")

-- closes the menu if this guy ain't our leader!
local function noLeaderClose(p)
	if p != PSO.lib.getLeader()
		PSO.lib.closeMenu(p)
		return true
	end
	return false
end

PSO.info.menus["quest_map"] = {
	
	openfunc = function(p)

			
		if server.questdata and server.questdata.complete
		and not p.exiting
			PSO.lib.changeMenu(p, "turnin")
			return
		end
		
		-- no, nooooo...
		if p ~= PSO.lib.getLeader()			
		or server.questdata	-- quest ongoing and we can't turn it in.
			PSO.lib.closeMenu(p)
			return
		end
		
		
		-- test, comment out
		--PSO.info.questmaps = {2}
		
		-- build the list of maps:
		local choices = {}
		for i = 1, #PSO.info.questmaps
			
			local mapnum = PSO.info.questmaps[i][1]
			local lock = PSO.info.questmaps[i][2]
			
			if lock and not PSO.lib.questUnlocked(mapnum)
				continue
			end
			
			local name = mapheaderinfo[mapnum].lvlttl or "INVALID MAP"
			
			table.insert(choices, {name, mapnum})
		end
		table.insert(choices, {"Cancel", 0})
		
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #choices
		p.pso.menu.choices = choices
	end,
	
	-- closefunc not needed, p.pso.menu is purged on clsoe
	
	hudfunc = function(v, p, c, choices, choice, timer)
		local w = 200
		local h = 80
		local x = 160-(w/2)
		local y = 100-(h/2)
		
		choices = p.pso.menu.choices
		
		v.drawFill(x, y, w, h, 253)
		
		v.drawString(160, y+4, "QUEST COUNTER", V_YELLOWMAP, "center")
		
		local cy = y+16
		for i = p.pso.menu.scroll+1, min(#choices, p.pso.menu.scroll +6)
			v.drawString(80, cy, (i == choice and "\x82"..">" or "")..choices[i][1], 0)
			cy = $+10
		end
		
		if choice ~= #choices
			local pic = G_BuildMapName(choices[choice][2]).."P"
			
			v.drawScaled(160<<FRACBITS, (y+16)<<FRACBITS, FRACUNIT/2, v.cachePatch(pic))
		end
		
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
			
		if noLeaderClose(p)
			return true
		end
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < #p.pso.menu.choices
			
			--p.pso.questmap = PSO.info.questmaps[p.pso.menu.choice][1]
			p.pso.questmap = p.pso.menu.choices[p.pso.menu.choice][2]
			-- open the next menu:
			PSO.lib.changeMenu(p, "quest_select", true, true)
			S_StartSound(nil, sfx_mconf, p)
			
			return true		
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == #p.pso.menu.choices)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end
	end,
	
	scroll = 6,
}

local difficultynames = {
	[DIFF_NORMAL] = "NORMAL",
	[DIFF_HARD] = "HARD",
	[DIFF_VERYHARD] = "VERY HARD",
	[DIFF_SUPERHARD] = "SUPER HARD",
	[DIFF_EXTREMELYHARD] = "EXTREMELY HARD",
	[DIFF_ULTRAHARD] = "ULTRA HARD"
}

PSO.info.menus["quest_select"] = {
	
	openfunc = function(p)
		
		-- build the list of quests:
		local choices = {}
		for i = 1, #PSO.info.quests[p.pso.questmap]
			-- is that quest, uh, unlocked?
			local q = PSO.info.quests[p.pso.questmap][i]
			
			if q.locked and not PSO.lib.questUnlocked(p.pso.questmap, i)
				continue
			end
			
			table.insert(choices, i)	-- save the index of the quest
		end
		table.insert(choices, 0)
		
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #choices
		p.pso.menu.choices = choices

		p.pso.acceptquest = nil
		p.pso.questdifficulties = nil
		p.pso.questdifficulty = nil	
	
	end,
	
	closefunc = function(p)
		p.pso.acceptquest = nil
		p.pso.questdifficulties = nil
		p.pso.questdifficulty = nil
	end,

	hudfunc = function(v, p, c, choices, choice, timer)
		local w = 120
		local h = 140
		local x = 2
		local y = 12
		
		local mapname = mapheaderinfo[p.pso.questmap].lvlttl

		if p.pso.acceptquest
			
			local aw = 160
			local ah = 30
			local ax = 160 - aw/2
			local ay = 100 - ah/2
			
			v.drawFill(ax, ay, aw, ah, 253)
			
			if p.pso.acceptquest < TICRATE*2
			
				v.drawString(160, 90, "\x82".."LOADING...", 0, "center")
				
				
				
				local barlen = min(aw-7, p.pso.acceptquest*(aw-7)/(TICRATE*2))
				local percentage = p.pso.acceptquest*100/(TICRATE*2)
				
				v.drawFill(ax+2, 108, aw-6, 2, 26)
				v.drawFill(ax+2, 108, barlen, 1, 73)
				v.drawString(160, 98, "\x82"..string.format("%03d", percentage).."%", 0, "center")
				
			elseif leveltime%4 < 2
				v.drawString(160, 96, "\x82".."QUEST ACCEPTED!", 0, "center")
			end
			
			return
		end
		
		v.drawFill(x, y, w, h, 253|V_SNAPTOLEFT)
		
		local qy = y + 22
				
		if p.pso.questdifficulties
			
			v.drawString(x+2, y+2, "\x82".."DIFFICULTY", V_RETURN8|V_SNAPTOLEFT)
			
			for i = 1, #p.pso.questdifficulties+1
				
				local display
				if i <= #p.pso.questdifficulties
					local diff = p.pso.questdifficulties[i]
					local lvl = PSO.info.quests[p.pso.questmap][choice].levels[diff]
					
					display = difficultynames[diff].."\n".."  ENEMY LV"..lvl
				else
					display = "BACK"
				end
				v.drawString(x+2, qy-8, (p.pso.questdifficulty == i and "\x82>" or "")..display, V_SNAPTOLEFT|V_RETURN8)
				qy = $ + 18
			end
		else
			v.drawString(x+2, y+2, "\x82".."QUEST LIST\n"..mapname, V_RETURN8|V_SNAPTOLEFT)
			for i = 1, #p.pso.menu.choices
				
				local qindex = p.pso.menu.choices[i]
				local name = "INVALID QUEST"
				
				local quest = PSO.info.quests[p.pso.questmap][qindex]
				
				if qindex == 0
					name = "BACK"
				elseif quest
					name = quest.name or "INVALID Q NAME"
				end
				
				v.drawString(x+2, qy, (choice == i and ("\x82"..">") or "")..name, V_SNAPTOLEFT, "thin")
				
				qy = $+8
			end
		end
		
		local squest = p.pso.menu.choices[choice]
		
		if squest and PSO.info.quests[p.pso.questmap][squest]
			-- display quest info:
			
			local nx = x + w + 2
			local nw = 320 - nx - 2
			local q = PSO.info.quests[p.pso.questmap][squest]
			
			v.drawFill(nx, y, nw, h, 253|V_SNAPTOLEFT)
			
			v.drawString(nx+2, y+2, "\x82"..q.name, V_SNAPTOLEFT)
			
			local dstr = PSO.lib.wordWrap(v, q.desc, nw-8)
			v.drawString(nx+2, y+12, "\x82".."DESCRIPTION:\x80\n"..dstr, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8)
			
			dstr = PSO.lib.wordWrap(v, q.objective, nw-8)
			v.drawString(nx+2, y+80, "\x82".."OBJECTIVE:\x80\n"..dstr, V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_RETURN8)
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown

		if noLeaderClose(p)
			return true
		end
		
		if p.pso.acceptquest
			
			p.pso.acceptquest = $+1
			
			if p.pso.acceptquest == TICRATE*2
				-- accept quest
				PSO.lib.acceptQuest(p.pso.questmap, p.pso.menu.choices[p.pso.menu.choice], p.pso.questdifficulties[p.pso.questdifficulty])
				
			elseif p.pso.acceptquest == TICRATE*3
				
				local q = PSO.info.quests[p.pso.questmap][p.pso.menu.choices[p.pso.menu.choice]]
				for p2 in players.iterate
					if p2 and p2.mo.valid
						PSO.lib.playerNotification(p2, "\x82".."QUEST START: ".."\x80"..q.name)	
					end
				end
				
				PSO.lib.closeMenu(p)
			end
			
			return true
		end
		
		if p.pso.questdifficulties
				
			if input(p, "down") == 1
				S_StartSound(nil, sfx_mhvr, p)
				p.pso.questdifficulty = $+1
				if p.pso.questdifficulty > #p.pso.questdifficulties+1
					p.pso.questdifficulty = 1
				end
				
			elseif input(p, "up") == 1
				S_StartSound(nil, sfx_mhvr, p)
				p.pso.questdifficulty = $-1
				if p.pso.questdifficulty <= 0
					p.pso.questdifficulty = #p.pso.questdifficulties+1
				end			
			end
			
			if input(p, IPT_CONFIRM) == 1
			and p.pso.questdifficulty <= #p.pso.questdifficulties
				
				p.pso.acceptquest = 1
				S_StartSound(nil, sfx_qload, p)
				
			elseif input(p, IPT_BACK) == 1
			or input(p, IPT_CONFIRM) == 1 and p.pso.questdifficulty > #p.pso.questdifficulties
				p.pso.questdifficulties = nil
				S_StartSound(nil, sfx_mback, p)
			end
			
			return true
		end
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < #p.pso.menu.choices
			
			p.pso.questdifficulty = 1
			-- find out which difficulties are available for the quest...
			
			local quest = PSO.info.quests[p.pso.questmap][p.pso.menu.choices[p.pso.menu.choice]]
			local diffs = {}
			if quest and quest.levels
				for i = DIFF_NORMAL, DIFF_ULTRAHARD
					
					if quest.locked
						local diffu = PSO.lib.questUnlocked(p.pso.questmap, p.pso.menu.choices[p.pso.menu.choice])
						if not diffu or diffu < i
							break
						end
					else
						-- this prevents normal quests from having hard unlocked at the start of the game etc...
						if PSO.lib.maxDifficultyUnlocked() < i
							break
						end
					end
					
					if quest.levels[i]
						diffs[#diffs+1] = i
					end
				end
			end
			
			p.pso.questdifficulties = diffs
			
			S_StartSound(nil, sfx_mconf, p)
			return true		
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == #p.pso.menu.choices)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end	
	end,
}