-- settings related menus

PSO.info.menus["options"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 6, 999)

		local xpos = 2
		local w = 128
		local y = 20
		local h = 32
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		
		for i = 1, #choices
			
			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT)
			y = $ + 8
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "main", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			p.pso.menu.choice = 6
			S_StartSound(nil, sfx_mback, p)
		end
	end,
	
	choices = {
		
		{"TOGGLES", "options_toggles"},
		{"INPUTS", "options_inputs"},
		{"DATA", "options_data"},
	},
}

PSO.info.menus["options_data"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 6, 999)

		local xpos = 2
		local w = 160
		local y = 20
		local h = 32
		
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		v.drawString(xpos+2, y+4, "DATA OPTIONS", V_YELLOWMAP|V_SNAPTOLEFT)
		
		y = $+8
		
		for i = 1, #choices
			
			local tflag = 0
			
			if i == 2
			and netgame
			and p ~= server
				tflag = V_50TRANS
			end
			
			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT|tflag)
			y = $ + 8
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "options", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)
		
		elseif input(p, IPT_CONFIRM) == 1
		
			if p.pso.menu.choice == 2
			and netgame
			and p ~= server		
				S_StartSound(nil, sfx_mnot, p)
				return true
			end
		end
	end,
	
	choices = {
		
		{"ERASE CHARACTER DATA", "options_erasedata"},
		{"ERASE GAME PROGRESS", "options_eraseserverdata"},
	},
}

-- yes this is retarded:
addHook("PreThinkFrame", do
	--if netgame return end
	for p in players.iterate do
		if p and p.pso and p.pso.nukesave
			COM_BufInsertText(p, "exitgame")
		end
	end
end)

PSO.info.menus["options_erasedata"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 6, 999)

		local xpos = 2
		local w = 280
		local h = 70
		local x = 160 - (w/2)
		local y = 100 - (h/2)
		
		v.drawFill(x, y, w, h, 253)
		
		local txt
		if netgame
			txt = "will be disconnected from the server."
		else
			txt = "will be returned to the titlescreen."
		end
		
		v.drawString(160, y+2, "\x85".."WARNING", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+12, "This will permanently erase your", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+20, "save data, which includes your level,", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+28, "items, PAs, etc... Furthermore, you", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+36, txt, V_ALLOWLOWERCASE, "center")
		
		for i = 1, #choices
			
			v.drawString(160, y+50, (i == choice and "\x82"..">" or "")..choices[i][1], V_ALLOWLOWERCASE, "center")
			y = $ + 8
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "options_data", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)
		elseif input(p, IPT_CONFIRM) == 1
			
			if p.pso.menu.choice == 2	-- delete
				-- from there it depends whether or not we're in a netgame!
				S_StartSound(nil, sfx_mconf, p)
				if not netgame
					p.pso.nukesave = true
					PSO.lib.clientNukeSave()
				else
					COM_BufInsertText(p, "__&client_askdelete")
					PSO.lib.closeMenu(p)
				end
				
				return true
			end
		end
	end,
	
	choices = {
		
		{"BACK", "options_data"},
		{"DELETE"},
	},
}

PSO.info.menus["options_eraseserverdata"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 6, 999)

		local xpos = 2
		local w = 280
		local h = 70
		local x = 160 - (w/2)
		local y = 100 - (h/2)
		
		v.drawFill(x, y, w, h, 253)
		
		local txt
		if netgame
			txt = "the server will shut down."
		else
			txt = "you will return to the title screen."
		end
		
		v.drawString(160, y+2, "\x85".."WARNING", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+12, "This will permanently erase the", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+20, "progress data, which unlocked areas", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+28, "and difficulties. Furthermore,", V_ALLOWLOWERCASE, "center")
		v.drawString(160, y+36, txt, V_ALLOWLOWERCASE, "center")
		
		for i = 1, #choices
			
			v.drawString(160, y+50, (i == choice and "\x82"..">" or "")..choices[i][1], V_ALLOWLOWERCASE, "center")
			y = $ + 8
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if p ~= server
			PSO.lib.closeMenu(p)
			return
		end
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "options_data", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)
		elseif input(p, IPT_CONFIRM) == 1
			
			if p.pso.menu.choice == 2	-- delete
				-- from there it depends whether or not we're in a netgame!
				S_StartSound(nil, sfx_mconf, p)
				PSO.lib.clientNukeData(p)
				
				return true
			end
		end
	end,
	
	choices = {
		
		{"BACK", "options_data"},
		{"DELETE"},
	},
}

local ipt_list = {IPT_CONFIRM, IPT_BACK, IPT_INTERACT, IPT_ATTACK, IPT_ATTACK2, IPT_PALETTE, IPT_SECONDPALETTE, IPT_LOCKON, IPT_MENU}
local ipt_names = {
	
	-- MENUS
	{"Confirm", 0},
	{"Back", 0},
	
	-- ACTION
	{"Interact / Pick Up /\n Evade / Dash (Hold)", 1},
	{"Attack 1 / \nAction Palette: Cycle Weapon", 1},
	{"Attack 2 / \nAction Palette: Cycle Items", 1},
	{"Open Action Palette", 0},
	{"Back Palette / \nAction Palette: Cycle Armours", 1},
	{"Lock-On", 0},
	{"Open Menu", 0},
	{"Revert to Defaults", 0},	-- hack :)
}

local butts = {BT_JUMP, BT_SPIN, BT_TOSSFLAG, BT_WEAPONNEXT, BT_WEAPONPREV, BT_CUSTOM1, BT_CUSTOM2, BT_CUSTOM3, BT_ATTACK, BT_FIRENORMAL}

PSO.info.menus["options_inputs"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 6, 999)
		
		if p.pso.remapreset
			
			local w = 230
			local h = 30
			
			v.drawFill(160 - w/2, 100 -h/2, w, h, 253)
			
			v.drawString(160, 100 - 10, "Are you sure?", V_YELLOWMAP, "center")
			v.drawString(160, 100 - 2, "(Confirm again to reset your inputs)", V_YELLOWMAP, "center")
			return
		end
		
		if p.pso.remapinput
			
			local w = 220
			local h = 30
			
			v.drawFill(160 - w/2, 100 -h/2, w, h, 253)
			
			v.drawString(160, 100 - 10, "Press any SRB2-bound key", V_YELLOWMAP, "center")
			v.drawString(160, 100 - 2, "(Or wait "..(p.pso.remaptime/TICRATE).." seconds to cancel)", V_YELLOWMAP, "center")
			return
		end

		local xpos = 2
		local w = 260
		local y = 20
		local h = 178
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		v.drawString(xpos+2, y+2, "\x82".."MENU INPUTS", V_SNAPTOLEFT)
		
		local missinginput
		for i = 1, #choices
			
			local col = ""
			
			if i < #choices
				if p.pso.tempinputs[ipt_list[i]]
					local bt = PSO.info.btIcons2[p.pso.tempinputs[ipt_list[i]]]
				
					v.draw(xpos+2, y+12, v.cachePatch(bt), V_SNAPTOLEFT)
				else
					col = "\x85"
					missinginput = true
				end
			end
				
			v.drawString(xpos + 24, y+10 +(not choices[i][2] and 4 or 0), (i == choice and "\x82"..col..">" or col)..choices[i][1], V_SNAPTOLEFT|V_RETURN8)
			
			y = $ + 16
			
			if i == IPT_MENUSEP
				v.drawString(xpos+2, y+10, "\x82".."FIELD INPUTS", V_SNAPTOLEFT)
				y = $ + 8
			end
		end
		
		if missinginput and leveltime%10 < 5
			v.drawString(318, 10, "MISSING INPUT(S)", V_REDMAP|V_SNAPTOTOP|V_SNAPTORIGHT, "right")
		end
		
	end,
	
	openfunc = function(p)
		p.pso.tempinputs = {}
		p.pso.hidehud = true
		p.pso.remapinput = nil
		
		for i = 1, #ipt_list
			p.pso.tempinputs[ipt_list[i]] = p.pso.inputs[ipt_list[i]]
		end
		
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		local c = p.pso.menu.choice
		
		if p.pso.remapreset

			if p.pso.confirmletgo
				
				if not input(p, IPT_CONFIRM)
					p.pso.confirmletgo = nil
				else
					return true
				end
			end
			
			if input(p, IPT_CONFIRM) == 1
				for i = 1, #ipt_list
					p.pso.tempinputs[ipt_list[i]] = PSO.info.inputDefaults[ipt_list[i]]
				end
				p.pso.remapreset = nil
				S_StartSound(nil, sfx_mconf, p)
			elseif input(p, IPT_BACK) == 1
				p.pso.remapreset = nil
				S_StartSound(nil, sfx_mback, p)
			end
		
			return true
		end
		
		if p.pso.remaptime
			p.pso.remaptime = $-1
			
			if not p.pso.remaptime
				p.pso.remapinput = nil
				p.pso.remaptime = nil
			end
			
			if p.pso.confirmletgo
				
				if not input(p, IPT_CONFIRM)
					p.pso.confirmletgo = nil
				else
					return true
				end
			end
			
			-- check for button inputs!
			for i = 1, #butts
				local bt = butts[i]
				
				if p.cmd.buttons & bt
					
					-- iterate through mapped inputs to remove potential duplicates if necessary.
					if c > IPT_MENUSEP
						-- iterate from IPT_MENUSEP+1 to the end of ipt_list
						for j = IPT_MENUSEP+1, #ipt_list
							if p.pso.tempinputs[j] == bt
								p.pso.tempinputs[j] = nil	-- remove that inpit
							end
						end
					else
						-- iterate from the start of the list to IPT_MENUSEP
						for j = 1, IPT_MENUSEP
							if p.pso.tempinputs[j] == bt
								p.pso.tempinputs[j] = nil	-- remove that inpit
							end
						end
					end

					-- set the new input!
					p.pso.tempinputs[ipt_list[c]] = bt
					
					p.pso.remapinput = nil
					p.pso.remaptime = nil
					
					S_StartSound(nil, sfx_mconf, p)
					
					break
				end
			end	
			
			return true
		end
		
		if input(p, IPT_BACK) == 1
			
			-- iterate inputs to make sure we haven't left any empty
			for i = 1, #ipt_list
				if not p.pso.tempinputs[i]
					S_StartSound(nil, sfx_mnot, p)
					return
				end
			end
			
			-- .....if we made it here, send the inputs, gah damn.	
			p.pso.alloweditinputs = true		-- will allow using the command
			local str = "pso_prefs_inputs \""
			
			for i = 1, #ipt_list
				str = $..(p.pso.tempinputs[i])..(i < #ipt_list and " " or "")
			end	
			str = $.."\""
			--print(str)
			
			COM_BufInsertText(p, str)
			
			PSO.lib.changeMenu(p, "options")
			S_StartSound(nil, sfx_mback, p)
		
		elseif input(p, IPT_CONFIRM) == 1

			-- flag to check and make sure we've let go of IPT_CONFIRM:
			p.pso.confirmletgo = true
			
			if c == #ipt_names
				p.pso.remapreset = true
			else
			
				p.pso.remapinput = ipt_list[c]
				p.pso.remaptime = TICRATE*6
			end
			return true
		end
	end,
	
	closefunc = function(p)
		p.pso.hidehud = nil
		--COM_BufInsertText(p, "pso_prefs_toggles "..(p.pso.tempprefs[1] and 1 or 0).." "..(p.pso.tempprefs[2] and 1 or 0).." "..(p.pso.tempprefs[3] and 1 or 0))
	end,
	
	choices = ipt_names,
}

PSO.info.menus["options_toggles"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 6, 999)

		local xpos = 2
		local w = 180
		local y = 20
		local h = 48
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		v.drawString(xpos+2, y+2, "\x82".."TOGGLES", V_SNAPTOLEFT)
		
		for i = 1, #choices
			
			v.drawString(xpos + 2, y+10, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT)
			
			local arr1 = ((i == choice and leveltime%10 < 5) and "\x82".."<" or "")
			local arr2 = ((i == choice and leveltime%10 < 5) and ">" or "")
			
			local str = p.pso.tempprefs[i] and "TOGGLE" or "HOLD"
			v.drawString(xpos + 148, y+10, arr1..str..arr2, V_SNAPTOLEFT, "center")
			
			y = $ + 8
		end
	end,
	
	openfunc = function(p)
		p.pso.tempprefs = {
			p.pso.toggle_lockon,
			p.pso.toggle_apalette,
			p.pso.toggle_bpalette,
		}
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		local c = p.pso.menu.choice
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "options")
			S_StartSound(nil, sfx_mback, p)
		end
		
		if input(p, "left") == 1
		or input(p, "right") == 1
			
			p.pso.tempprefs[c] = p.pso.tempprefs[c] == false and true or false
			S_StartSound(nil, sfx_mhvr, p)
		end
	end,
	
	closefunc = function(p)
		COM_BufInsertText(p, "pso_prefs_toggles "..(p.pso.tempprefs[1] and 1 or 0).." "..(p.pso.tempprefs[2] and 1 or 0).." "..(p.pso.tempprefs[3] and 1 or 0))
	end,
	
	choices = {
		
		{"LOCK-ON", nil},
		{"ACTION PALETTE", nil},
		{"BACK PALETTE", nil},
	},
}