-- Storage: Allows you to withdraw items you have deposited
local choices = {
		"Buy",
		"Sell",
		"Leave",
}

local w = 140
local h = 50
local function drawShopMenu(v, p, c, choice, timer)
	
	local x = 160-(w/2)
	local y = 100-(h/2)
	
	v.drawFill(x, y, w, h, 253)
	
	v.drawString(160, y+4, "SHOP", V_YELLOWMAP, "center")
	
	local cy = y+16
	for i = 1, #choices
		v.drawString(160, cy, (i == choice and "\x82"..">" or "")..choices[i], 0, "center")
		cy = $+10
	end
end

PSO.info.menus["shop"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawShopMenu(v, p, c, choice, timer)
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_CONFIRM) == 1
		and p.pso.menu.choice < 3
			
			p.pso.shoptype = p.pso.menu.choice
			-- open the next menu:
			PSO.lib.changeMenu(p, "shop_do", true, true)
			S_StartSound(nil, sfx_mconf, p)
			return true
			
		elseif input(p, IPT_BACK) == 1
		or (input(p, IPT_CONFIRM) and p.pso.menu.choice == 3)
			S_StartSound(nil, sfx_mback, p)
			PSO.lib.closeMenu(p)
		end
	end,
	
	choices = choices,
}

local stypes = {
	"shop",
	"inventory"
}

PSO.info.menus["shop_do"] = {

	openfunc = function(p)
		
		local where = stypes[p.pso.shoptype] or stypes[1]
		
		-- these can stay as the same variables
		p.pso.hidehud = true
		p.pso[where.."section"] = 1
		p.pso[where.."state"] = 0
		p.pso[where.."choice"] = 1
		p.pso[where.."qty"] = 1
		
		-- set the initial menu bounds (these must read the specific type of display):
		p.pso.menu.minchoice = p.pso[where.."_sections"][1]
		p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso[where.."_sections"][2] -1)
		
		p.pso.itmsg = nil
	end,
	
	closefunc = function(p)
		p.pso.hidehud = nil
	end,
	
	hudfunc = 	function(v, p, c, choices, choice, timer)

		-- old variables still used by the code below
		local xpos = 2
		local w = 178
		local y = 34		
		local sx = xpos + 14		
		local y2 = 114
			
		-- we still have to compute that here
		local where = stypes[p.pso.shoptype] or stypes[1]
		local inv = p.pso[where]
		local tab = p.pso[where.."section"]
		local sect = where.."_sections"
		local scroll = p.pso.menu.scroll
		
		local schoice = where.."choice"
		local sqty = where.."qty"
		
		--print(sect)
		--print(tab)
		--print(p.pso[sect][tab])
		local start = (p.pso[sect][tab] or 1) + (scroll or 0)
		local finish = p.pso[sect][tab+1] or #inv
	
		v.drawString(sx, 2, "\x82".."INVENTORY ("..#p.pso.inventory.."/"..PSO.info.INVENTORYSIZE..")", V_SNAPTOTOP|V_SNAPTOLEFT)
		v.draw(sx, 10, v.cachePatch("H_MST"), V_SNAPTOTOP|V_SNAPTOLEFT)
		v.drawString(sx + 10, 10, "\x82"..PSO.lib.numCommas(p.pso.meseta), V_SNAPTOTOP|V_SNAPTOLEFT)
		
		-- use the refactored func:
		PSO.lib.HUDDrawInventory(v, p, where, tab, p.pso.menu.choice, scroll, p.pso.shoptype)		
		
		local selected
		if start ~= finish
			selected = inv[p.pso.menu.choice][1]
		end
		
		if p.pso.itmsg
			v.drawFill(xpos + w + 2, 20, 320 - xpos - w - 2 - 2, 28, 253|V_SNAPTOLEFT)
			v.drawString(xpos + w + 8, 24, "\x82".."INFO:\n"..p.pso.itmsg, V_SNAPTOLEFT)
		end
		
		--  context menu (use/drop/equip.....)
		if selected and p.pso[where.."state"]
				
			local extray = 0
			local drawqty

			if type(selected) == "string"
				drawqty = true
			end
			extray = $+10
				
			if drawqty
				v.drawFill(xpos + w + 2, 20, 320 - xpos - w - 2 - 2, 2*10 +8 + extray, 253|V_SNAPTOLEFT)
				v.drawString(xpos + w + 8, 24, "\x82".."HOW MANY?", V_SNAPTOLEFT)
					
				local arr1 = leveltime%10 < 5 and "<" or "< "
				local arr2 = leveltime%10 < 5 and ">" or " >"
				v.drawString(xpos+w+32, 30 + extray, arr1..p.pso[sqty]..arr2, V_SNAPTOLEFT, "center")
				
				local itprice = max(1, PSO.lib.itemPrice(selected) / (p.pso.shoptype == 2 and 8 or 1)) * p.pso[sqty]
				v.draw(320 - 24, 30 + extray, v.cachePatch("H_MST"), V_SNAPTOLEFT)
				v.drawString(320 - 24 - 2, 30 + extray, "\x82".." = "..PSO.lib.numCommas(itprice), V_SNAPTOLEFT, "right")
				
			else
				local choices = {"YES", "NO"}
				v.drawFill(xpos + w + 2, 20, 320 - xpos - w - 2 - 2, #choices*10 +8 + extray, 253|V_SNAPTOLEFT)
					
				local str = {"BUY ITEM?", "SELL ITEM?"}
				v.drawString(xpos + w + 8, 24, "\x82"..str[p.pso.shoptype or 1], V_SNAPTOLEFT)

				local oy = 24 + extray
					
				for i = 1, #choices
						
					local yel = (p.pso[schoice] == i and leveltime%4 < 2)
					v.drawString(xpos + w + 8, oy, (yel and "\x82" or "")..choices[i], V_SNAPTOLEFT)
					oy = $+10
				end
			end		
		end
	end,
				
	runfunc = 	function(p)
		
		local where = stypes[p.pso.shoptype] or stypes[1]
		local input = PSO.lib.playerInputDown
		
		local inv = p.pso[where]
		local tab = p.pso[where.."section"]
		local sect = where.."_sections"
		local scroll = p.pso.menu.scroll
		
		local schoice = where.."choice"
		local sqty = where.."qty"
		
		local start = p.pso[sect][tab] + scroll
		local finish = p.pso[sect][tab+1] or #inv
		
		local item = inv[p.pso.menu.choice]
		local info
		if item
			item = item[1]	-- make sure we do that.
			info = PSO.lib.itemInfo(item)
		end
		
		if p.pso[where.."state"]
			-- select what to do w the item.
			-- (yes/no/quantity to select)
			
			if type(item) == "string"	-- if the item is a string it's a stackable!

				p.pso[schoice] = 1	-- force it to "yes"
				
				if inv[p.pso.menu.choice][2] and inv[p.pso.menu.choice][2] > 1
					if input(p, "left") == 1 or input(p, "right") > TICRATE/2
						p.pso[sqty] = $-1
						if not p.pso[sqty]
							p.pso[sqty] = inv[p.pso.menu.choice][2]
						end	
								
						S_StartSound(nil, sfx_mhvr, p)
								
					elseif input(p, "right") == 1 or input(p, "right") > TICRATE/2
						p.pso[sqty] = $+1
						if p.pso[sqty] > inv[p.pso.menu.choice][2]
							p.pso[sqty] = 1
						end	
								
						S_StartSound(nil, sfx_mhvr, p)			
					end
				end
				
			else
				
				p.pso[sqty] = 1
				if input(p, "up") == 1 or input(p, "down") == 1
					p.pso[schoice] = p.pso[schoice] == 1 and 2 or 1
					S_StartSound(nil, sfx_mhvr, p)
				end
			end
			
			-- confirm
			if input(p, IPT_CONFIRM) == 1 and p.pso[schoice] == 1
				-- what we do here depends if we're depositing or retrieving
				if p.pso.shoptype == 1		-- buying
					
					-- first of all, do you have the money to foot the bill?
					local price = PSO.lib.itemPrice(item)*(p.pso[sqty] or 1)
					
					if p.pso.meseta < price
						S_StartSound(nil, sfx_mnot, p)
						p.pso.itmsg = "\x85".."YOU'RE BROKE!"
						p.pso[where.."state"] = nil
						return
					end
					
					local res = PSO.lib.playerGetItem(p, item, p.pso[sqty])
					if res
						S_StartSound(nil, sfx_mconf, p)
						p.pso[where.."state"] = nil
						p.pso.itmsg = "\x83".."ITEM BOUGHT"
						
						local amount
						local qty = p.pso[sqty]
						if type(res) == "number"
							amount = price*res
							qty = res
						else
							amount = price*(p.pso[sqty] or 1)
						end
						
						p.pso.shop[p.pso.menu.choice][2] = $ - qty
						if not p.pso.shop[p.pso.menu.choice][2]
							table.remove(p.pso.shop, p.pso.menu.choice)
							PSO.lib.playerSortShop(p)
						end
						
						p.pso.meseta = $ - price
						S_StartSound(nil, sfx_chchng, p)
						
					else
						S_StartSound(nil, sfx_mnot, p)
						p.pso.itmsg = "\x85".."INVENTORY FULL!"
					end
					
				elseif p.pso.shoptype == 2	-- selling
				
					local price = max(1, PSO.lib.itemPrice(item) / 8) * (p.pso[sqty] or 1)
					p.pso.meseta = $ + price
					S_StartSound(nil, sfx_mconf, p)
				
					PSO.lib.playerLoseItem(p, p.pso.menu.choice, p.pso[sqty])
					
					S_StartSound(nil, sfx_mconf, p)
					p.pso[where.."state"] = nil
					p.pso.itmsg = "\x83".."ITEM SOLD"
				end
				
				-- update menu shit
				p.pso.menu.minchoice = p.pso[where.."_sections"][p.pso[where.."section"]]
				p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso[where.."_sections"][p.pso[where.."section"]+1] -1)
				p.pso.menu.choice = min($, p.pso.menu.maxchoice)

				p.pso[where.."state"] = nil
				p.pso[sqty] = 0
				p.pso[schoice] = 0
				
			-- cancel
			elseif input(p, IPT_BACK) == 1
			or input(p, IPT_CONFIRM) == 1 and p.pso[schoice] == 2
				p.pso[where.."state"] = nil
				p.pso[sqty] = 0
				p.pso[schoice] = 0
				
				S_StartSound(nil, sfx_mback, p)
			end
			
			return true
		end
		
		if PSO.lib.navigateInventoryTabs(p, where)
			return true
		
		elseif input(p, IPT_BACK) == 1
			PSO.lib.changeMenu(p, "shop", true, true)
			p.pso.hidehud = nil
			return true
		
		elseif input(p, IPT_CONFIRM) == 1
		
			if item
				if item.equipped
					S_StartSound(nil, sfx_mnot, p)
					p.pso.itmsg = "\x85".."ITEM IS EQUIPPED!"	
					return true
				
				elseif item.type == IT_ARMOR
					
					local info = PSO.lib.itemInfo(item)
					for u = 1, info.slots or 0
						if item.slots[u]
							S_StartSound(nil, sfx_mnot, p)
							p.pso.itmsg = "\x85".."ITEM HAS UNIT(S)!"	
							return true
						end
					end
				end
			end
			if start ~= finish
				p.pso[where.."state"] = 1
				p.pso[sqty] = 1
				p.pso[schoice] = 1
				p.pso.itmsg = nil
			end
			return true
		end
	end,

	nomemory = true,	-- don't remember this
	scroll = 7,			-- # of items that can be displayed
	
}

