local mapnum = 3
table.insert(PSO.info.questmaps, {mapnum, true})	-- map starts off locked
PSO.info.quests[mapnum] = {}

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[mapnum], {
	
	name = "2-1: Mines Scouting",
	desc = "A new potential area rich in resources has been located. We are sending operatives to assess the amount of Badniks and suppress those that are found.",
	objective = "Clear the way to the mines",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{3, 2}},	-- unlocks 2-2
	
	levels = {
		[DIFF_NORMAL] = 10,
		[DIFF_HARD] = 36,
	},

	grading = {
		{QG_TIME, 30, 0, TICRATE*60*10, TICRATE*60*12},
		{QG_DAMAGETAKEN, 20, 0, 350, 600},
		{QG_NOINCAP, 10},
	},

	drops = {
		[DIFF_NORMAL] = {	
			{"brand", 1, 0, 5, 50},
			{"lockgun", 0, 0, 5, 50},
			{"staff", 0, 0, 5, 50},			

			{"doublegladius", 1, 0, 5, 100},
			{"shot", 1, 0, 5, 100},
			
			{"unit_hp_1", 1, 0, 5, 50},
			{"unit_pp_1", 1, 0, 5, 50},
			{"unit_satk_1", 1, 0, 5, 50},
			{"unit_tatk_1", 1, 0, 5, 50},
			{"unit_ratk_1", 1, 0, 5, 50},
			
			{1000, nil, nil, 1, 5},
		},

		[DIFF_HARD] = {	
			{"vita claw", 1, 0, 5, 50},
			{"vita peacekeeper", 0, 0, 5, 50},
			{"vita scepter", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"unit_hpsatk_2", 1, 0, 7, 50},
			{"unit_hptatk_2", 1, 0, 7, 50},
			{"unit_hpratk_2", 1, 0, 7, 50},
			
			{"vulture basher", 1, 0, 1, 100},
			{"double driller", 1, 0, 1, 100},
			
			{6000, nil, nil, 1, 5},
		},
		
	},
	
	layout = {
		{0, 10400, -1568, 180, 0, 0, 0, 1},
		{MT_PSO_JUMPTARGET, 4960, 3744, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 5632, 2688, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 7328, 3136, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9568, 3488, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9216, -224, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 6624, -704, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9184, 2432, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, -1056, 768, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 2368, 2624, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 1536, 1472, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 1536, 128, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 128, 960, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, -2048, -192, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, -1984, 3264, 182, 0, 0, 0, 2513},
		{MT_PSO_LASERTOWER, 10944, -1216, 180, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10432, -1216, 181, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10016, -1216, 182, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7072, 1248, 190, 31105, 1944, 1, 2504},
		{MT_PSO_LASERTOWER, 7072, 928, 191, 31104, 1944, 1, 2504},
		{MT_PSO_LASERTOWER, 7072, 544, 192, 31104, 1944, 1, 2504},
		{MT_PSO_ROOMANCHOR, 8512, -128, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6976, 1472, 0, 0, 0, 0, 2500},
		{6, 8192, 448, 270, 31104, 1944, 0, 100},
		{7, 7456, 320, 0, 31104, 1944, 0, 101},
		{7, 7264, 1120, 270, 31104, 1944, 0, 101},
		{MT_PSO_CRATE, 10880, -1632, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10848, -1440, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7584, -1824, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7520, -1632, 270, 0, 0, 0, 2505},
		{MT_PSO_CARDREADER, 7168, 1312, 0, 31104, 1944, 1, 2503},
		{MT_PSO_UNLOCKCARD, 7328, 896, 1, 31104, 1944, 0, 2502},
		{MT_PSO_JUMPPAD, 2880, 608, 180, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 3584, -128, 180, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 3584, 1248, 180, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 3584, 576, 180, 3072, 192, 0, 2513},
		{MT_PSO_ROOMANCHOR, 2304, 1888, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4800, -704, 1, 0, 0, 0, 2500},
		{29, 3968, 352, 0, 3328, 208, 0, 117},
		{29, 3968, 736, 0, 3200, 200, 0, 117},
		{7, 3488, 1344, 0, 0, 0, 0, 101},
		{7, 3488, -64, 0, 0, 0, 0, 101},
		{MT_PSO_LASERTOWER, 3168, 1760, 200, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3488, 1760, 201, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3776, 1760, 202, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3776, 1856, 203, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3136, 1696, 270, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 3584, 576, 1, 3200, 200, 0, 2502},
		{MT_PSO_CRATE, 3200, 3968, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3456, 3936, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1536, 3520, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1568, 3808, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1632, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -224, 7552, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3776, 5312, 2, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 240, 5312, 220, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 576, 5312, 221, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 880, 5312, 222, 0, 0, 1, 2504},
		{37, 1360, 6000, 0, 0, 0, 0, 121},
		{6, 1760, 6400, 0, 0, 0, 0, 100},
		{6, 1792, 5760, 0, 0, 0, 0, 100},
		{37, 1248, 6336, 0, 0, 0, 1, 121},
		{37, 2784, 5696, 180, 0, 0, 1, 121},
		{MT_PSO_CARDREADER, 320, 5408, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 1760, 6080, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, -1312, 3392, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -384, 1824, 3, 0, 0, 0, 2500},
		{17, -1152, 2304, 0, 31232, 1952, 0, 111},
		{17, -608, 2304, 0, 31232, 1952, 0, 111},
		{26, -864, 2336, 90, 31232, 1952, 0, 115},
		{MT_PSO_LASERTOWER, -1184, 2240, 230, 31105, 1944, 1, 2504},
		{MT_PSO_LASERTOWER, -864, 2240, 231, 31104, 1944, 1, 2504},
		{MT_PSO_LASERTOWER, -544, 2240, 232, 31104, 1944, 1, 2504},
		{MT_PSO_JUMPPAD, -864, 2112, 10, 31104, 1944, 0, 2512},
		{MT_PSO_JUMPTARGET, -864, 1024, 10, 31104, 1944, 0, 2513},
		{MT_PSO_CRATE, -1120, 544, 270, 31104, 1944, 0, 2505},
		{MT_PSO_CRATE, -1728, -1600, 270, 0, 0, 0, 2505},
		{MT_PSO_JUMPPAD, -864, 256, 20, 31104, 1944, 0, 2512},
		{MT_PSO_JUMPTARGET, -864, -384, 20, 31104, 1944, 0, 2513},
		{MT_PSO_CARDREADER, -544, 2304, 90, 31104, 1944, 1, 2503},
		{MT_PSO_CRATE, -1568, -1728, 270, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -4512, -3072, 240, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4384, -2752, 241, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4256, -2432, 242, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4160, -2144, 243, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4064, -1888, 244, 0, 0, 1, 2504},
		{MT_PSO_JUMPPAD, -4320, -2208, 30, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -5024, -1632, 30, 7200, 450, 0, 2513},
		{MT_PSO_JUMPPAD, -2496, -2944, 40, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1984, -3040, 40, 0, 0, 0, 2513},
		{7, -3680, -2272, 0, 0, 0, 0, 101},
		{7, -3968, -3168, 0, 0, 0, 0, 101},
		{17, -2144, -2720, 0, 0, 0, 1, 111},
		{17, -2240, -3232, 0, 0, 0, 1, 111},
		{37, -3584, -2720, 0, 0, 0, 1, 121},
		{MT_PSO_UNLOCKCARD, -2048, -2944, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -4000, -2144, 0, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -4512, -1760, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1632, -3776, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7200, 1696, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4128, -1664, 5, 0, 0, 0, 2500},
		{MT_PSO_CRATE, -5632, -2208, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5408, -2336, 270, 0, 0, 0, 2505},
		{29, -5856, -1312, 315, 1920, 120, 0, 117},
		{29, -5184, -608, 225, 1920, 120, 0, 117},
		{26, -6464, 832, 270, 0, 0, 1, 115},
		{26, -5728, 1152, 270, 0, 0, 1, 115},
		{37, -5568, -832, 270, 0, 0, 1, 121},
		{MT_PSO_LASERTOWER, -6592, 1472, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6304, 1472, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6016, 1472, 302, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5760, 1472, 303, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5504, 1472, 304, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -6496, 1376, 270, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -5824, 704, 1, 0, 0, 1, 2502},
		{MT_PSO_JUMPPAD, -5984, -1728, 50, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -5984, -1152, 50, 1920, 120, 0, 2513},
		{MT_PSO_JUMPTARGET, -5088, -320, 60, 1920, 120, 0, 2513},
		{MT_PSO_JUMPPAD, -5088, -768, 60, 0, 0, 0, 2512},
		{MT_PSO_UNLOCKCARD, -864, 2464, 1, 31104, 1944, 0, 2502},
		{7, -8256, 1952, 0, 0, 0, 0, 101},
		{37, -8256, 2192, 0, 0, 0, 0, 121},
		{MT_PSO_ROOMANCHOR, -8864, 2592, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7312, 1632, 6, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, -7872, 2032, 1, 0, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, -4960, 6080, 10, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1440, 4608, 8, 0, 0, 0, 2500},
		{MT_PSO_JUMPPAD, -3360, 5344, 100, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2656, 5344, 100, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2784, 5344, 101, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3456, 5344, 101, 0, 0, 0, 2513},
		{7, -2368, 5600, 180, 0, 0, 0, 101},
		{7, -2144, 5152, 180, 0, 0, 0, 101},
		{37, -3904, 5408, 0, 0, 0, 1, 121},
		{37, -1888, 5376, 0, 0, 0, 1, 121},
		{MT_PSO_UNLOCKCARD, -2208, 5376, 2, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -6400, 4448, 310, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6176, 4448, 311, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5920, 4448, 312, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6400, 4640, 320, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -6176, 4640, 321, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -5968, 4640, 322, 0, 0, 2, 2504},
		{MT_PSO_ROOMANCHOR, -6560, 4768, 9, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5760, 4288, 9, 0, 0, 0, 2500},
		{MT_PSO_CARDREADER, -6304, 4384, 270, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, -6304, 4576, 270, 0, 0, 2, 2503},
		{MT_PSO_CRATE, -6400, 8128, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6208, 8128, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6016, 8064, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6112, 7936, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6304, 7968, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -7392, 8096, 10, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4160, 5920, 8, 0, 0, 0, 2500},
		{26, -6752, 7296, 270, 3712, 232, 0, 115},
		{26, -5568, 7072, 180, 3712, 232, 0, 115},
		{MT_PSO_ROOMANCHOR, -4320, 9328, 11, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -2528, 7840, 11, 1, 0, 0, 2500},
		{7, -3520, 8544, 270, 0, 0, 0, 101},
		{7, -3168, 8704, 270, 0, 0, 0, 101},
		{37, -3872, 8832, 270, 0, 0, 1, 121},
		{37, -3072, 8192, 270, 0, 0, 1, 121},
		{29, -3040, 9056, 225, 0, 0, 2, 117},
		{29, -4160, 8320, 45, 0, 0, 2, 117},
		{37, -2784, 8320, 180, 0, 0, 2, 121},
		{MT_PSO_CRATE, -3616, 9088, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -3360, 9088, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -3104, 8960, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2944, 8672, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2976, 8160, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -3328, 8064, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -3872, 8128, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -4000, 8384, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -4000, 8608, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -3840, 8928, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -3360, 8896, 180, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -2752, 8736, 180, 5, 0, 2, 2505},
		{MT_PSO_JUMPTARGET, 5440, 5728, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 4608, 7264, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 5600, 7904, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 4512, 9952, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 2592, 8256, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 6528, 9696, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 8128, 9120, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 8608, 7808, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9408, 9920, 182, 0, 0, 0, 2513},
		{MT_PSO_LASERTOWER, -8192, 2592, 1000, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7920, 2432, 1001, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2528, 5968, 1100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2304, 5984, 1101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2080, 6000, 1102, 0, 0, 0, 2504},
		{MT_PSO_TELEPORTER, 10560, -1568, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORTER, -3424, 8544, 1, 1, 0, 3, 2510},
		{MT_PSO_TELEPORT_DEST, 10464, -1568, 0, 0, 0, 0, 2511},	
	},
	
})

table.insert(PSO.info.quests[mapnum], {
	
	name = "2-2: Battle in the valley",
	desc = "Exploitation of the mines has begun, but the quickest way out has been overrun by Badniks. Make a safe path out to make shipments easier.",
	objective = "Secure the shipment route through the canyon.",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{3, 3}},	-- unlocks 2-3
	
	levels = {
		[DIFF_NORMAL] = 13,
		[DIFF_HARD] = 38,
	},

	grading = {
		{QG_TIME, 40, 0, TICRATE*60*20, TICRATE*60*25},
		{QG_DAMAGETAKEN, 30, 0, 600, 1400},
		{QG_NOINCAP, 20},
	},

	drops = {
		[DIFF_NORMAL] = {	
			{"breaker", 1, 0, 1, 100},
			{"breag calibur", 1, 0, 1, 100},
			{"breag edge", 1, 0, 1, 100},
			
			{"laser", 1, 0, 1, 100},
			{"longlaser", 1, 0, 1, 100},
			{"burstlaser", 1, 0, 1, 100},
			
			{"ulrod", 1, 0, 1, 100},
			{"luciel", 1, 0, 1, 100},
			{"half-luciel", 1, 0, 1, 100},
			
			{"slash", 0, 0, 3, 50},
			{"autogun", 0, 0, 3, 50},
			{"batnara", 0, 0, 3, 50},			
			
			{"unit_hp_1", 1, 0, 2, 50},
			{"unit_pp_1", 1, 0, 2, 50},
			{"unit_satk_1", 1, 0, 2, 50},
			{"unit_tatk_1", 1, 0, 2, 50},
			{"unit_ratk_1", 1, 0, 2, 50},
			
			{"stone frame", 1, 0, 1, 5},
		},

		[DIFF_HARD] = {	
			{"vita claw", 1, 0, 5, 50},
			{"vita peacekeeper", 0, 0, 5, 50},
			{"vita scepter", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"unit_hpsatk_2", 1, 0, 7, 50},
			{"unit_hptatk_2", 1, 0, 7, 50},
			{"unit_hpratk_2", 1, 0, 7, 50},
			{"unit_rainbow_2", 1, 0, 7, 50},

			{"vulture basher", 1, 0, 1, 100},
			{"double driller", 1, 0, 1, 100},
			
			{6000, nil, nil, 1, 5},
		},
		
	},
	
	layout = {
		{0, -3200, 8960, 225, 0, 0, 0, 1},
		{MT_PSO_JUMPTARGET, 9408, 9920, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9568, 3488, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9216, -224, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9184, 2432, 182, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -7456, 8352, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4672, 5280, 0, 0, 0, 0, 2500},
		{17, -6336, 7616, 0, 0, 0, 0, 111},
		{17, -6016, 7808, 0, 0, 0, 0, 111},
		{17, -6432, 6176, 0, 0, 0, 0, 111},
		{17, -6048, 6112, 0, 0, 0, 0, 111},
		{7, -6656, 7104, 0, 3328, 208, 0, 101},
		{29, -5088, 7456, 180, 0, 0, 1, 117},
		{29, -5088, 6816, 180, 0, 0, 1, 117},
		{7, -6752, 7552, 270, 0, 0, 1, 101},
		{7, -6752, 6336, 90, 0, 0, 1, 101},
		{29, -6144, 7616, 270, 0, 0, 2, 117},
		{29, -5376, 7360, 180, 0, 0, 2, 117},
		{7, -6560, 6016, 135, 0, 0, 2, 101},
		{MT_PSO_LASERTOWER, -6432, 5312, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6208, 5312, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -5952, 5312, 2, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -6400, 5408, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -6144, 5824, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -7648, 3712, 10, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7424, 3712, 11, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7232, 3712, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6464, 3712, 20, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6208, 3712, 21, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5920, 3712, 22, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -5088, 6144, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1120, 4544, 1, 0, 0, 0, 2500},
		{MT_PSO_JUMPPAD, -3360, 5312, 0, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2752, 5312, 0, 0, 0, 0, 2513},
		{7, -3488, 5408, 180, 0, 0, 0, 101},
		{37, -2304, 5344, 180, 0, 0, 0, 121},
		{6, -2336, 5536, 180, 0, 0, 0, 100},
		{6, -2336, 5152, 180, 0, 0, 0, 100},
		{17, -3744, 5280, 0, 0, 0, 1, 111},
		{17, -3648, 5632, 0, 0, 0, 0, 111},
		{17, -3488, 4992, 0, 0, 0, 0, 111},
		{7, -3520, 5312, 0, 0, 0, 1, 101},
		{7, -2592, 5344, 180, 0, 0, 1, 101},
		{17, -2496, 5632, 0, 0, 0, 1, 111},
		{17, -2368, 5344, 0, 0, 0, 1, 111},
		{17, -2496, 5056, 0, 0, 0, 1, 111},
		{MT_PSO_LASERTOWER, -2528, 6016, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2304, 6016, 31, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2112, 6016, 32, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -2528, 5920, 270, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -2144, 5664, 1, 1, 0, 1, 2502},
		{MT_PSO_JUMPPAD, -2144, 7456, 1, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1792, 7456, 1, 1, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -2912, 8032, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -544, 6688, 2, 0, 0, 0, 2500},
		{29, -1976, 7872, 180, 0, 0, 0, 117},
		{29, -1976, 7168, 180, 0, 0, 0, 117},
		{7, -2432, 7552, 270, 0, 0, 0, 101},
		{37, -1408, 7488, 180, 0, 0, 1, 121},
		{37, -2432, 7296, 0, 0, 0, 1, 121},
		{17, -1344, 8000, 0, 0, 0, 1, 111},
		{17, -1376, 6848, 0, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, -1184, 7488, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -656, 7616, 60, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -672, 7456, 61, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -688, 7296, 62, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -800, 7648, 180, 0, 0, 1, 2503},
		{MT_PSO_CRATE, -6592, 8032, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6432, 8160, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6272, 7968, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6016, 8064, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4800, 7744, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7424, 4032, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7488, 3840, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 992, 10720, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3296, 7040, 3, 0, 0, 0, 2500},
		{7, 1440, 9152, 270, 25088, 1568, 0, 101},
		{7, 1664, 9152, 270, 25088, 1568, 0, 101},
		{29, 1344, 8096, 90, 0, 0, 1, 117},
		{29, 1696, 8064, 90, 0, 0, 1, 117},
		{29, 2048, 9760, 225, 25088, 1568, 2, 117},
		{29, 2080, 9408, 225, 25120, 1570, 0, 117},
		{7, 1472, 9312, 270, 25088, 1568, 2, 101},
		{7, 1632, 9312, 270, 25088, 1568, 2, 101},
		{MT_PSO_LASERTOWER, 2528, 9808, 70, 25121, 1570, 1, 2504},
		{MT_PSO_LASERTOWER, 2528, 9568, 71, 25120, 1570, 1, 2504},
		{MT_PSO_LASERTOWER, 2528, 9328, 72, 25120, 1570, 1, 2504},
		{MT_PSO_JUMPPAD, 2752, 9568, 10, 25120, 1570, 0, 2512},
		{MT_PSO_JUMPTARGET, 3648, 7456, 10, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 3904, 7456, 20, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 4416, 8960, 20, 26080, 1630, 0, 2513},
		{7, 5056, 9120, 180, 27744, 1734, 0, 101},
		{7, 5056, 8768, 180, 27744, 1734, 0, 101},
		{17, 4192, 9024, 0, 25600, 1600, 1, 111},
		{17, 4192, 8768, 0, 25600, 1600, 1, 111},
		{29, 5824, 9120, 180, 29632, 1852, 2, 117},
		{29, 5824, 8768, 180, 29632, 1852, 2, 117},
		{7, 5280, 9024, 180, 28224, 1764, 2, 101},
		{7, 5280, 8832, 180, 28224, 1764, 2, 101},
		{MT_PSO_LASERTOWER, 5920, 9200, 80, 29857, 1866, 1, 2504},
		{MT_PSO_LASERTOWER, 5920, 8928, 81, 29856, 1866, 1, 2504},
		{MT_PSO_LASERTOWER, 5920, 8656, 82, 29856, 1866, 1, 2504},
		{MT_PSO_UNLOCKCARD, 5536, 8928, 1, 28928, 1808, 1, 2502},
		{MT_PSO_CARDREADER, 5856, 9184, 180, 29600, 1850, 1, 2503},
		{MT_PSO_UNLOCKCARD, 2304, 9568, 1, 25120, 1570, 2, 2502},
		{MT_PSO_CARDREADER, 2464, 9760, 180, 25120, 1570, 1, 2503},
		{MT_PSO_JUMPPAD, 6112, 8928, 90, 30592, 1912, 0, 2512},
		{MT_PSO_JUMPTARGET, 7168, 7424, 90, 0, 0, 0, 2513},
		{MT_PSO_LASERTOWER, 8384, 4768, 90, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8384, 4576, 91, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8384, 4320, 92, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8384, 4032, 93, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 7904, 4448, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7616, 4640, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7616, 4128, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 8032, 4288, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 8192, 4608, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 8192, 4032, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7648, 4320, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 3872, 9376, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6656, 8480, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 8960, 6560, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 11648, 4992, 5, 0, 0, 0, 2500},
		{37, 10656, 6144, 180, 0, 0, 0, 121},
		{37, 10624, 5248, 180, 0, 0, 0, 121},
		{7, 10912, 5632, 180, 0, 0, 0, 101},
		{17, 9888, 5920, 0, 0, 0, 1, 111},
		{17, 9952, 5312, 0, 0, 0, 0, 111},
		{MT_PSO_JUMPPAD, 10176, 5600, 100, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 9664, 5696, 100, 0, 0, 0, 2513},
		{7, 10944, 5856, 180, 0, 0, 1, 101},
		{7, 10848, 5504, 180, 0, 0, 1, 101},
		{MT_PSO_LASERTOWER, 11584, 5888, 180, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11584, 5632, 181, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11584, 5344, 182, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 11424, 5248, 180, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 10784, 5664, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 11360, 5024, 6, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 15264, -2400, 6, 1, 0, 0, 2500},
		{26, 11808, 3200, 90, 0, 0, 0, 115},
		{26, 12128, 3232, 90, 0, 0, 0, 115},
		{7, 11968, 4384, 90, 0, 0, 0, 101},
		{7, 12256, 4384, 90, 0, 0, 0, 101},
		{17, 13088, 3680, 0, 0, 0, 1, 111},
		{17, 13056, 3296, 0, 0, 0, 1, 111},
		{MT_PSO_JUMPPAD, 12448, 3168, 200, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 13216, 3456, 200, 0, 0, 0, 2513},
		{MT_PSO_LASERTOWER, 12416, 3456, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 12352, 3136, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 12416, 2848, 302, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 12352, 3488, 180, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 12096, 3360, 1, 0, 0, 0, 2502},
		{29, 11968, 4192, 270, 0, 0, 1, 117},
		{29, 12288, 4192, 270, 0, 0, 1, 117},
		{26, 13408, 1920, 90, 27520, 1720, 1, 115},
		{7, 13696, 2016, 90, 27520, 1720, 1, 101},
		{MT_PSO_JUMPPAD, 13376, 2144, 300, 27520, 1720, 0, 2512},
		{MT_PSO_JUMPTARGET, 12064, 3488, 300, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 14624, 1792, 301, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 13760, 2144, 301, 27520, 1720, 0, 2512},
		{17, 14496, 2208, 0, 0, 0, 1, 111},
		{17, 14368, 1824, 0, 0, 0, 1, 111},
		{29, 13216, 2784, 315, 0, 0, 2, 117},
		{29, 13408, 2880, 315, 0, 0, 2, 117},
		{29, 14368, 1696, 180, 0, 0, 2, 117},
		{29, 14368, 2176, 180, 0, 0, 2, 117},
		{29, 12576, 928, 45, 37248, 2328, 2, 117},
		{29, 13408, 704, 90, 37248, 2328, 2, 117},
		{29, 14112, 672, 90, 37248, 2328, 2, 117},
		{MT_PSO_LASERTOWER, 13312, 1792, 500, 27521, 1720, 2, 2504},
		{MT_PSO_LASERTOWER, 13568, 1792, 501, 27520, 1720, 2, 2504},
		{MT_PSO_LASERTOWER, 13856, 1792, 502, 27520, 1720, 2, 2504},
		{MT_PSO_UNLOCKCARD, 13600, 2368, 2, 27520, 1720, 1, 2502},
		{MT_PSO_CARDREADER, 13344, 1856, 90, 27520, 1720, 2, 2503},
		{MT_PSO_JUMPPAD, 13568, 1664, 400, 27520, 1720, 0, 2512},
		{MT_PSO_JUMPTARGET, 13536, 480, 400, 37248, 2328, 0, 2513},
		{MT_PSO_JUMPPAD, 13152, 608, 800, 37248, 2328, 0, 2512},
		{MT_PSO_JUMPTARGET, 13600, 2464, 800, 27520, 1720, 0, 2513},
		{29, 13472, 2976, 800, 0, 0, 3, 117},
		{29, 13344, 2816, 270, 0, 0, 3, 117},
		{29, 14368, 1984, 180, 0, 0, 3, 117},
		{29, 14368, 1536, 180, 0, 0, 3, 117},
		{29, 12448, 3296, 315, 0, 0, 3, 117},
		{29, 12416, 2976, 315, 0, 0, 3, 117},
		{MT_PSO_UNLOCKCARD, 13152, 480, 3, 37248, 2328, 3, 2502},
		{MT_PSO_LASERTOWER, 12672, 256, 1000, 37249, 2328, 3, 2504},
		{MT_PSO_LASERTOWER, 12928, 256, 1001, 37248, 2328, 3, 2504},
		{MT_PSO_LASERTOWER, 13216, 256, 1002, 37248, 2328, 3, 2504},
		{MT_PSO_LASERTOWER, 13504, 256, 1003, 37248, 2328, 3, 2504},
		{MT_PSO_JUMPPAD, 13152, 160, 1200, 37248, 2328, 0, 2512},
		{MT_PSO_JUMPTARGET, 13120, -960, 1200, 0, 0, 0, 2513},
		{MT_PSO_CRATE, 12768, -1120, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 12992, -1056, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13184, -1120, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13120, -1312, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 12608, -1664, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 12800, -1312, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13184, -1632, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13408, -1408, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 12864, -1696, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 12768, -1504, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13056, -1440, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13376, -1568, 0, 5, 0, 3, 2505},
		{MT_PSO_CRATE, 13312, -1248, 0, 5, 0, 3, 2505},
		{MT_PSO_TELEPORTER, 13216, -1824, 1, 1, 0, 4, 2510},
		{MT_PSO_JUMPPAD, -2816, 5312, 8000, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3296, 5312, 8000, 0, 0, 0, 2513},
		{MT_PSO_TELEPORTER, -3552, 9152, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -3376, 9056, 0, 1, 0, 0, 2511},
		{MT_PSO_JUMPPAD, 14512, 1904, 3000, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 13584, 2096, 3000, 27520, 1720, 0, 2513},
		{MT_PSO_CARDREADER, 12736, 320, 90, 37249, 2328, 3, 2503},
	},
})

table.insert(PSO.info.quests[mapnum], {
	
	name = "2-3: Oil Pit Terror",
	desc = "Crew had to evacuate the deeper parts of the mines due to an enormous Badnik's attack. This threat must be eliminated.",
	objective = "Subdue the target enemy",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{4, 1}},	-- unlocks 3-1
	
	levels = {
		[DIFF_NORMAL] = 17,
		[DIFF_HARD] = 40,
	},

	grading = {
		{QG_TIME, 70, 0, TICRATE*60*25, TICRATE*60*30},
		{QG_DAMAGETAKEN, 40, 0, 1200, 200},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, 10624, 1088, 90, 0, 0, 0, 1},
		{MT_PSO_JUMPTARGET, 9408, 9920, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9568, 3488, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9216, -224, 182, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 9184, 2432, 182, 0, 0, 0, 2513},
		{MT_PSO_CRATE, 10208, -992, 90, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10336, -1056, 90, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10624, -992, 90, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10912, -928, 90, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 10016, -1184, 1, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10336, -1184, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10656, -1184, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10944, -1184, 4, 0, 0, 0, 2504},
		{MT_PSO_TELEPORT_DEST, 10624, 896, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 10624, 736, 1, 1, 0, 0, 2510},
		{MT_PSO_ROOMANCHOR, 6624, 5120, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 11392, 3680, 0, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 7440, 4800, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 7776, 4832, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 8080, 4864, 12, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 7360, 4736, 270, 1, 0, 1, 2503},
		{7, 8640, 4608, 0, 0, 0, 0, 101},
		{7, 8640, 4224, 0, 0, 0, 0, 101},
		{37, 8480, 4416, 0, 0, 0, 0, 121},
		{29, 9856, 4672, 180, 0, 0, 1, 117},
		{29, 7840, 4256, 0, 0, 0, 1, 117},
		{17, 9888, 4256, 0, 0, 0, 1, 111},
		{17, 7840, 4608, 0, 0, 0, 1, 111},
		{26, 8064, 4416, 0, 0, 0, 2, 115},
		{26, 9728, 4448, 0, 0, 0, 2, 115},
		{MT_PSO_UNLOCKCARD, 7808, 4448, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, 9248, 6176, 20, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9536, 6176, 21, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9536, 5952, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9536, 5632, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9536, 5376, 24, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9344, 5376, 25, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9152, 5376, 26, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 9088, 5984, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9248, 5600, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9376, 5856, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9088, 5696, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9280, 5792, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9344, 6016, 0, 0, 0, 0, 2505},
		{MT_PSO_JUMPPAD, 6688, 7552, 1, 0, 0, 0, 2512},
		{MT_PSO_ROOMANCHOR, 3808, 9376, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6624, 8448, 1, 0, 0, 0, 2500},
		{7, 5184, 9088, 0, 28032, 1752, 0, 101},
		{MT_PSO_JUMPTARGET, 5792, 8928, 1, 29440, 1840, 0, 2513},
		{7, 5184, 8768, 0, 28032, 1752, 0, 101},
		{17, 5792, 9088, 0, 29440, 1840, 1, 111},
		{17, 5792, 8768, 0, 29440, 1840, 1, 111},
		{7, 4480, 8768, 0, 26240, 1640, 1, 101},
		{7, 4480, 9056, 0, 26240, 1640, 1, 101},
		{MT_PSO_UNLOCKCARD, 4576, 8928, 1, 26496, 1656, 1, 2502},
		{MT_PSO_LASERTOWER, 4384, 9200, 30, 25985, 1624, 1, 2504},
		{MT_PSO_LASERTOWER, 4384, 9024, 31, 25984, 1624, 1, 2504},
		{MT_PSO_LASERTOWER, 4384, 8832, 32, 25984, 1624, 1, 2504},
		{MT_PSO_LASERTOWER, 4384, 8656, 33, 25984, 1624, 1, 2504},
		{MT_PSO_CARDREADER, 4448, 9152, 0, 26112, 1632, 1, 2503},
		{MT_PSO_JUMPPAD, 4192, 8896, 5, 25472, 1592, 0, 2512},
		{MT_PSO_JUMPTARGET, 3904, 7456, 5, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 3552, 7456, 6, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1760, 7744, 6, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, 0, 10656, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3104, 6944, 2, 0, 0, 0, 2500},
		{7, 1056, 7872, 0, 0, 0, 0, 101},
		{7, 1152, 7584, 0, 0, 0, 0, 101},
		{29, 1376, 9376, 270, 25088, 1568, 0, 117},
		{29, 1664, 9376, 270, 25088, 1568, 0, 117},
		{MT_PSO_CRATE, 2560, 9760, 270, 25088, 1568, 0, 2505},
		{MT_PSO_CRATE, 2688, 9440, 270, 25088, 1568, 0, 2505},
		{MT_PSO_CRATE, 2880, 9600, 270, 25088, 1568, 0, 2505},
		{MT_PSO_CRATE, 2464, 9472, 270, 25088, 1568, 0, 2505},
		{MT_PSO_CRATE, 2656, 9632, 270, 25088, 1568, 0, 2505},
		{29, 1344, 8128, 90, 0, 0, 1, 117},
		{29, 1632, 8064, 90, 0, 0, 1, 117},
		{7, 1568, 8768, 90, 25088, 1568, 1, 101},
		{MT_PSO_LASERTOWER, 96, 7232, 40, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 96, 7392, 41, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 96, 7552, 42, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 96, 7712, 43, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 192, 7232, 0, 1, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -3040, 8192, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -608, 6656, 3, 0, 0, 0, 2500},
		{17, -1312, 8064, 0, 0, 0, 0, 111},
		{17, -1024, 8000, 0, 0, 0, 0, 111},
		{17, -800, 7808, 0, 0, 0, 0, 111},
		{17, -768, 7168, 0, 0, 0, 0, 111},
		{17, -960, 6976, 0, 0, 0, 0, 111},
		{17, -1376, 6912, 0, 0, 0, 0, 111},
		{7, -1664, 7488, 0, 0, 0, 0, 101},
		{37, -2400, 7680, 0, 0, 0, 1, 121},
		{37, -2432, 7136, 0, 0, 0, 1, 121},
		{17, -1856, 7776, 0, 0, 0, 1, 111},
		{17, -1664, 7904, 0, 0, 0, 1, 111},
		{17, -1440, 7968, 0, 0, 0, 1, 111},
		{17, -1856, 7168, 0, 0, 0, 1, 111},
		{17, -1664, 6976, 0, 0, 0, 1, 111},
		{17, -1408, 6912, 0, 0, 0, 1, 111},
		{MT_PSO_LASERTOWER, -2784, 6848, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2560, 6848, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2336, 6848, 52, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -2784, 6944, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -2560, 7360, 1, 0, 0, 1, 2502},
		{MT_PSO_JUMPPAD, -2208, 7424, 10, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1632, 7424, 10, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2784, 5312, 20, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3456, 5312, 20, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -3360, 5312, 21, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2656, 5312, 21, 0, 0, 0, 2513},
		{7, -2560, 5408, 90, 0, 0, 0, 101},
		{7, -2016, 5344, 90, 0, 0, 0, 101},
		{37, -3808, 5408, 0, 0, 0, 0, 121},
		{17, -3680, 5600, 0, 0, 0, 0, 111},
		{17, -3584, 5120, 0, 0, 0, 0, 111},
		{17, -2624, 5696, 0, 0, 0, 1, 111},
		{17, -2368, 5408, 0, 0, 0, 1, 111},
		{17, -2560, 5088, 0, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, -4448, 5376, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -4672, 5120, 90, 0, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -4720, 4976, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4576, 4976, 101, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4416, 4976, 102, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -4288, 4976, 103, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -6464, 5024, 110, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6272, 5024, 111, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6064, 5024, 112, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5888, 5024, 113, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6464, 3712, 120, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6304, 3712, 121, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -6096, 3712, 122, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5920, 3712, 123, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -6288, 4816, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6288, 4544, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6128, 4928, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6144, 4704, 0, 0, 0, 0, 2505},
		{26, -7456, 4064, 0, 0, 0, 0, 115},
		{26, -7456, 3872, 0, 0, 0, 0, 115},
		{MT_PSO_ROOMANCHOR, -5184, 6144, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1120, 4608, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7744, 4320, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4800, 3680, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8896, 2656, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -7104, 1472, 6, 0, 0, 0, 2500},
		{7, -8480, 1952, 0, 0, 0, 0, 101},
		{7, -8576, 2176, 0, 0, 0, 0, 101},
		{7, -7904, 1792, 90, 0, 0, 0, 101},
		{17, -7328, 2112, 0, 0, 0, 1, 111},
		{17, -8192, 2496, 0, 0, 0, 1, 111},
		{17, -8256, 1664, 0, 0, 0, 1, 111},
		{37, -8384, 2112, 0, 0, 0, 1, 121},
		{37, -7872, 2080, 0, 0, 0, 1, 121},
		{MT_PSO_LASERTOWER, -8192, 2624, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8032, 2624, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7872, 2624, 132, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -8256, 2528, 270, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 512, 7520, 1, 0, 0, 1, 2502},
		{MT_PSO_UNLOCKCARD, -8192, 2272, 1, 0, 0, 1, 2502},
		{7, -9696, 5376, 315, 0, 0, 0, 101},
		{7, -9792, 5056, 315, 0, 0, 0, 101},
		{7, -9344, 5408, 315, 0, 0, 0, 101},
		{17, -10336, 5024, 0, 0, 0, 1, 111},
		{17, -9024, 5504, 0, 0, 0, 1, 111},
		{29, -10048, 5600, 315, 0, 0, 1, 117},
		{29, -9664, 5760, 315, 0, 0, 1, 117},
		{26, -9120, 4800, 135, 0, 0, 2, 115},
		{26, -8864, 5024, 135, 0, 0, 2, 115},
		{17, -9024, 4352, 0, 0, 0, 2, 111},
		{17, -8928, 5312, 0, 0, 0, 2, 111},
		{7, -9568, 5216, 135, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, -9792, 6112, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -9984, 6368, 160, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9760, 6368, 161, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9536, 6368, 162, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -10016, 6272, 270, 1, 0, 1, 2503},
		{MT_PSO_CRATE, -10400, 7648, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -10240, 8000, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8992, 7616, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -9088, 7264, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8832, 7392, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -10464, 7872, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -10816, 6400, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8192, 4128, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -11680, 12864, 8, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -5248, 6752, 8, 0, 0, 0, 2500},
		{29, -10176, 10336, 270, 0, 0, 0, 117},
		{29, -9888, 10592, 270, 0, 0, 0, 117},
		{29, -9472, 10656, 270, 0, 0, 0, 117},
		{29, -9024, 10432, 270, 0, 0, 0, 117},
		{7, -9568, 10336, 270, 0, 0, 1, 101},
		{7, -9312, 10336, 270, 0, 0, 1, 101},
		{7, -9824, 10272, 270, 0, 0, 1, 101},
		{17, -7520, 9824, 0, 0, 0, 1, 111},
		{17, -7744, 9536, 0, 16, 1, 0, 111},
		{17, -10048, 12000, 0, 0, 0, 1, 111},
		{17, -9568, 12192, 0, 0, 0, 1, 111},
		{29, -9920, 8896, 90, 0, 0, 2, 117},
		{29, -9664, 8800, 90, 0, 0, 2, 117},
		{29, -9440, 8928, 90, 0, 0, 2, 117},
		{37, -10304, 10816, 270, 0, 0, 2, 121},
		{37, -9408, 11072, 270, 0, 0, 2, 121},
		{MT_PSO_JUMPPAD, -8480, 9952, 700, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -7584, 9408, 700, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -7648, 9728, 701, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -8544, 10080, 701, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -9792, 11136, 702, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -9888, 12160, 702, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -9888, 12000, 703, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -9792, 11072, 703, 0, 0, 0, 2513},
		{MT_PSO_LASERTOWER, -8352, 10336, 200, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8544, 10336, 201, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8544, 10528, 202, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8544, 10720, 203, 0, 0, 1, 2504},
		{MT_PSO_JUMPPAD, -8384, 10464, 800, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -8288, 11104, 800, 1, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -8256, 11200, 801, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -7456, 11712, 801, 1, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -7264, 11520, 900, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -9568, 10208, 900, 1, 0, 0, 2513},
		{MT_PSO_UNLOCKCARD, -9248, 10528, 1, 1, 0, 2, 2502},
		{MT_PSO_CARDREADER, -8640, 10784, 180, 1, 0, 1, 2503},
		{MT_PSO_CRATE, -7456, 12032, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7744, 11904, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7296, 11808, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7008, 11456, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6944, 12000, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6976, 11744, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -6784, 11552, 180, 0, 0, 0, 2505},
		{MT_PSO_TELEPORTER, -6528, 11840, 50, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -3840, 12672, 50, 0, 0, 0, 2511},
		{MT_PSO_VIPERBOSS, -2944, 12736, 180, 1, 0, 0, 2551},
		{MT_PSO_ROOMANCHOR, -5312, 15168, 9, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -256, 10528, 9, 0, 0, 0, 2500},
		{MT_PSO_JUMPPAD, -3712, 12320, 808, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3072, 11712, 808, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -3296, 11904, 809, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3808, 12448, 809, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2496, 11968, 802, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2048, 12544, 802, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2144, 12448, 803, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2592, 11808, 803, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2080, 13120, 804, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2720, 13664, 804, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2592, 13568, 805, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2016, 12960, 805, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -3328, 13568, 806, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3840, 12960, 806, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -3776, 13056, 807, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -3104, 13632, 807, 0, 0, 0, 2513},
		{MT_PSO_TELEPORTER, -1984, 12768, 1, 1, 0, 1, 2510},
		{MT_PSO_CRATE, -3968, 12960, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3744, 12832, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -4032, 12672, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3744, 12640, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3904, 12512, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3072, 13792, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2944, 13568, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2816, 13664, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3072, 13504, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2976, 13696, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2720, 13792, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2656, 13632, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3200, 13664, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3168, 11872, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3040, 11776, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2976, 11648, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2848, 11872, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2784, 11712, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2976, 11968, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2720, 11904, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2656, 11744, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2560, 11872, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -2624, 12000, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3904, 12800, 180, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -3808, 12416, 180, 1, 0, 0, 2505},
	}
})