local mapnum = 6
table.insert(PSO.info.questmaps, {mapnum, true})	-- map starts off locked
PSO.info.quests[mapnum] = {}

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[mapnum], {
	
	name = "Towards the future [VR]",
	desc = "We've prepared a special training session using VR based on the battle records you have collected. Use this to train and become stronger!",
	objective = "Finish the VR training",
	
	map = mapnum,

	locked = true,		-- initially locked

	drops = {
		[DIFF_NORMAL] = {	
			{"alva pine", 1, 35, 1, 100},
			{"alva claymore", 1, 35, 1, 100},
			{"vita pine", 1, 35, 1, 100},
			{"vita claymore", 1, 35, 1, 100},
			
			{"alva doubliss", 1, 35, 1, 100},
			{"alva doublecutter", 1, 35, 1, 100},	
			{"vita doubliss", 1, 35, 1, 100},
			{"vita doublecutter", 1, 35, 1, 100},
			
			{"alva shooter", 1, 35, 1, 100},
			{"alva burster", 1, 35, 1, 100},				
			{"vita shooter", 1, 35, 1, 100},
			{"vita burster", 1, 35, 1, 100},
				
			{"alva shot", 1, 35, 1, 100},
			{"alva concentrator", 1, 35, 1, 100},	
			{"vita shot", 1, 35, 1, 100},
			{"vita concentrator", 1, 35, 1, 100},
			
			{"alva crest", 1, 35, 1, 100},
			{"alva crescent", 1, 35, 1, 100},
			{"vita crest", 1, 35, 1, 100},
			{"vita crescent", 1, 35, 1, 100},
				
			{"alva claw", 1, 35, 1, 100},
			{"alva cutter", 1, 35, 1, 100},			
			{"vita claw", 1, 35, 1, 100},
			{"vita cutter", 1, 35, 1, 100},
			
			{"alva beamgun", 1, 35, 1, 100},
			{"alva peacekeeper", 1, 35, 1, 100},			
			{"vita beamgun", 1, 35, 1, 100},
			{"vita peacekeeper", 1, 35, 1, 100},
					
			{"alva hammer", 1, 35, 1, 100},
			{"alva scepter", 1, 35, 1, 100},
			{"vita hammer", 1, 35, 1, 100},
			{"vita scepter", 1, 35, 1, 100},
			
			{"unit_hp_2", 1, 35, 2, 50},
			{"unit_pp_2", 1, 35, 2, 50},
			{"unit_satk_2", 1, 35, 2, 50},
			{"unit_tatk_2", 1, 35, 2, 50},
			{"unit_ratk_2", 1, 35, 2, 50},

			{"vulture basher", 36, 55, 1, 150},
			{"double driller", 36, 55, 1, 150},
			{"winginator", 36, 55, 1, 150},
			{"sneg zapper", 36, 55, 1, 150},
			{"command shot", 36, 55, 1, 150},
			{"poss shooter", 36, 55, 1, 150},
			{"ice stabberrod", 36, 55, 1, 150},
			{"asterod", 36, 55, 1, 150},

			{"digrinder", 1, 35, 1, 5},
		},
		
		[DIFF_HARD] = {

			{"vita pine", 36, 55, 1, 60},
			{"vita claymore", 36, 55, 1, 60},
			{"vita doubliss", 36, 55, 1, 60},
			{"vita doublecutter", 36, 55, 1, 60},				
			{"vita shooter", 36, 55, 1, 60},
			{"vita burster", 36, 55, 1, 60},						
			{"vita shot", 36, 55, 1, 60},
			{"vita concentrator", 36, 55, 1, 60},			
			{"vita crest", 36, 55, 1, 60},
			{"vita crescent", 36, 55, 1, 60},			
			{"vita claw", 36, 55, 1, 60},
			{"vita cutter", 36, 55, 1, 60},					
			{"vita beamgun", 36, 55, 1, 60},
			{"vita peacekeeper", 36, 55, 1, 60},						
			{"vita hammer", 36, 55, 1, 60},
			{"vita scepter", 36, 55, 1, 60},
			
			{"unit_ppsatk_2", 36, 55, 3, 20},
			{"unit_pptatk_2", 36, 55, 3, 50},
			{"unit_ppratk_2", 36, 55, 3, 50},
			{"unit_rainbow_2", 36, 55, 3, 50},
			
			{"flow frame", 36, 55, 1, 60},
			{"scape doll", 36, 55, 1, 40},
			
			{"orakl sword", 36, 55, 1, 100},
			{"orakl doublesaber", 36, 55, 1, 100},
			{"orakl soaringblade", 36, 55, 1, 100},
			{"orakl rifle", 36, 55, 1, 100},
			{"orakl shot", 36, 55, 1, 100},
			{"orakl orphan", 36, 55, 1, 100},
			{"orakl rod", 36, 55, 1, 100},
			{"orakl wand", 36, 55, 1, 100},
			
			{"vulture basher", 36, 55, 1, 80},
			{"double driller", 36, 55, 1, 80},
			{"winginator", 36, 55, 1, 80},
			{"sneg zapper", 36, 55, 1, 80},
			{"command shot", 36, 55, 1, 80},
			{"poss shooter", 36, 55, 1, 80},
			{"ice stabberrod", 36, 55, 1, 80},
			{"asterod", 36, 55, 1, 80},
			
			{"digrinder", 36, 55, 6, 50},
		
		},
	},
	
	levels = {
		[DIFF_NORMAL] = 30,
		[DIFF_HARD] = 50,
	},

	grading = {
		{QG_TIME, 200, 0, TICRATE*60*25, TICRATE*60*40},
	},
	
	layout = {},
})