-- Yup, the titlescreen, how wonderful.
freeslot("SPR_TTCI")	-- used for rotations...

local srb_anim_start = 4
local srb_numghosts = 3
local srb_ghostdelay = TICRATE/8

local srb_startscale = FRACUNIT*3
local srb_scalespeed = FRACUNIT/6

local inf_anim_start = 20
local inf_speed = 1

local cutin_start = inf_anim_start
local cutin_wait = 10

local fade_start = cutin_start+20
local fadeout = 2	-- lose 1 fade level every n tics

local patchcache = {}
local num_rotations = 120

local topbars = {}
local num_topbars = 32

local num_soundthings = 8
local soundthings_vals = {}

local arks_rot_speed = ANG1*3/2

local hextypes = 2
local hex_duration = TICRATE*3
local hex_fadespeed = 7

local hexstart
local hexx
local hexy
local hextype

hud.add(function(v)
	
	-- rotation caches
	if not #patchcache or not patchcache[i].valid	-- wtf.
		-- time to lag your game fucker
		for i = 1, num_rotations
			patchcache[i] = v.getSpritePatch(SPR_TTCI, A, 0, (360/num_rotations *i)*ANG1)
			--print("Cached #"..i)
		end
		
		for i = 1, num_topbars
			topbars[i] = v.RandomRange(0, 4)
		end
		
		for i = 1, num_soundthings
			soundthings_vals[i] = 0
		end
	end	
	
	local t = leveltime
	local ttx = 160
	local tty = 80
	
	local col = t < fade_start and 31 or 3
	v.drawFill(0,0,999,999, col|V_SNAPTOLEFT|V_SNAPTOTOP)
	
	if t >= cutin_start
	and t < fade_start
		local newt = t - cutin_start
		local h
		
		if newt < cutin_wait
			h = 2
		else
			h = (newt - cutin_wait)*64
		end
		
		v.drawFill(0, tty - (h/2), 999, h, V_SNAPTOLEFT)
	end
	
	if t >= srb_anim_start
	and t < fade_start
		local newt = t - srb_anim_start
		
		for i = 1, srb_numghosts
			local gt = newt - srb_ghostdelay*(i-1)
			if gt > 0
				local tflag = max(0, 9 - (gt/2))
				local scale = max(FRACUNIT, srb_startscale - srb_scalespeed*gt)
				
				v.drawScaled(ttx<<FRACBITS, tty<<FRACBITS, scale, v.cachePatch("PSTTLA"), tflag<<V_ALPHASHIFT)
			end
		end
	end
	
	--v.draw(20, 20, v.cachePatch("PSTEST"), V_ADD)
	if t >= inf_anim_start
	and t <= inf_anim_start + (inf_speed*10)
		local newt = t - inf_anim_start
		local frame = max(1, newt/inf_speed)
		
		v.draw(ttx, tty, v.cachePatch("INFD"..frame), V_ADD)
	end
	

	if t >= fade_start
		
		v.drawScaled(0, 0, FRACUNIT/2, v.cachePatch("PSTTLBG"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
		
		-- real titlescreen:
		
		-- hexagons
		if not hextype
		or leveltime-hexstart >= hex_duration
			
			hextype = v.RandomRange(1, hextypes)
			hexx = v.RandomRange(0, 260)
			hexy = v.RandomRange(0, 160)
			hexstart = leveltime
		else
			local tflag = 7<<V_ALPHASHIFT
			local timer = leveltime-hexstart
			
			if timer < 3*hex_fadespeed
				tflag = (10 - timer/hex_fadespeed)<<V_ALPHASHIFT
				
			elseif timer > (hex_duration-(3*hex_fadespeed))
				local newt = timer - (hex_duration-(3*hex_fadespeed))
				tflag = (7 + (newt/hex_fadespeed))<<V_ALPHASHIFT
			end
			
			if (tflag >> V_ALPHASHIFT) < 10
				v.drawScaled(hexx<<FRACBITS, hexy<<FRACBITS, FRACUNIT*3/2, v.cachePatch("PSTTLHX"..hextype), tflag)
			end
		end
		
		-- the circle things
		local circlepatch = ((leveltime/2) % num_rotations) +1
		v.drawScaled(ttx<<FRACBITS, tty<<FRACBITS, FRACUNIT*2/3, patchcache[circlepatch], V_ADD|V_60TRANS)

		v.drawScaled(ttx<<FRACBITS, tty<<FRACBITS, FRACUNIT, patchcache[max(1, num_rotations - circlepatch)], V_ADD|V_80TRANS)
		
		-- top thing
		v.drawFill(0, 12, 999, 1, V_SNAPTOTOP|V_SNAPTOLEFT)
		for i = 1, num_topbars
			if topbars[i]
				local xpos = ((i-1)*4 + (leveltime*2)) % (num_topbars*4)
				v.drawFill(xpos, 2, 2, 8, V_SNAPTOTOP|V_SNAPTOLEFT)
			end
		end

		-- bottom thing
		v.drawFill(0, 188, 999, 1, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		local sx = 300
		for i = 1, num_soundthings
			local sw = 8
			local sh = 4
			
			if leveltime%4 == 0
				soundthings_vals[i] = v.RandomRange(1, 5)
			end
			
			local sy = 188-2-sh
			for j = 1, soundthings_vals[i]
				v.drawFill(sx, sy, sw, sh, V_SNAPTOBOTTOM|V_SNAPTORIGHT)
				sy = $-sh-2
			end
			
			sx = $-sw-2
		end
		
		-- ARKS logo
		local scale = cos(leveltime*arks_rot_speed)
		v.drawStretched(ttx<<FRACBITS, tty<<FRACBITS, abs(scale), FRACUNIT, v.cachePatch("PSTTLARK"), V_ADD|(scale < 0 and V_FLIP or 0))
		
		-- the title logo
		v.draw(ttx, tty, v.cachePatch("PSTTL3"))
		v.draw(ttx, tty, v.cachePatch("PSTTL4"))
		v.draw(ttx, tty, v.cachePatch("PSTTL2"))
		v.draw(ttx, tty, v.cachePatch("PSTTL1"))
		v.draw(ttx, tty, v.cachePatch("PSTTL5"))
		
		-- fading overlay

		local newt = t - fade_start
		local fadelevel = 10 - (newt / fadeout)
		
		if fadelevel <= 10
		and fadelevel > 0
			v.fadeScreen(0, fadelevel)
		end
		
		
		-- stuff exclusive to the trailer
		-- leaving it here because there's no reason to delete it, it's a cool tidbit!
		if false
			local str1 = "THE WORLD NEEDS HEROES..."
			local str2 = "DOWNLOAD IN DESCRIPTION!"
		
			local txt_t = t - (fade_start + TICRATE)
			local txt_t2 = txt_t - TICRATE
			
			if txt_t > 0
				v.drawString(160, 140, str1:sub(1, txt_t), V_YELLOWMAP, "center")
			end

			if txt_t2 > 0
				v.drawString(160, 150, str2:sub(1, txt_t2), V_YELLOWMAP, "center")
			end
		end
	end	
	
end, "title")